2009-06-15  Adele Peterson  <adele@apple.com>

        Reviewed by Darin Adler.

        Fix for <rdar://problem/6907228> Pasting a paragraph as quotation leaves you typing in blue instead of black; repros

        * editing/InsertParagraphSeparatorCommand.cpp: (WebCore::InsertParagraphSeparatorCommand::doApply):
        When inserting a newline after the blockquote, we don't want to apply the original style after the insertion.

2009-06-15  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Remove outdated comment.

        * bindings/js/JSDOMWindowBase.h:

2009-06-15  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Bring CustomGetPropertyNames more inline with the other
        extended attributes prefixed with Custom, by making it 
        require a complete implementation.

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::getPropertyNames):
        * bindings/js/JSHistoryCustom.cpp:
        (WebCore::JSHistory::getPropertyNames):
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::JSLocation::getPropertyNames):
        * bindings/js/JSStorageCustom.cpp:
        (WebCore::JSStorage::getPropertyNames):
        * bindings/scripts/CodeGeneratorJS.pm:

2009-06-15  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Remove commented out ondataunavailable attribute event listener which
        has now been removed from HTML 5.

        * page/DOMWindow.idl:

2009-06-15  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Move entire custom implementation of getOwnPropertySlot and put
        for JSDOMWindow into JSDOMWindowCustom, eliminating the bit in
        JSDOMWindowBase.

        * bindings/js/JSDOMWindowBase.cpp:
        * bindings/js/JSDOMWindowBase.h:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::nonCachingStaticFunctionGetter):
        (WebCore::childFrameGetter):
        (WebCore::indexGetter):
        (WebCore::namedItemGetter):
        (WebCore::JSDOMWindow::getOwnPropertySlot):
        (WebCore::JSDOMWindow::put):
        (WebCore::JSDOMWindow::getPropertyAttributes):
        * bindings/js/JSDOMWindowCustom.h:
        * page/DOMWindow.idl:

2009-06-15  Jeremy Orlow (jorlow@chromium.org)

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26356
        Define the functions in V8CustomBindings.h.  "Forgot" this in my
        earlier patch since it wasn't fully upstreamed when I wrote the
        patch.

        * bindings/v8/custom/V8CustomBinding.h:

2009-06-15  Andre Boule  <aboule@apple.com>

        Reviewed by Cameron Zwarich and Dan Bernstein.

        - fix <rdar://problem/6967975> crash with NSString drawAtPoint

        No test possible because this crash can only occur if the client uses
        WebKit text drawing without ever using WebCore text, and DumpRenderTree
        cannot do either.

        * platform/graphics/FontCache.cpp:
        (WebCore::FontCache::purgeInactiveFontData): Null-check
            gFontPlatformDataCache.

2009-06-15  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/6974857>
        
        Define ENABLE_3D_RENDERING when building on 10.6, and move ENABLE_3D_RENDERING
        switch from config.h to wtf/Platform.h.

        * Configurations/FeatureDefines.xcconfig:
        * config.h:

2009-06-15  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Make WebInspector's console evaluation/completion asynchronous.
        This way of evaluation allows serializing calls between 
        InspectorController and its frontend.
        
        https://bugs.webkit.org/show_bug.cgi?id=26350

        * inspector/front-end/Console.js:
        (WebInspector.Console.prototype.completions):
        (WebInspector.Console.prototype._reportCompletions):
        (WebInspector.Console.prototype._evalInInspectedWindow):
        (WebInspector.Console.prototype._enterKeyPressed.printResult):
        (WebInspector.Console.prototype._enterKeyPressed):
        * inspector/front-end/DatabaseQueryView.js:
        * inspector/front-end/ObjectPropertiesSection.js:
        (WebInspector.ObjectPropertyTreeElement.prototype.evaluateExpression):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.evaluateInSelectedCallFrame):
        * inspector/front-end/TextPrompt.js:
        (WebInspector.TextPrompt.prototype.complete):
        (WebInspector.TextPrompt.prototype._completionsReady):

2009-06-15  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim Hatcher.

        Reverted previous change as the old behavior was correct for heavy view.

        * inspector/front-end/BottomUpProfileDataGridTree.js:
        (WebInspector.BottomUpProfileDataGridNode.prototype._populate):

2009-06-15  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/6968125> Profiler 'Call' count is incorrect in Heavy
        view (26418)

        - Removed code that copied call and time data from it's ancestor.

        * inspector/front-end/BottomUpProfileDataGridTree.js:
        (WebInspector.BottomUpProfileDataGridNode.prototype._populate):

2009-06-15  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser  <simon.fraser@apple.com>.

        https://bugs.webkit.org/show_bug.cgi?id=26163

        Added logic to updateTransitions similar to that in updateKeyframeAnimations
        which detects and removes stale transitions.

        Test: transitions/cancel-transition.html

        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimation::updateTransitions):
        * page/animation/ImplicitAnimation.cpp:
        (WebCore::ImplicitAnimation::ImplicitAnimation):
        * page/animation/ImplicitAnimation.h:
        (WebCore::ImplicitAnimation::active):
        (WebCore::ImplicitAnimation::setActive):

2009-06-15  Dan Bernstein  <mitz@apple.com>

        Reviewed by Tim Hatcher.

        - allow the source code font in the Web Inspector to be customized

        * css/view-source.css: Use the default monospace font family and size
            for source code.
        * inspector/front-end/inspector.css: Use the default monospace font
            family and size for console I/O.

2009-06-15  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by and done with Tor Arne Vestbø.

        Fix initialization of uninitialized members in FontFallbackListQt, leading
        to random crashes when rendering text.

        * platform/graphics/qt/FontFallbackListQt.cpp:
        (WebCore::FontFallbackList::FontFallbackList):
        (WebCore::FontFallbackList::invalidate):

2009-06-15  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=25895
        [Gtk] Segfault when deleting the last/only character in an entry if a11y is enabled

        Use computeOffsetInContainerNode instead of the inline
        offsetInContainerNode to return the caret offset, since the former
        can handle all types of anchoring. Otherwise we'll hit an ASSERT
        in some situations in debug builds, and crash.

        * editing/gtk/SelectionControllerGtk.cpp:
        (WebCore::SelectionController::notifyAccessibilityForSelectionChange):

2009-06-15  Joe Ligman  <joseph.ligman@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Fix build break
        Rename JSONObject to InspectorJSONObject

        https://bugs.webkit.org/show_bug.cgi?id=26340

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * inspector/ConsoleMessage.cpp:
        (WebCore::ConsoleMessage::addToConsole):
        * inspector/InspectorDOMStorageResource.cpp:
        (WebCore::InspectorDOMStorageResource::bind):
        * inspector/InspectorDatabaseResource.cpp:
        (WebCore::InspectorDatabaseResource::bind):
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::newInspectorJSONObject):
        (WebCore::InspectorFrontend::addMessageToConsole):
        (WebCore::InspectorFrontend::addResource):
        (WebCore::InspectorFrontend::updateResource):
        (WebCore::InspectorFrontend::addDatabase):
        (WebCore::InspectorFrontend::addDOMStorage):
        * inspector/InspectorFrontend.h:
        * inspector/InspectorJSONObject.cpp: Copied from WebCore/inspector/JSONObject.cpp.
        (WebCore::InspectorJSONObject::InspectorJSONObject):
        (WebCore::InspectorJSONObject::set):
        (WebCore::InspectorJSONObject::scriptObject):
        (WebCore::InspectorJSONObject::createNew):
        * inspector/InspectorJSONObject.h: Copied from WebCore/inspector/JSONObject.h.
        * inspector/InspectorResource.cpp:
        (WebCore::populateHeadersObject):
        (WebCore::InspectorResource::createScriptObject):
        (WebCore::InspectorResource::updateScriptObject):
        * inspector/JSONObject.cpp: Removed.
        * inspector/JSONObject.h: Removed.

2009-06-12  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        Refactor handling of options in the build-webkit script
        
        Options are now defined in one place, and then reused when creating
        the usage help text, the arguments to GetOptions(), and when passing
        the options on to the underlying port-dependent build systems.
        
        This allows the Qt port to read the defaults for the options from the
        pro file (dynamically), and to pass the options on to qmake at build.

        * WebCore.pro:

2009-06-14  chris fleizach  <cfleizach@apple.com>

        Reviewed by Darin Adler.

        Bug 26399: REGRESSION: java applet accessibility broken
        https://bugs.webkit.org/show_bug.cgi?id=26399
 
        Accessibility could not access the elements in a java applet 
        when going down the AX hierarchy.

        Test: DRT does not allow java applets so add a manual test:
              manual-tests/accessibility/java-applet.html

        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::doAccessibilityHitTest):
        * accessibility/mac/AccessibilityObjectMac.mm:
        (WebCore::AccessibilityObject::accessibilityIgnoreAttachment):
        * accessibility/mac/AccessibilityObjectWrapper.mm:
        (-[AccessibilityObjectWrapper attachmentView]):
        * manual-tests/accessibility: Added.
        * manual-tests/accessibility/java-applet.html: Added.
        * manual-tests/accessibility/resources: Added.
        * manual-tests/accessibility/resources/AppletTest.class: Added.
        * manual-tests/accessibility/resources/AppletTest.java: Added.
        (AppletTest):
        (AppletTest.init):

2009-06-14  Sam Weinig  <sam@webkit.org>

        Reviewed by Cameron Zwarich.

        Rename the CustomGetOwnPropertySlot and CustomPutFunction extended attributes
        to DelegatingGetOwnPropertySlot and DelegatingPutFunction to more clearly describe
        their functionality (customGetOwnPropertySlot and customPut member functions have
        been renamed getOwnPropertySlotDelegate and putDelegate).  CustomGetOwnPropertySlot 
        and CustomPutFunction have been repurposed to mean a complete custom implementation
        of the function which is inline with other extended attributes prefixed with Custom.

        * bindings/js/JSCSSStyleDeclarationCustom.cpp:
        (WebCore::JSCSSStyleDeclaration::putDelegate):
        * bindings/js/JSDOMWindowCustom.h:
        (WebCore::JSDOMWindow::getOwnPropertySlotDelegate):
        (WebCore::JSDOMWindow::putDelegate):
        * bindings/js/JSHTMLAppletElementCustom.cpp:
        (WebCore::JSHTMLAppletElement::getOwnPropertySlotDelegate):
        (WebCore::JSHTMLAppletElement::putDelegate):
        * bindings/js/JSHTMLEmbedElementCustom.cpp:
        (WebCore::JSHTMLEmbedElement::getOwnPropertySlotDelegate):
        (WebCore::JSHTMLEmbedElement::putDelegate):
        * bindings/js/JSHTMLObjectElementCustom.cpp:
        (WebCore::JSHTMLObjectElement::getOwnPropertySlotDelegate):
        (WebCore::JSHTMLObjectElement::putDelegate):
        * bindings/js/JSHistoryCustom.cpp:
        (WebCore::JSHistory::getOwnPropertySlotDelegate):
        (WebCore::JSHistory::putDelegate):
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::JSLocation::getOwnPropertySlotDelegate):
        (WebCore::JSLocation::putDelegate):
        (WebCore::JSLocationPrototype::putDelegate):
        * bindings/js/JSStorageCustom.cpp:
        (WebCore::JSStorage::putDelegate):
        * bindings/js/JSWorkerContextCustom.cpp:
        (WebCore::JSWorkerContext::getOwnPropertySlotDelegate):
        * bindings/scripts/CodeGeneratorJS.pm:
        * css/CSSStyleDeclaration.idl:
        * html/HTMLAppletElement.idl:
        * html/HTMLEmbedElement.idl:
        * html/HTMLObjectElement.idl:
        * page/DOMWindow.idl:
        * page/History.idl:
        * page/Location.idl:
        * storage/Storage.idl:
        * workers/WorkerContext.idl:

2009-06-14  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix https://bugs.webkit.org/show_bug.cgi?id=26395
          <rdar://problem/6971333> REGRESSION (r40813-r40884): No caret after
          going back/forward to page with focused text field

        No test, since the back/forward cache is disabled in DumpRenderTree

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::open): Added a call to CachedPage::restore(),
        which was removed in r40870.

2009-06-14  Darin Adler  <darin@apple.com>

        * editing/TextIterator.cpp:
        (WebCore::BitStack::push): Use named constant instead of hardcoded numbers.
        (WebCore::BitStack::top): Ditto.

2009-06-14  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Bug 26364: Search can find text that's hidden by overflow:hidden
        https://bugs.webkit.org/show_bug.cgi?id=26364
        <rdar://problem/6952081>

        Test: fast/text/find-hidden-text.html

        * editing/TextIterator.cpp:
        (WebCore::BitStack::BitStack): Added.
        (WebCore::BitStack::push): Added.
        (WebCore::BitStack::pop): Added.
        (WebCore::BitStack::top): Added.
        (WebCore::BitStack::size): Added.
        (WebCore::parentOrShadowParent): Added. Helper function for walking up
        the parent node chain, crossing shadow tree boundaries.
        (WebCore::depthCrossingShadowBoundaries): Added for use in assertions.
        Counts the depth of a node using the parentOrShadowParent function.
        (WebCore::fullyClipsContents): Added. Returns true for an element that
        fully clips its contents, currently defined as a box that has zero width
        or height and hides overflow. We can add other cases here later.
        (WebCore::ignoresContainerClip): Added. Returns true for an element that
        ignores its container clip, currently defined as an element with absolute
        or fixed positioning.
        (WebCore::pushFullyClippedState): Added. Pushes a bit on the stack indicating
        if the node in question fully clips its contents.
        (WebCore::setUpFullyClippedStack): Added. Pushes a bit for each ancestor of
        a node. Used when creating an iterator.
        (WebCore::TextIterator::TextIterator): Removed code to initialize
        m_inShadowContent. Call setUpFullyClippedStack.
        (WebCore::TextIterator::advance): Use parentOrShadowParent. Call pop when moving
        up to a parent node, and also one extra time when moving to a sibling node.
        Call pushFullyClippedState when moving to a child node, or when moving to a
        sibling node after the aforementioned call to pop.
        (WebCore::TextIterator::handleTextNode): Return early if the node is fully clipped.
        (WebCore::TextIterator::handleReplacedElement): Ditto.
        (WebCore::SimplifiedBackwardsTextIterator::SimplifiedBackwardsTextIterator):
        Call setUpFullyClippedStack.
        (WebCore::SimplifiedBackwardsTextIterator::advance): Same changes as
        TextIterator::advance above.

        * editing/TextIterator.h: Added BitStack class and added m_fullyClippedStack to both
        TextIterator and SimplifiedBackwardsTextIterator. Removed unneeded m_inShadowContent.

2009-06-14  David Hyatt  <hyatt@apple.com>

        Reviewed by Simon Fraser.

        https://bugs.webkit.org/show_bug.cgi?id=26362

        Back out Simon's fix and replace it with a better one that doesn't needlessly destroy RenderObjects.
        Use NoInherit rather than Detach for child index changes, and don't worry about other pseudo-class state
        changes, since they were handled already with setNeedsStyleRecalcs on the affected objects themselves.

        * dom/Element.cpp:
        (WebCore::Element::recalcStyle):
        * dom/Node.cpp:
        (WebCore::Node::diff):
        * rendering/style/RenderStyle.h:
        (WebCore::InheritedFlags::setChildIndex):

2009-06-14  David Hyatt  <hyatt@apple.com>

        Reviewed by Dan Bernstein.

        Move all of the mutable member variables from Font into the refcounted FontFallbackList.  This makes
        copying of Fonts more efficient and also effectively makes all of the mutations of a Font object happen
        inside the FontFallbackList.

        * WebCore.base.exp:
        * platform/graphics/Font.cpp:
        (WebCore::Font::Font):
        (WebCore::Font::operator=):
        (WebCore::Font::primaryFont):
        (WebCore::Font::update):
        * platform/graphics/Font.h:
        (WebCore::Font::setWordSpacing):
        (WebCore::Font::setLetterSpacing):
        * platform/graphics/FontFallbackList.cpp:
        (WebCore::FontFallbackList::FontFallbackList):
        (WebCore::FontFallbackList::invalidate):
        (WebCore::FontFallbackList::determinePitch):
        * platform/graphics/FontFallbackList.h:
        (WebCore::FontFallbackList::primarySimpleFontData):
        (WebCore::FontFallbackList::primaryFontData):
        * platform/graphics/FontFastPath.cpp:
        (WebCore::Font::glyphDataForCharacter):

2009-06-14  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler
        
        https://bugs.webkit.org/show_bug.cgi?id=26362
        
        Fix an issue noted on quirksmode.com where dynamically adding siblings does not
        update :nth-child style correctly.

        Test: fast/css/nth-child-dynamic.html

        * dom/Node.h:
        Change diff() to take const RenderStyle*
        * dom/Node.cpp:
        (WebCore::Node::diff):
        When comparing styles to decide whether to detach and reattach, we
        need to look at whether the pseudoclass-related data in the style
        changed (since RenderStyle::diff doesn't check this).
        
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::getCachedPseudoStyle):
        (WebCore::RenderStyle::inheritedNotEqual):
        Make these methods const.
        * rendering/style/RenderStyle.h:
        (WebCore::InheritedFlags::styleType):
        (WebCore::InheritedFlags::pseudoClassStateEquivalent):
        Make methods const.
        Add new method that compares the pseudoclass-related members.

2009-06-13  Peter Kasting  <pkasting@google.com>

        Reviewed by Kevin Ollivier.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part eleven
        Write a wx implementation so the wx port can compile.  For now this is
        mostly a copy of the Cairo port, but in the future it can be changed to
        use a wxBitmap as the storage type everywhere (just as Cairo can
        probably be changed).
        
        Also ASSERT for any other ports who call getAddr() (I don't think there
        are any, and besides, they probably won't link, but this doesn't hurt).
        
        Also fixes a dumb Cairo build bustage typo introduced in part ten.

        * platform/graphics/wx/ImageSourceWx.cpp:
        (WebCore::ImageSource::createFrameAtIndex):
        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::getAddr):
        * platform/image-decoders/cairo/ImageDecoderCairo.cpp:
        (WebCore::RGBA32Buffer::setStatus):
        * platform/image-decoders/wx: Added.
        * platform/image-decoders/wx/ImageDecoderWx.cpp: Added.
        (WebCore::RGBA32Buffer::RGBA32Buffer):
        (WebCore::RGBA32Buffer::clear):
        (WebCore::RGBA32Buffer::zeroFill):
        (WebCore::RGBA32Buffer::copyBitmapData):
        (WebCore::RGBA32Buffer::setSize):
        (WebCore::RGBA32Buffer::asNewNativeImage):
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::RGBA32Buffer::setStatus):
        (WebCore::RGBA32Buffer::operator=):
        (WebCore::RGBA32Buffer::width):
        (WebCore::RGBA32Buffer::height):
        * webcore-wx.bkl:

2009-06-13  Stephen White  <senorblanco@chromium.org>

        Reviewed by Dimitri Glazkov.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26320

        Some minor code cleanup for chromium/skia port.  Removed #ifdef's
        around skia API changes, since the new version seems solid and we
        don't need to go back.  Added some comments to
        TransparencyWin.h, as requested by Brett in
        https://bugs.webkit.org/show_bug.cgi?id=24584.

        * platform/graphics/chromium/FontCacheLinux.cpp:
        (WebCore::FontCache::createFontPlatformData):
        * platform/graphics/chromium/TransparencyWin.h:
        * platform/graphics/skia/PathSkia.cpp:
        (WebCore::Path::boundingRect):
        (WebCore::boundingBoxForCurrentStroke):
        * platform/graphics/skia/SkiaUtils.cpp:
        (WebCore::SkPathContainsPoint):

2009-06-13  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Fisher.

        https://bugs.webkit.org/show_bug.cgi?id=24492

        Moved registerURLSchemeAsLocal and registerURLSchemeAsNoAccess from
        FrameLoader to SecurityOrigin.

        * WebCore.base.exp:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadFrameRequest):
        (WebCore::FrameLoader::canLoad):
        * loader/FrameLoader.h:
        * page/SecurityOrigin.cpp:
        (WebCore::localSchemes):
        (WebCore::noAccessSchemes):
        (WebCore::SecurityOrigin::SecurityOrigin):
        (WebCore::SecurityOrigin::isLocal):
        (WebCore::SecurityOrigin::registerURLSchemeAsLocal):
        (WebCore::SecurityOrigin::shouldTreatURLAsLocal):
        (WebCore::SecurityOrigin::shouldTreatURLSchemeAsLocal):
        (WebCore::SecurityOrigin::registerURLSchemeAsNoAccess):
        (WebCore::SecurityOrigin::shouldTreatURLSchemeAsNoAccess):
        * page/SecurityOrigin.h:

2009-06-13  Ben Murdoch  <benm@google.com>

        Reviewed by David Kilzer.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26189

        This patch changes the way PageGroups create their localStorage
        objects. Rather than creating a local storage object for the page group
        when a page is added to the group, the local storage object is now
        created lazily when the local storage object is requested by the
        DOMWindow.

        * page/PageGroup.cpp:
        (WebCore::PageGroup::closeLocalStorage): Before attempting to close a local storage object for a page group, ensure one has been created.
        (WebCore::PageGroup::addPage): Do not automatically try to create a local storage object when a page is added to the group.
        (WebCore::PageGroup::localStorage): Create a local storage object if one does not exist and return it.
        * page/PageGroup.h: Add private hasLocalStorage method to PageGroup.


2009-06-13  Ben Murdoch  <benm@google.com>

        Reviewed by Eric Seidel.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26189

        Add ENABLE(DOM_STORAGE) guards to the dom storage source files.

        * storage/LocalStorage.cpp: Add ENABLE(DOM_STORAGE) guards to the file.
        * storage/LocalStorage.h: Ditto
        * storage/LocalStorageArea.cpp: Ditto
        * storage/LocalStorageArea.h: Ditto
        * storage/LocalStorageTask.cpp: Ditto
        * storage/LocalStorageTask.h: Ditto
        * storage/LocalStorageThread.cpp: Ditto
        * storage/LocalStorageThread.h: Ditto
        * storage/SessionStorage.cpp: Ditto
        * storage/SessionStorage.h: Ditto
        * storage/SessionStorageArea.cpp: Ditto
        * storage/SessionStorageArea.h: Ditto
        * storage/Storage.cpp: Ditto
        * storage/Storage.h: Ditto
        * storage/StorageArea.cpp: Ditto
        * storage/StorageArea.h: Ditto
        * storage/StorageEvent.cpp: Ditto
        * storage/StorageEvent.h: Ditto
        * storage/StorageMap.cpp: Ditto
        * storage/StorageMap.h: Ditto
        * storage/StorageEvent.idl: Add Conditional=DOM_STORAGE attribute.
        * storage/Storage.idl: Ditto

2009-06-13  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part ten
        Make Skia use the root directory ImageDecoder.h and factor out most
        Skia-specific bits into skia/ImageDecoderSkia.cpp.  Also fix a pair of
        style violations in ImageDecoderCairo.cpp.  This is the last patch for
        this bug, everything beyond this is an enhancement rather than
        unforking.

        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::getAddr):
        * platform/image-decoders/cairo/ImageDecoderCairo.cpp:
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::setStatus):
        * platform/image-decoders/skia/ImageDecoder.h: Removed.
        * platform/image-decoders/skia/ImageDecoderSkia.cpp: Added.
        (WebCore::RGBA32Buffer::RGBA32Buffer):
        (WebCore::RGBA32Buffer::clear):
        (WebCore::RGBA32Buffer::zeroFill):
        (WebCore::RGBA32Buffer::copyBitmapData):
        (WebCore::RGBA32Buffer::setSize):
        (WebCore::RGBA32Buffer::asNewNativeImage):
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::RGBA32Buffer::setStatus):
        (WebCore::RGBA32Buffer::operator=):
        (WebCore::RGBA32Buffer::width):
        (WebCore::RGBA32Buffer::height):

2009-06-13  Victor Wang <victorw@chromium.org>

        Reviewed by Eric Seidel.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26333
        Alert during a dragenter event handler will crash the renderer
        
        This crash is casued by calling NULL pointer m_documentUnderMouse in
        DragController::tryDocumentDrag()

        tryDHTMLDrag fires dragenter event. The event listener that listens
        to this event may create a nested message loop (open a modal dialog),
        which could process dragleave event and reset m_documentUnderMouse in
        dragExited.

        Fix the crash by checking m_documentUnderMouse after tryDHTMLDrag and
        do not continue if the pointer has been set to NULL.

        Test: DRT does not show alerts so add a manual test:
              manual-tests/drag-enter-alert.html

        * manual-tests/drag-enter-alert.html: Added.
        * manual-tests/resources/drag-image.png: Added.
        * page/DragController.cpp:
        (WebCore::DragController::tryDocumentDrag):

2009-06-13  Nate Chapin  <japhet@google.com>

        Reviewed by Dimitri Glazkov.  Landed by Adam Barth.

        Moved V8 Bindings for V8CustomXPathNSResolver to svn.webkit.org.

        https://bugs.webkit.org/show_bug.cgi?id=26227

        * bindings/v8/custom/V8CustomXPathNSResolver.cpp: Added.
        (WebCore::V8CustomXPathNSResolver::V8CustomXPathNSResolver): Moved from src.chromium.org.
        (WebCore::V8CustomXPathNSResolver::~V8CustomXPathNSResolver): Moved from src.chromium.org.
        (WebCore::V8CustomXPathNSResolver::lookupNamespaceURI): Moved from src.chromium.org.
        * bindings/v8/custom/V8CustomXPathNSResolver.h: Added.
        * bindings/v8/custom/V8DocumentCustom.cpp: Updated includes.
        (WebCore::CALLBACK_FUNC_DECL): Updated class name.

2009-06-13  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Mark Rowe.  Landed by Adam Barth.

        Remove obsolete declarations for old Symbian port
        https://bugs.webkit.org/show_bug.cgi?id=26339

        * platform/graphics/FloatPoint.h: Remove declarations for native SYMBIAN adaptation.
        * platform/graphics/FloatRect.h: Ditto.
        * platform/graphics/IntPoint.h: Ditto.
        * platform/graphics/IntRect.h: Ditto.
        * platform/graphics/IntSize.h: Ditto.

2009-06-13  Dirk Schulze  <krit@webkit.org>

        Reviewed by Eric Seidel.

        Added subRegion calculation to SVG filter. Every filter effect is
        clipped to the filter region (according to the spec). This makes
        ImageBuffers for filter effects smaller and we just need to take
        care about big filter regions.
        SVGFEImage needed a correction, to avoid an ASSERT. The two filter
        effects feOffset and feFlood help to test the new subRegion code.

        Tests: svg/filters/subRegion-one-effect.svg
               svg/filters/subRegion-two-effects.svg

        * platform/graphics/filters/FEBlend.h:
        (WebCore::FEBlend::uniteChildEffectSubregions):
        * platform/graphics/filters/FEColorMatrix.h:
        (WebCore::FEColorMatrix::uniteChildEffectSubregions):
        * platform/graphics/filters/FEComponentTransfer.h:
        (WebCore::FEComponentTransfer::uniteChildEffectSubregions):
        * platform/graphics/filters/FEComposite.h:
        (WebCore::FEComposite::uniteChildEffectSubregions):
        * platform/graphics/filters/Filter.h:
        (WebCore::Filter::setSourceImage):
        (WebCore::Filter::sourceImage):
        * platform/graphics/filters/FilterEffect.cpp:
        (WebCore::FilterEffect::FilterEffect):
        (WebCore::FilterEffect::calculateUnionOfChildEffectSubregions):
        (WebCore::FilterEffect::calculateEffectRect):
        * platform/graphics/filters/FilterEffect.h:
        (WebCore::FilterEffect::setUnionOfChildEffectSubregions):
        (WebCore::FilterEffect::unionOfChildEffectSubregions):
        (WebCore::FilterEffect::hasX):
        (WebCore::FilterEffect::setHasX):
        (WebCore::FilterEffect::hasY):
        (WebCore::FilterEffect::setHasY):
        (WebCore::FilterEffect::hasWidth):
        (WebCore::FilterEffect::setHasWidth):
        (WebCore::FilterEffect::hasHeight):
        (WebCore::FilterEffect::setHasHeight):
        (WebCore::FilterEffect::setEffectBuffer):
        (WebCore::FilterEffect::uniteChildEffectSubregions):
        * platform/graphics/filters/SourceAlpha.h:
        (WebCore::SourceAlpha::calculateEffectRect):
        * platform/graphics/filters/SourceGraphic.cpp:
        (WebCore::SourceGraphic::calculateEffectRect):
        (WebCore::SourceGraphic::apply):
        * platform/graphics/filters/SourceGraphic.h:
        * rendering/SVGRenderSupport.cpp:
        (WebCore::SVGRenderBase::prepareToRenderSVGContent):
        (WebCore::SVGRenderBase::finishRenderSVGContent):
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::setStandardAttributes):
        * svg/graphics/SVGResourceFilter.cpp:
        (WebCore::SVGResourceFilter::prepareFilter):
        (WebCore::SVGResourceFilter::applyFilter):
        * svg/graphics/SVGResourceFilter.h:
        * svg/graphics/filters/SVGFEConvolveMatrix.h:
        (WebCore::FEConvolveMatrix::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFEDiffuseLighting.h:
        (WebCore::FEDiffuseLighting::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFEDisplacementMap.h:
        (WebCore::FEDisplacementMap::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFEFlood.cpp:
        (WebCore::FEFlood::apply):
        * svg/graphics/filters/SVGFEGaussianBlur.h:
        (WebCore::FEGaussianBlur::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFEImage.cpp:
        (WebCore::FEImage::FEImage):
        * svg/graphics/filters/SVGFEImage.h:
        * svg/graphics/filters/SVGFEMerge.cpp:
        (WebCore::FEMerge::uniteEffectRect):
        * svg/graphics/filters/SVGFEMerge.h:
        * svg/graphics/filters/SVGFEMorphology.h:
        (WebCore::FEMorphology::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFEOffset.cpp:
        (WebCore::FEOffset::apply):
        * svg/graphics/filters/SVGFEOffset.h:
        (WebCore::FEOffset::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFESpecularLighting.h:
        (WebCore::FESpecularLighting::uniteEffectRect):
        * svg/graphics/filters/SVGFETile.cpp:
        (WebCore::FETile::uniteChildEffectSubregions):
        * svg/graphics/filters/SVGFETile.h:
        * svg/graphics/filters/SVGFilter.cpp:
        (WebCore::SVGFilter::calculateEffectSubRegion):
        * svg/graphics/filters/SVGFilter.h:
        (WebCore::SVGFilter::effectBoundingBoxMode):
        (WebCore::SVGFilter::filterRegion):
        (WebCore::SVGFilter::sourceImageRect):

2009-06-13  Peter Kasting  <pkasting@google.com>

        Bustage: Fix broken GIFs on Cairo due to subtle typo.  Fix a warning.

        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::copyRowNTimes):
        * platform/image-decoders/bmp/BMPImageReader.cpp:
        (WebCore::BMPImageReader::processBitmasks):

2009-06-13  Peter Kasting  <pkasting@google.com>

        GTK bustage fix.  "inline" is handled differently by different compilers.

        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::getAddr):
        * platform/image-decoders/cairo/ImageDecoderCairo.cpp:

2009-06-13  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part nine
        Factor Cairo-specific implementation out of ImageDecoder.h into
        ImageDecoderCairo.cpp.  Add some comments to functions declared
        in ImageDecoder.h.

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * platform/image-decoders/ImageDecoder.h:
        * platform/image-decoders/cairo: Added.
        * platform/image-decoders/cairo/ImageDecoderCairo.cpp: Added.
        (WebCore::RGBA32Buffer::RGBA32Buffer):
        (WebCore::RGBA32Buffer::clear):
        (WebCore::RGBA32Buffer::zeroFill):
        (WebCore::RGBA32Buffer::copyBitmapData):
        (WebCore::RGBA32Buffer::setSize):
        (WebCore::RGBA32Buffer::asNewNativeImage):
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::RGBA32Buffer::operator=):
        (WebCore::RGBA32Buffer::width):
        (WebCore::RGBA32Buffer::height):
        (WebCore::RGBA32Buffer::getAddr):

2009-06-13  David Hyatt  <hyatt@apple.com>

        Reviewed by Darin Adler.

        Cleanup of the new MidpointState class.  Turn it into a struct instead.  Fix a mistaken
        assertion removal and some unintentional whitespace changes.

        * platform/text/BidiResolver.h:
        (WebCore::MidpointState::reset):
        * rendering/RenderBlock.h:
        * rendering/bidi.cpp:
        (WebCore::BidiRun::operator delete):
        (WebCore::chopMidpointsAt):
        (WebCore::checkMidpoints):
        (WebCore::addMidpoint):
        (WebCore::appendRunsForObject):
        (WebCore::RenderBlock::findNextLineBreak):

2009-06-12  David Hyatt  <hyatt@apple.com>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=26367

        Remove the global variables in bidi.cpp.  Make a new struct, MidpointState, that holds all of the
        midpoint information.  Add the remaining global variables as arguments passed down through functions
        as needed.

        * platform/text/BidiResolver.h:
        (WebCore::MidpointState::MidpointState):
        (WebCore::MidpointState::reset):
        (WebCore::BidiResolver::midpointState):
        * rendering/RenderBlock.h:
        * rendering/bidi.cpp:
        (WebCore::BidiRun::operator delete):
        (WebCore::chopMidpointsAt):
        (WebCore::checkMidpoints):
        (WebCore::addMidpoint):
        (WebCore::appendRunsForObject):
        (WebCore::RenderBlock::bidiReorderLine):
        (WebCore::RenderBlock::layoutInlineChildren):
        (WebCore::RenderBlock::determineStartPosition):
        (WebCore::skipNonBreakingSpace):
        (WebCore::shouldCollapseWhiteSpace):
        (WebCore::requiresLineBox):
        (WebCore::RenderBlock::generatesLineBoxesForInlineChild):
        (WebCore::RenderBlock::skipTrailingWhitespace):
        (WebCore::RenderBlock::skipLeadingWhitespace):
        (WebCore::shouldSkipWhitespaceAfterStartObject):
        (WebCore::RenderBlock::findNextLineBreak):

2009-06-12  Holger Hans Peter Freyther  <zecke@selfish.org>

        Build fix for Qt. After recent ImageDeocder.h changes. I want
        the original change to be backed out as the whole Skia merging
        is going in the wrong direction. The discussion will happen in
        the bugtracker.

        https://bugs.webkit.org/show_bug.cgi?id=25709.

        * platform/image-decoders/ImageDecoder.h:

2009-06-12  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix: include cstdio so we can use sscanf

        Gtk/Win Cairo build fix: use isASCIISpace instead of isspace
        Suggested by Brent Fulgham

        * platform/image-decoders/xbm/XBMImageDecoder.cpp:
        (WebCore::XBMImageDecoder::decodeDatum):

2009-06-12  Peter Kasting  <pkasting@google.com>

        Yet another Skia bustage fix.

        * platform/image-decoders/skia/ImageDecoder.h:
        (WebCore::RGBA32Buffer::setSize): Avoid symbol name clash.  The better fix is to take an IntSize(); I'll do that later.

2009-06-12  Peter Kasting  <pkasting@google.com>

        Fix remaining Cairo build bustage from
        https://bugs.webkit.org/show_bug.cgi?id=25709 changes.  Use
        Vector<char> in place of std::string.

        * platform/image-decoders/xbm/XBMImageDecoder.cpp:
        (WebCore::XBMImageDecoder::setData):
        (WebCore::XBMImageDecoder::decodeHeader):
        (WebCore::XBMImageDecoder::decodeDatum):
        * platform/image-decoders/xbm/XBMImageDecoder.h:

2009-06-12  David Levin  <levin@chromium.org>

        Reviewed by Darin Adler.

        UString shouldn't create sharedBuffer for SmallStrings.
        https://bugs.webkit.org/show_bug.cgi?id=26347

        Change the call to use the method UString::Rep::sharedBuffer due
        to changes in UString.

        No noticable change in behavior, so no test.

        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::create):

2009-06-12  Peter Kasting  <pkasting@google.com>

        Fix Chromium and some of Cairo build bustage, fallout from
        https://bugs.webkit.org/show_bug.cgi?id=25709 changes.

        * WebCore.vcproj/WebCore.vcproj: Add missing XBM decoder files.
        * platform/image-decoders/skia/ImageDecoder.h:
        (WebCore::RGBA32Buffer::copyRowNTimes): Fix typo that broke Skia GIF decoding.

2009-06-12  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        https://bugs.webkit.org/show_bug.cgi?id=26095
        
        Fix crash when a renderer for an anonymous node is composited
        by null-checking renderer()->node().
        
        Test: compositing/generated-content.html

        * rendering/RenderLayerBacking.cpp:
        (WebCore::RenderLayerBacking::createGraphicsLayer):
        (WebCore::RenderLayerBacking::rendererHasBackground):
        (WebCore::RenderLayerBacking::rendererBackgroundColor):
        (WebCore::RenderLayerBacking::isSimpleContainerCompositingLayer):
        (WebCore::RenderLayerBacking::paintIntoLayer):

2009-06-12  Simon Fraser  <simon.fraser@apple.com>

        Fix build when ACCELERATED_COMPOSITING is defined.

        * loader/EmptyClients.h:
        (WebCore::EmptyChromeClient::attachRootGraphicsLayer):
        (WebCore::EmptyChromeClient::setNeedsOneShotDrawingSynchronization):
        (WebCore::EmptyChromeClient::scheduleViewUpdate):
        Add stubs for the compositing-related ChromeClient methods.
        
        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::updateRootLayerPosition):
        (WebCore::RenderLayerCompositor::ensureRootPlatformLayer):
        docWidth()/docHeight() became private. Use overflowWidth()/overflowHeight() instead, which
        matches what is used to size the WebHTMLView.

2009-06-12  jorlow  <jorlow@chromium.org>

        Reviewed by David Levin.

        https://bugs.webkit.org/show_bug.cgi?id=26356
        http://crbug.com/14006
        Create custom bindings for v8.  The rest of these files are still
        forked (so the review is happening on the chromium review site).
        These bindings have been tested on a hacked up Chromium instance
        (also running --single-process) and Android.

        * bindings/v8/custom/V8StorageCustom.cpp: Added.

2009-06-12  Dmitry Titov  <dimich@chromium.org>

        Reviewed by David Levin.

        https://bugs.webkit.org/show_bug.cgi?id=26359
        [v8] Add XMLHttpRequest to WorkerContextExecutionProxy.

        * bindings/v8/WorkerContextExecutionProxy.cpp:
        (WebCore::WorkerContextExecutionProxy::ToV8Object): Add type == V8ClassIndex::XMLHTTPREQUEST to the convertable types.
        (WebCore::WorkerContextExecutionProxy::EventTargetToV8Object): same.
        * bindings/v8/WorkerContextExecutionProxy.h: fix typo in the comment.

2009-06-12  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part eight
        Replace placeholder Cairo BMP, ICO, XBM decoders with real ones.  Remove
        all the decoders from skia/ since they are now just mirrors of the Cairo
        ones.

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCoreSources.bkl:
        * platform/graphics/cairo/ImageSourceCairo.cpp:
        (WebCore::createDecoder): Pass IntSize() to ICOImageDecoder() so it will always decode the largest icon.  Enable XBM decoding on Windows.
        * platform/graphics/skia/ImageSourceSkia.cpp:
        * platform/graphics/wx/ImageSourceWx.cpp:
        (WebCore::createDecoder): Pass IntSize() to ICOImageDecoder() so it will always decode the largest icon.
        * platform/image-decoders/bmp/BMPImageDecoder.cpp: Replaced with WebCore/platform/image-decoders/skia/BMPImageDecoder.cpp.
        * platform/image-decoders/bmp/BMPImageDecoder.h: Replaced with WebCore/platform/image-decoders/skia/BMPImageDecoder.h.
        * platform/image-decoders/bmp/BMPImageReader.cpp: Copied from WebCore/platform/image-decoders/skia/BMPImageReader.cpp.
        * platform/image-decoders/bmp/BMPImageReader.h: Copied from WebCore/platform/image-decoders/skia/BMPImageReader.h.
        * platform/image-decoders/ico/ICOImageDecoder.cpp: Replaced with WebCore/platform/image-decoders/skia/ICOImageDecoder.cpp.
        * platform/image-decoders/ico/ICOImageDecoder.h: Replaced with WebCore/platform/image-decoders/skia/ICOImageDecoder.h.
        * platform/image-decoders/skia/BMPImageDecoder.cpp: Removed.
        * platform/image-decoders/skia/BMPImageDecoder.h: Removed.
        * platform/image-decoders/skia/BMPImageReader.cpp: Removed.
        * platform/image-decoders/skia/BMPImageReader.h: Removed.
        * platform/image-decoders/skia/GIFImageDecoder.cpp: Removed.
        * platform/image-decoders/skia/GIFImageDecoder.h: Removed.
        * platform/image-decoders/skia/GIFImageReader.cpp: Removed.
        * platform/image-decoders/skia/GIFImageReader.h: Removed.
        * platform/image-decoders/skia/ICOImageDecoder.cpp: Removed.
        * platform/image-decoders/skia/ICOImageDecoder.h: Removed.
        * platform/image-decoders/skia/JPEGImageDecoder.cpp: Removed.
        * platform/image-decoders/skia/JPEGImageDecoder.h: Removed.
        * platform/image-decoders/skia/PNGImageDecoder.cpp: Removed.
        * platform/image-decoders/skia/PNGImageDecoder.h: Removed.
        * platform/image-decoders/skia/XBMImageDecoder.cpp: Removed.
        * platform/image-decoders/skia/XBMImageDecoder.h: Removed.
        * platform/image-decoders/xbm/XBMImageDecoder.cpp: Replaced with WebCore/platform/image-decoders/skia/XBMImageDecoder.cpp.
        * platform/image-decoders/xbm/XBMImageDecoder.h: Replaced with WebCore/platform/image-decoders/skia/XBMImageDecoder.h.

2009-06-11  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part seven
        Update Skia's ImageDecoder.h with a few changes designed to reduce the
        delta between specific implementations of ImageDecoder.h.  Update
        Cairo's ImageDecoder.h to sync up with the API changes in the Skia
        version in the last two chage sets.  Update Cairo's PNG/JPEG/GIF
        decoders to use the APIs as well.  All the Cairo image decoder changes
        are direct copies of the Skia versions except ImageDecoder.h, which is
        modified in the necessary ways for the differences between Cairo and
        Skia.

        * platform/graphics/cairo/ImageSourceCairo.cpp:
        (WebCore::ImageSource::createFrameAtIndex): Use new RGBA32Buffer::asNewNativeImage() API.
        * platform/image-decoders/ImageDecoder.h: Sync up with Skia version.
        (WebCore::RGBA32Buffer::):
        (WebCore::RGBA32Buffer::RGBA32Buffer):
        (WebCore::RGBA32Buffer::clear):
        (WebCore::RGBA32Buffer::zeroFill):
        (WebCore::RGBA32Buffer::copyBitmapData):
        (WebCore::RGBA32Buffer::copyRowNTimes):
        (WebCore::RGBA32Buffer::setSize):
        (WebCore::RGBA32Buffer::asNewNativeImage):
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::disposalMethod):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::RGBA32Buffer::setDisposalMethod):
        (WebCore::RGBA32Buffer::setRGBA):
        (WebCore::RGBA32Buffer::operator=):
        (WebCore::RGBA32Buffer::width):
        (WebCore::RGBA32Buffer::height):
        (WebCore::RGBA32Buffer::getAddr):
        * platform/image-decoders/gif/GIFImageDecoder.cpp: Sync up with Skia version.
        (WebCore::GIFImageDecoder::initFrameBuffer):
        (WebCore::GIFImageDecoder::haveDecodedRow):
        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp: Sync up with Skia version.
        (WebCore::JPEGImageDecoder::outputScanlines):
        * platform/image-decoders/png/PNGImageDecoder.cpp: Sync up with Skia version.
        (WebCore::PNGImageDecoder::rowAvailable):
        * platform/image-decoders/skia/ImageDecoder.h: Add various typedefs or helper functions to minimize differences with Cairo version.  Reorder functions slightly to match reordering of Cairo's m_hasAlpha variable, which I moved to increase readability.
        (WebCore::RGBA32Buffer::):
        (WebCore::RGBA32Buffer::copyRowNTimes):
        (WebCore::RGBA32Buffer::setSize):
        (WebCore::RGBA32Buffer::asNewNativeImage):
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::disposalMethod):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::RGBA32Buffer::setStatus):
        (WebCore::RGBA32Buffer::setDisposalMethod):
        (WebCore::RGBA32Buffer::setRGBA):
        (WebCore::RGBA32Buffer::operator=):
        (WebCore::RGBA32Buffer::width):
        (WebCore::RGBA32Buffer::height):
        (WebCore::RGBA32Buffer::getAddr):
        * platform/image-decoders/skia/JPEGImageDecoder.cpp: Add #include needed by JPEG headers on some platforms, plus comment.

2009-06-12  Brent Fulgham  <bfulgham@webkit.org>

        Unreviewed build correction.

        Revert accidental configuration checkin.  Was not meant to
        be part of the last changeset.

        * config.h:

2009-06-12  Brent Fulgham  <bfulgham@webkit.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=26353
        Corrects handling of Cairo fonts that were getting out of
        sync due to default copy construction.  Also refactors
        some incorrect platform font destruction code that belongs
        in the font object's destructor.

        * platform/graphics/win/FontPlatformData.h:
        * platform/graphics/win/FontPlatformDataCGWin.cpp:
        (WebCore::FontPlatformData::~FontPlatformData):
        * platform/graphics/win/FontPlatformDataCairoWin.cpp:
        (WebCore::FontPlatformData::platformDataInit):
        (WebCore::FontPlatformData::FontPlatformData):
        (WebCore::FontPlatformData::setFont):
        (WebCore::FontPlatformData::~FontPlatformData):
        * platform/graphics/win/FontPlatformDataWin.cpp:
        * platform/graphics/win/SimpleFontDataCGWin.cpp:
        * platform/graphics/win/SimpleFontDataCairoWin.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        * platform/graphics/win/SimpleFontDataWin.cpp:

2009-06-12  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        * ChangeLog-2007-10-14: Update my email address.
        * ChangeLog-2008-08-10: Update my email address.

2009-06-12  Nate Chapin  <japhet@google.com>

        Reviewed by David Levin.

        Upstream V8Helpers.

        https://bugs.webkit.org/show_bug.cgi?id=26332

        * bindings/v8/V8Helpers.cpp: Added.
        (wrapNPObject): Moved from v8_helpers.cpp.
        (toV8Context): Moved from v8_helpers.cpp.
        (toV8Proxy): Moved from v8_helpers.cpp.
        * bindings/v8/V8Helpers.h: Added.

2009-06-12  Jessie Berlin  <jberlin@apple.com>

        Reviewed by Mark Rowe.

        https://bugs.webkit.org/show_bug.cgi?id=24792
        rdar://problem/6933055

        Changes the radius in which cursor movement around the 4 arrow icon
        while pan-scrolling does not cause scrolling from around 10 pixels to
        15 pixels, similar to what is found in IE and Firefox.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::setPanScrollCursor):
        Factor out the no-pan-scroll radius.
        * platform/ScrollView.h:
        Create a constant for the no-pan-scroll radius.
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::panScrollFromPoint):
        Factor out the no-pan-scroll radius.

2009-06-12  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=25609
        [GTK] Implement support for get_selection and get_n_selections

        Only use the VisibleSelection object if it actually belongs to the
        object we are using.

        This is pretty hacky-ish, but I can't seem to find a direct API to
        get the VisibleSelection for a given object, only the global one.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (selectionBelongsToObject):
        (webkit_accessible_text_get_n_selections):
        (webkit_accessible_text_get_selection):

2009-06-03  Eric Seidel  <eric@webkit.org>

        Reviewed by Darin Adler.

        Crash at Node::nodeIndex()
        https://bugs.webkit.org/show_bug.cgi?id=26044

        This crash seems to be caused by calling nodeIndex() on
        and invalid Node pointer.  As far as I can tell, the most likely
        explanation is that the Range holding the node is actually
        deleted already (thus the memory is junk).  Looking at the code
        Range changes m_start.container() in its destructor to tell if
        the range is detached or not.  If somehow m_start.container() was
        cleared, the range will never be detached and the Document will end
        up with pointers to deleted ranges.  I don't know how to reproduce this
        any reproduction I could think of would hit ASSERTS in Debug mode.
        One reproduction I tried, did not crash in Release mode, even though it
        did in Debug mode.

        I'm making a speculative fix by always detaching the Range from the document
        during ~Range.  This is safer, and all we lose is an ASSERT to prevent double-detach.
        
        Another solution would be to instead store an m_attached bool on the Range object, or
        expose a Document::isRangeAttached(range) call.  Either of those solutions
        could affect performance, so I went with this solution for now.

        I also removed the RangeBoundaryPoint default constructor
        as it is not used anywhere (and is more likely to cause confusion).

        Since I can't reproduce the crash, no test.

        * dom/Document.cpp:
        (WebCore::Document::detachRange):
        * dom/Range.cpp:
        (WebCore::Range::~Range):
        (WebCore::Range::detach):
        * dom/RangeBoundaryPoint.h:
        (WebCore::RangeBoundaryPoint::RangeBoundaryPoint):
          RangeBoundaryPoints always have an m_containerNode, ASSERT that.
        (WebCore::RangeBoundaryPoint::set):
          ASSERT(container) to match all the other functions.
          All callers already ASSERT(container).  Since we only
          have reports if this crash from Release mode, I can only
          assume that those ASSERTs would have been hit in a Debug reproduction.

2009-06-11  Shinichiro Hamaji  <hamaji@chromium.org>

        Reviewed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=25512
        Handle texts after unfinished special tags (i.e., script, style, textarea,
        title, xmp, and iframe) as the text node under the tags in view-source mode.
        Before this change, all texts in unfinished special tags cannot be seen even in view-source mode.

        This was already done only for title. This change allows other special tags to be handled as well.

        Test: fast/frames/viewsource-unfinished-tags.html

        * html/HTMLTokenizer.cpp:
        (WebCore::HTMLTokenizer::parseNonHTMLText):
        (WebCore::HTMLTokenizer::parseTag):
        (WebCore::HTMLTokenizer::write):
        * html/HTMLTokenizer.h:
        (WebCore::HTMLTokenizer::State::inAnyNonHTMLText):

2009-06-11  Yongjun Zhang  <yongjun.zhang@nokia.com>

        Reviewed by Ariya Hidayat.

        https://bugs.webkit.org/show_bug.cgi?id=26291

        [Qt] build break in ImageDecoderQt.cpp.

        * platform/graphics/qt/ImageDecoderQt.cpp:
        (WebCore::ImageDecoderQt::reset):
        (WebCore::ImageDecoderQt::setData):
        (WebCore::ImageDecoderQt::isSizeAvailable):
        * platform/image-decoders/ImageDecoder.h:
        (WebCore::ImageDecoder::setSize):

2009-06-11  Simon Hausmann  <simon.hausmann@nokia.com>

        Rubber-stamped by Ariya Hidayat.

        Removed obsolete and unmaintained files from the old Symbian port.

        * platform/symbian/FloatPointSymbian.cpp: Removed.
        * platform/symbian/FloatRectSymbian.cpp: Removed.
        * platform/symbian/IntPointSymbian.cpp: Removed.
        * platform/symbian/IntRectSymbian.cpp: Removed.
        * platform/symbian/IntSizeSymbian.cpp: Removed.
        * platform/text/symbian/StringImplSymbian.cpp: Removed.
        * platform/text/symbian/StringSymbian.cpp: Removed.

2009-06-10  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part six
        Miscellaneous tiny changes.  The important bits here are the ANSI C++
        compliance fix in skia/ImageDecoders.h (needed to compile this file on
        non-MSVC) and some behavioral fixes for the XBM decoder that Chromium
        unit tests partly exposed.  Other changes are mostly cosmetic.

        * platform/image-decoders/ImageDecoder.h: Make some variables private again.  This will break QTWebKit but those guys have agreed to wait on my finishing the ImageDecoder changes.
        * platform/image-decoders/gif/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::initFrameBuffer): Use IntPoint() instead of the redundant IntPoint(0, 0).
        (WebCore::GIFImageDecoder::frameComplete): Use IntPoint() instead of the redundant IntPoint(0, 0).
        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:
        (WebCore::JPEGImageDecoder::outputScanlines): Remove obvious comments.
        * platform/image-decoders/png/PNGImageDecoder.cpp:
        (WebCore::PNGImageDecoder::rowAvailable): Remove obvious comments.
        * platform/image-decoders/skia/BMPImageReader.cpp:
        (WebCore::BMPImageReader::decodeBMP): Make more in line with other decoders' comments and structure, use a ref to decrease verbosity.
        (WebCore::BMPImageReader::processRLEData): Use a ref to decrease verbosity.
        (WebCore::BMPImageReader::processNonRLEData): Use a ref to decrease verbosity.
        * platform/image-decoders/skia/GIFImageDecoder.cpp: Use IntPoint() instead of the redundant IntPoint(0, 0).
        (WebCore::GIFImageDecoder::initFrameBuffer): Use IntPoint() instead of the redundant IntPoint(0, 0).
        (WebCore::GIFImageDecoder::frameComplete): Use IntPoint() instead of the redundant IntPoint(0, 0).
        * platform/image-decoders/skia/ImageDecoder.h:
        (WebCore::RGBA32Buffer::copyRowNTimes): Fix ANSI violation that MSVC let me compile (!).
        * platform/image-decoders/skia/JPEGImageDecoder.cpp:
        (WebCore::JPEGImageDecoder::outputScanlines): Remove obvious comments.
        * platform/image-decoders/skia/PNGImageDecoder.cpp:
        (WebCore::PNGImageDecoder::rowAvailable): Remove obvious comments.
        * platform/image-decoders/skia/XBMImageDecoder.cpp:
        (WebCore::XBMImageDecoder::frameBufferAtIndex): Return 0 for non-zero indexes, don't try to decode unnecessarily after failure or when the size couldn't be computed, make more in line with other decoders' comments and structure, call RGBA32Buffer::setRect() appropriately.

2009-06-10  Ojan Vafai  <ojan@chromium.org>

        Reviewed by Eric Seidel.

        The shadow node inside empty textareas gets collapsed in disabled
        textareas. This is a regression from moving the overflow from
        the shadow node to it's parent. The fix is to return true in
        RenderBlock::hasLineIfEmpty for textarea shadow nodes as we 
        currently do for input shadow nodes.
        
        https://bugs.webkit.org/show_bug.cgi?id=26296
        
        Test: fast/forms/empty-textarea-toggle-disabled.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::hasLineIfEmpty):

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=25609
        [GTK] Implement support for get_selection and get_n_selections

        Implement atk_text_get_n_selections.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (webkit_accessible_text_get_n_selections):

2009-06-10  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - fix <rdar://problem/6958664> REGRESSION (r42665): When I drag to pan a
          Google map in iPhoto Places, it drags a map tile instead

        Calling stopLoadRequest() from notifyFinished() removed the
        ScriptElementData from the CachedScript's client set, which could make
        it eligible for purging. The fix is to call removeClient() only after
        executing the script, which protects it from being purged while it is
        in the document's queue of scripts to execute soon.

        * dom/ScriptElement.cpp:
        (WebCore::ScriptElementData::execute): Call removeClient() here.
        (WebCore::ScriptElementData::notifyFinished): Instead of calling
        stopLoadRequest(), which calls removeClient(), just reset
        m_cachedScript.

2009-06-10  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed by Mark Rowe and Eric Seidel.

        Update WebInspector localizedStrings.js with new resource tracking strings
        https://bugs.webkit.org/show_bug.cgi?id=26247

        * English.lproj/localizedStrings.js:

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android specific files.
        https://bugs.webkit.org/show_bug.cgi?id=26280

        * platform/text/android: Added.
        * platform/text/android/TextBreakIteratorInternalICU.cpp: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android specific file to WebCore/platform/android (part 9).
        https://bugs.webkit.org/show_bug.cgi?id=26266

        * platform/android/TemporaryLinkStubs.cpp: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android platform specific files.
        https://bugs.webkit/org/show_bug.cgi?id=26265 (part 8).

        * platform/android/SystemTimeAndroid.cpp: Added.
        * platform/android/WidgetAndroid.cpp: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android port files to WebCore/platform. (part 6).
        https://bugs.webkit.org/show_bug.cgi?id=26264

        * platform/android/RenderThemeAndroid.cpp: Added.
        * platform/android/RenderThemeAndroid.h: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android port files to WebCore/platform (part 7).
        https://bugs.webkit.org/show_bug.cgi?id=23296

        * platform/android/ScreenAndroid.cpp: Added.
        * platform/android/ScrollViewAndroid.cpp: Added.
        * platform/android/SearchPopupMenuAndroid.cpp: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android port files to WebCore/platform (part 5).
        https://bugs.webkit.org/show_bug.cgi?id=23296

        * platform/android/LocalizedStringsAndroid.cpp: Added.
        * platform/android/PopupMenuAndroid.cpp: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android port files to WebCore/platform (part 4).
        https://bugs.webkit.org/show_bug.cgi?id=23296

        * platform/android/KeyEventAndroid.cpp: Added.
        * platform/android/KeyboardCodes.h: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android port files to WebCore/platform (part 3).
        https://bugs.webkit.org/show_bug.cgi?id=23296

        * platform/android/FileChooserAndroid.cpp: Added.
        * platform/android/FileSystemAndroid.cpp: Added.

2009-06-10  Feng Qian  <feng@chromium.org>

        Reviewed by Eric Seidel.

        Add Android port files to WebCore/platform (part 2).
        https://bugs.webkit.org/show_bug.cgi?id=23296

        * platform/android/CursorAndroid.cpp: Added.
        * platform/android/DragDataAndroid.cpp: Added.
        * platform/android/EventLoopAndroid.cpp: Added.

2009-06-10  Nate Chapin  <japhet@google.com>

        Reviewed by David Levin.

        Finish moving V8Custom from src.chromium.org to svn.webkit.org.

        https://bugs.webkit.org/show_bug.cgi?id=26258

        * bindings/v8/custom/V8CustomBinding.cpp: Finished upstreaming.
        (WebCore::ACCESSOR_GETTER): Moved from v8_custom.cpp.
        (WebCore::INDEXED_ACCESS_CHECK): Moved from v8_custom.cpp.
        (WebCore::NAMED_ACCESS_CHECK): Moved from v8_custom.cpp.
        (WebCore::V8Custom::GetTargetFrame): Moved from v8_custom.cpp.
        (WebCore::V8Custom::DowncastSVGPathSeg): Moved from v8_custom.cpp.
        * bindings/v8/custom/V8CustomBinding.h: Finished upstreaming.
        * bindings/v8/custom/V8DatabaseCustom.cpp: Updated includes.
        * bindings/v8/custom/V8SQLResultSetRowListCustom.cpp: Updated includes.
        * bindings/v8/custom/V8SQLTransactionCustom.cpp: Updated includes.
        * bindings/v8/custom/V8WebKitPointConstructor.cpp: Added.
        (WebCore::CALLBACK_FUNC_DECL): Moved from v8_custom.cpp.

2009-06-10  Takeshi Yoshino  <tyoshino@google.com>

        Reviewed by Justin Garcia.

        Bug 26214: RenderTextControl: Remove ASSERT for checking that visiblePositionForIndex()'s return is not null.
        https://bugs.webkit.org/show_bug.cgi?id=26214

        visiblePositionForIndex can return an instance that returns true for
        isNotNull(). One of common case is when the corresponding input element has
        "-webkit-user-select: none" style attribute. We should allow the case instead
        of putting ASSERT.

        Test: fast/forms/input-select-webkit-user-select-none.html

        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::setSelectionRange):

2009-06-10  Roland Steiner <rolandsteiner@google.com>

        Reviewed by Eric Seidel.

        Bug 26197: Incorrect variable initialization in PlatformContextSkia.cpp
        https://bugs.webkit.org/show_bug.cgi?id=26197

        The PlatformContextSkia constructor does a (very likely) wrong size
        initialization for its m_stateStack member:

            m_stateStack(sizeof(State))

        The intended initialization is probably rather

            m_stateStack(1)

        However, since this doesn't buy much (see also comment #4),
        I removed the initialization completely.

        * platform/graphics/skia/PlatformContextSkia.cpp:
        (PlatformContextSkia::PlatformContextSkia): remove member initialization

2009-06-10  Dean McNamee  <deanm@chromium.org>

        Reviewed by Eric Seidel.

        When there is no backing bitmap, return a transparent pattern.
        https://bugs.webkit.org/show_bug.cgi?id=26061

        Test: fast/canvas/canvas-empty-image-pattern.html

        * platform/graphics/skia/PatternSkia.cpp:
        (WebCore::Pattern::createPlatformPattern):

2009-06-10  Dean McNamee  <deanm@chromium.org>

        Reviewed by Eric Seidel.

        Fix a crash for radial gradients with a zero radius.
        https://bugs.webkit.org/show_bug.cgi?id=26059

        Test: fast/gradients/crash-on-zero-radius.html

        * platform/graphics/skia/GradientSkia.cpp:
        (WebCore::Gradient::platformGradient):

2009-06-10  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part five
        Rewrite users of ImageDecoder.h to use "safe" API calls, Skia side.
        This tweaks the RGBA32Buffer interfaces to be implementable by Cairo as
        well and modifies Skia's usage of those interfaces accordingly.  Once a
        similar change lands on the Cairo side, the Skia and Cairo decoders
        should be identical except for the implementation of RGBA32Buffer.

        * platform/graphics/skia/ImageSourceSkia.cpp:
        (WebCore::ImageSource::createFrameAtIndex): Use new RGBA32Buffer::asNewNativeImage() function.
        * platform/image-decoders/skia/BMPImageReader.cpp:
        (WebCore::BMPImageReader::processNonRLEData): Use new RGBA32Buffer::zeroFill() function.
        * platform/image-decoders/skia/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::haveDecodedRow): Rewrite to use RGBA32Buffer::setRGBA(x, y, ...) calls as well as other RGBA32Buffer interface calls instead of knowing the underlying types inside the buffer; also try and add clarity.
        * platform/image-decoders/skia/ImageDecoder.h: Removed bitmap(), width(), and height().
        (WebCore::RGBA32Buffer::zeroFill): Added.
        (WebCore::RGBA32Buffer::copyBitmapData): Avoid using bitmap(), which is going away.
        (WebCore::RGBA32Buffer::copyRowNTimes): Added.
        (WebCore::RGBA32Buffer::setSize): Use new zeroFill() function.
        (WebCore::RGBA32Buffer::asNewNativeImage): Added.
        (WebCore::RGBA32Buffer::setRGBA): Condensed two versions into one that takes coordinates instead of a raw pointer.

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=25671
        [GTK] Implement support for set_caret_offset

        Make an implementation that actually works.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (webkit_accessible_text_set_caret_offset):

2009-06-10  Darin Fisher  <darin@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26294

        Make sure all member variables are initialized so that the default
        assignment operator and copy constructors do not read uninitialized
        memory.

        * platform/network/ResourceResponseBase.cpp:

2009-06-10  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Timothy Hatcher.

        Update main resource meta-data when resource tracking is disabled.

        https://bugs.webkit.org/show_bug.cgi?id=26253

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::getTrackedResource):
        (WebCore::InspectorController::willSendRequest):
        (WebCore::InspectorController::didReceiveResponse):
        (WebCore::InspectorController::didReceiveContentLength):
        (WebCore::InspectorController::didFinishLoading):
        (WebCore::InspectorController::didFailLoading):
        * inspector/InspectorController.h:

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=25609
        [GTK] Implement support for get_selection and get_n_selections

        Implement atk_text_get_selection.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (webkit_accessible_text_get_selection):

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Gustavo Noronha.

        Do not check if our parent class has the finalize method, it's
        guaranteed to be there.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (webkit_accessible_finalize):

2009-06-10  Brent Fulgham  <bfulgham@webkit.org>

        Build correct for Windows Cairo targets.

        * WebCore.vcproj/WebCore.vcproj: Disable warning 4611 (interaction
          between '_setjmp' and C++ object destruction is non-portable) for
          the two Cairo targets.  This used to be disabled in a #pragma,
          but recent refactoring removed these lines.

2009-06-10  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        Fix the build of PluginView on Qt with 64-bit where we disable plugins
        at compile time.

        Use the FooNone.cpp files at compile-time.

        * plugins/PluginPackageNone.cpp:
        * plugins/mac/PluginPackageMac.cpp:
        * plugins/mac/PluginViewMac.cpp:

2009-06-10  Simon Hausmann  <simon.hausmann@nokia.com>

        Fix the Qt build.

        ImageDecoderQt needs m_size and m_sizeAvailable to be protected.

        * platform/image-decoders/ImageDecoder.h:

2009-06-10  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Use absolute path for install_name on Mac

        * WebCore.pro:

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Jan Alonzo.

        https://bugs.webkit.org/show_bug.cgi?id=25415
        [GTK][ATK] Please implement support for get_text_at_offset

        Reduce duplicated code to access the text of a AtkText
        object. doAXStringForRange calls text() internally, so we are
        doing exactly the same after the change.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (getGailTextUtilForAtk):
        (getPangoLayoutForAtk):

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Jan Alonzo.

        https://bugs.webkit.org/show_bug.cgi?id=25415
        [GTK][ATK] Please implement support for get_text_at_offset

        Pass a PangoLayout to the GailTextUtil function calls.

        It's needed for LINE boundary calls to work correctly.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (updateLayout):
        (getPangoLayoutForAtk):
        (webkit_accessible_text_get_text_after_offset):
        (webkit_accessible_text_get_text_at_offset):

2009-06-10  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Jan Alonzo.

        https://bugs.webkit.org/show_bug.cgi?id=25415
        [GTK][ATK] Please implement support for get_text_at_offset

        Use GailUtilText instead of my crappy partial reimplementation of
        it. This should add support for LINE boundaries too, although it's
        mostly untested for now.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (getGailTextUtilForAtk):
        (webkit_accessible_text_get_text_after_offset):
        (webkit_accessible_text_get_text_at_offset):

2009-06-10  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Gtk build fix: include <stdio.h> as it is required in jpeglib.h

        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:

2009-06-09  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part four
        Most of the remaining Cairo changes needed before merging Skia/Cairo
        image decoders.  Most of these involve plumbing more error detection and
        handling (or, in some cases, merely the capability to detect errors, as
        e.g. Skia detects and handles image allocation failure while Cairo
        currently doesn't).  There is also some general cleanup and
        simplification; RGBA32Buffer::m_height and all associated functions have
        been removed (set but never used) and some places now rely on superclass
        implementations.

        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::RGBA32Buffer): Remove m_height, ensureHeight() and associated stuff
        (WebCore::RGBA32Buffer::copyBitmapData): Add API function so refcounted backing stores (like Skia uses) can be used with GIFs
        (WebCore::RGBA32Buffer::setSize): Zero-fill image to avoid garbage
        (WebCore::RGBA32Buffer::height): Remove
        (WebCore::RGBA32Buffer::ensureHeight): Remove
        (WebCore::ImageDecoder::ImageDecoder): Keep member initialization in order, force subclasses to go through size() instead of accessing m_size directly
        (WebCore::ImageDecoder::isSizeAvailable): Check that decoding hasn't failed
        (WebCore::ImageDecoder::size): Check that decoding hasn't failed
        (WebCore::ImageDecoder::setSize): Protect against integer overflow
        (WebCore::ImageDecoder::isOverSize): Protect against integer overflow
        * platform/image-decoders/gif/GIFImageDecoder.cpp: Remove prepEmptyFrameBuffer()
        (WebCore::GIFImageDecoder::isSizeAvailable): Rely on superclass isSizeAvailable() for better failure handling
        (WebCore::GIFImageDecoder::sizeNowAvailable): Add return values for better failure handling, rely on superclass setSize() for overflow protection
        (WebCore::GIFImageDecoder::initFrameBuffer): Add return values for better failure handling, remove prepEmptyFrameBuffer(), use RGBA32Buffer::setSize() to handle potential allocation failures (won't happen with Cairo port, can in Skia), use RGBA32Buffer::copyBitmapData() so backing store can be refcounted internally (Cairo won't be, Skia is), rely on superclass size() for better failure handling
        (WebCore::GIFImageDecoder::haveDecodedRow): Fix style violation, remove RGBA32Buffer::ensureHeight()
        (WebCore::GIFImageDecoder::frameComplete): Remove RGBA32Buffer::ensureHeight()
        * platform/image-decoders/gif/GIFImageDecoder.h: Remove prepEmptyFrameBuffer(), add return values for better failure handling
        * platform/image-decoders/gif/GIFImageReader.cpp:
        (GIFImageReader::do_lzw): Protect against array overflow, add comments
        (GIFImageReader::read): Protect against array overflow, be more tolerant of bad data, better failure handling
        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp: Remove MSVC-specific warning disable (bfulgham will move into build files)
        (WebCore::JPEGImageReader::decode): Better failure handling
        (WebCore::JPEGImageDecoder::isSizeAvailable): Rely on superclass isSizeAvailable() for better failure handling
        (WebCore::JPEGImageDecoder::outputScanlines): Use RGBA32Buffer::setSize() to handle potential allocation failures (won't happen with Cairo port, can in Skia), rely on superclass size() for better failure handling, remove RGBA32Buffer::ensureHeight()
        * platform/image-decoders/jpeg/JPEGImageDecoder.h: Rely on superclass setSize() for overflow protection
        * platform/image-decoders/png/PNGImageDecoder.cpp: Remove MSVC-specific warning disable (bfulgham will move into build files)
        (WebCore::PNGImageDecoder::PNGImageDecoder): Don't allocate a slot in the framebuffer cache until it's needed
        (WebCore::PNGImageDecoder::isSizeAvailable): Rely on superclass isSizeAvailable() for better failure handling
        (WebCore::PNGImageDecoder::frameBufferAtIndex): Don't allocate a slot in the framebuffer cache until it's needed
        (WebCore::PNGImageDecoder::decode): Don't allocate a slot in the framebuffer cache until it's needed
        (WebCore::PNGImageDecoder::decodingFailed): Fix style violation
        (WebCore::PNGImageDecoder::headerAvailable): Rely on superclass isSizeAvailable() and setSize() for overflow protection and better failure handling
        (WebCore::PNGImageDecoder::rowAvailable): Don't allocate a slot in the framebuffer cache until it's needed, use RGBA32Buffer::setSize() to handle potential allocation failures (won't happen with Cairo port, can in Skia), remove RGBA32Buffer::ensureHeight()
        (WebCore::PNGImageDecoder::pngComplete): Don't allocate a slot in the framebuffer cache until it's needed

2009-06-09  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix, adding JSCore/assembler to the list of include dirs, and
        adding editing/ReplaceNodeSpanCommand.cpp to the build.
        
        * WebCoreSources.bkl:
        * webcore-base.bkl:

2009-06-09  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Timothy Hatcher.

        When checking if the loader is the main resource loader make sure that the loader's frame is the main frame. 

        https://bugs.webkit.org/show_bug.cgi?id=26218

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::didLoadResourceFromMemoryCache):
        (WebCore::InspectorController::identifierForInitialRequest):
        (WebCore::InspectorController::isMainResourceLoader):
        * inspector/InspectorController.h:

2009-06-09  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=26190

        Test: media/controls-css-overload.html

        * rendering/RenderMedia.cpp:
        (WebCore::RenderMedia::updateControls): Prevent NULL dereference in case containers gets hidden.

2009-06-08  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part three
        Various minor cleanups to the Skia files.  Mostly non-functional, except
        for two specific changes:
        * JPEGs and PNGs were always marked as transparent; now they are only
          marked as transparent when they actually are.  I doubt this has much
          of an effect but in theory it could be used to optimize their display.
        * Instead of arbitrarily disallowing images over 32 * 1024 * 1024 px^2,
          only disallow images which are so large they will cause overflow in
          other parts of the code.  This should fix the testcase on
          http://code.google.com/p/chromium/issues/detail?id=3643.

        * platform/image-decoders/skia/BMPImageReader.h:
        (WebCore::BMPImageReader::setRGBA): Use simpler non-static setRGBA() form
        * platform/image-decoders/skia/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::initFrameBuffer): Remove unneeded code, use more readable setRGBA() form
        (WebCore::GIFImageDecoder::haveDecodedRow): Fix style violation
        * platform/image-decoders/skia/GIFImageDecoder.h: Remove unneeded code
        * platform/image-decoders/skia/ImageDecoder.h:
        (WebCore::RGBA32Buffer::setSize): setSize() should just setStatus() when it fails since all callers were doing it
        (WebCore::ImageDecoder::isOverSize): Ease "oversized" image constraints to allow any image that won't overflow
        * platform/image-decoders/skia/JPEGImageDecoder.cpp:
        (WebCore::JPEGImageDecoder::outputScanlines): Remove unneeded code, mark JPEGs as non-transparent
        * platform/image-decoders/skia/PNGImageDecoder.cpp:
        (WebCore::PNGImageDecoder::decodingFailed): Fix style violation
        (WebCore::PNGImageDecoder::rowAvailable): Mark un-decoded PNGs as non-transparent (this will get reset later as needed)
        * platform/image-decoders/skia/XBMImageDecoder.cpp:
        (WebCore::XBMImageDecoder::frameBufferAtIndex): Remove unneeded code

2009-06-09  Darin Fisher  <darin@chromium.org>

        Fix Chromium build bustage.
        
        CachedResource.cpp no longer compiles if USE(JSC) is not defined.  The
        problem is that this file is using a macro from StdLibExtras.h without
        including that file.  It just happenes to get that file via a JSC
        specific include.

        * loader/CachedResource.cpp:

2009-06-09  Dean McNamee  <deanm@chromium.org>

        Reviewed by Oliver Hunt.

        Make sure the graphics backends are in sync with the canvas lineWidth state.
        https://bugs.webkit.org/show_bug.cgi?id=26187

        Test: fast/canvas/canvas-line-width.html

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::CanvasRenderingContext2D):

2009-06-09  Michael Nordman  <michaeln@google.com>

        Reviewed by Eric Seidel.

        Proactively cancel pending requests at DocLoader dtor time,
        otherwise crashes can occur. 

        https://bugs.webkit.org/show_bug.cgi?id=26230
        http://code.google.com/p/chromium/issues/detail?id=12161

        Test: fast/frames/javascript-url-as-framesrc-crash.html

        * loader/DocLoader.cpp:
        (WebCore::DocLoader::~DocLoader):

2009-06-09  Eric Seidel  <eric@webkit.org>

        Reviewed by Darin Adler.

        Fix ASSERT seen in shadow tree testing
        https://bugs.webkit.org/show_bug.cgi?id=25092

        Test: svg/custom/use-mutation-event-crash.svg

        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::instanceForShadowTreeElement):

2009-06-09  Brent Fulgham  <bfulgham@webkit.org>

        Reviewed by Eric Seidel.

        Fixes https://bugs.webkit.org/show_bug.cgi?id=22891
        Scrolling in Windows Cairo Broken if no background color set.

        * platform/graphics/cairo/GradientCairo.cpp:
        (WebCore::Gradient::fill):  Use the GraphicsContext save and restore
          methods (rather than the Cairo-only functions) so that the Windows
          device context is kept in sync.
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::GraphicsContext): Add new constructor call
          to sync Windows HDC with Cairo surface.
        * platform/graphics/cairo/GraphicsContextPlatformPrivateCairo.h:
        (WebCore::GraphicsContextPlatformPrivate::syncContext): Provide
          declaration for Windows HDC sync method (and stub for non-Windows
          Cairo implementations).
        * platform/graphics/cairo/ImageCairo.cpp:
        (WebCore::BitmapImage::draw): Use GraphicsContext save and restore
          methods (rather than the Cairo-only functions) so that the Windows
          device context is kept in sync.
        * platform/graphics/win/GraphicsContextCairoWin.cpp:
        (WebCore::CairoContextWithHDC): New method to create a valid Cairo
          context for a given HDC.
        (WebCore::GraphicsContext::GraphicsContext): Modify constructor to
          use new CairoContextWithHDC call.
        (WebCore::GraphicsContext::getWindowsContext): Revise to match
          behavior of CG implementation.
        (WebCore::GraphicsContext::releaseWindowsContext): Revise to match
          behavior of CG implementation.
        (WebCore::GraphicsContextPlatformPrivate::concatCTM): Get rid of
          incorrect new HDC, and use object's HDC member for dealing with
          concatCTM operations.
        (WebCore::GraphicsContextPlatformPrivate::syncContext): New method
          to sync Windows HDC with Cairo context.
        * platform/graphics/win/ImageCairoWin.cpp:
        (WebCore::BitmapImage::getHBITMAPOfSize): Revise implementation to
          match CG behavior.

2009-06-09  Jian Li  <jianli@chromium.org>

        Reviewed by David Levin.

        Bug 26196: Fix the problem that worker's importScripts fails if the
        script URL is redirected from different origin.
        https://bugs.webkit.org/show_bug.cgi?id=26196

        Test: http/tests/workers/worker-importScripts.html

        The fix is to pass an additional enum parameter to the loader in
        order to tell it to perform the redirect origin check or not.

        * loader/DocumentThreadableLoader.cpp:
        (WebCore::DocumentThreadableLoader::create):
        (WebCore::DocumentThreadableLoader::DocumentThreadableLoader):
        (WebCore::DocumentThreadableLoader::willSendRequest):
        * loader/DocumentThreadableLoader.h:
        * loader/ThreadableLoader.cpp:
        (WebCore::ThreadableLoader::create):
        (WebCore::ThreadableLoader::loadResourceSynchronously):
        * loader/ThreadableLoader.h:
        (WebCore::):
        * loader/WorkerThreadableLoader.cpp:
        (WebCore::WorkerThreadableLoader::WorkerThreadableLoader):
        (WebCore::WorkerThreadableLoader::loadResourceSynchronously):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::MainThreadBridge):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::mainThreadCreateLoader):
        * loader/WorkerThreadableLoader.h:
        (WebCore::WorkerThreadableLoader::create):
        * workers/WorkerContext.cpp:
        (WebCore::WorkerContext::importScripts):
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::loadRequestAsynchronously):

2009-06-09  Anand K. Mistry  <amistry@google.com>

        Reviewed by Dimitri Glazkov.

        Paint bitmaps with the alpha channel in Skia.
        https://bugs.webkit.org/show_bug.cgi?id=26037

        Test: fast/canvas/drawImage-with-globalAlpha.html

        * platform/graphics/skia/ImageSkia.cpp:
        (WebCore::paintSkBitmap):
        * platform/graphics/skia/PlatformContextSkia.cpp:
        (PlatformContextSkia::getAlpha):
        * platform/graphics/skia/PlatformContextSkia.h:

2009-06-09  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Reviewed by Xan Lopez.

        https://bugs.webkit.org/show_bug.cgi?id=26104
        [GTK] Make NetworkRequest a proper GObject and expose SoupMessage

        Refactor how SoupMessage is handled, so that our ResourceRequest
        object doesn't have to store it as a member, which complicates
        managing ResourceRequest's lifetime.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::startHttp):
        * platform/network/soup/ResourceRequest.h:
        (WebCore::ResourceRequest::ResourceRequest):
        (WebCore::ResourceRequest::doUpdatePlatformRequest):
        (WebCore::ResourceRequest::doUpdateResourceRequest):
        * platform/network/soup/ResourceRequestSoup.cpp:
        (WebCore::ResourceRequest::toSoupMessage):
        (WebCore::ResourceRequest::updateFromSoupMessage):

2009-06-09  Simon Hausmann  <simon.hausmann@nokia.com>

        Fix the Qt build, the time functions moved into the WTF namespace.

        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertValueToQVariant):
        (JSC::Bindings::convertQVariantToValue):

2009-06-08  Brady Eidson  <beidson@apple.com>

        Reviewed by Antti Koivisto

        <rdar://problem/6727495> Repro crash in WebCore::Loader::Host::servePendingRequests() and dupes.

        Test: http/tests/loading/deleted-host-in-resource-load-delegate-callback.html

        Loader::Host objects were manually managed via new/delete.
        There's a variety of circumstances where a Host might've been deleted while it was still in the middle
        of a resource load delegate callback.
        Changing them to be RefCounted then adding protectors in the callbacks makes this possibility disappear.

        At the same time, remove ProcessingResource which was an earlier fix for this same problem that wasn't
        fully implemented.

        * loader/loader.cpp:
        (WebCore::Loader::Loader):
        (WebCore::Loader::load):
        (WebCore::Loader::servePendingRequests):
        (WebCore::Loader::resumePendingRequests):
        (WebCore::Loader::cancelRequests):
        (WebCore::Loader::Host::didFinishLoading):
        (WebCore::Loader::Host::didFail):
        (WebCore::Loader::Host::didReceiveResponse):
        (WebCore::Loader::Host::didReceiveData):
        * loader/loader.h:
        (WebCore::Loader::Host::create):

2009-06-08  Dmitry Titov  <dimich@chromium.org>

        Reviewed by David Levin.

        https://bugs.webkit.org/show_bug.cgi?id=26126
        Refactor methods of WorkerMessagingProxy used to talk to main-thread loader into new interface.

        Split a couple of methods used to schedule cross-thread tasks between worker thread and loader thread
        implemented on WorkerMessagingProxy into a separate interface so the loading can be implemented in
        Chromium's workers.

        No changes in functionality so no tests added.

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        Added WorkerLoaderProxy.h to the bulid.

        * bindings/js/WorkerScriptController.cpp:
        (WebCore::WorkerScriptController::evaluate): WorkerThread::workerObjectProxy() now returns & instead of *
        * bindings/v8/WorkerScriptController.cpp:
        (WebCore::WorkerScriptController::evaluate): same.
        * workers/WorkerContext.cpp:
        (WebCore::WorkerContext::~WorkerContext): same.
        (WebCore::WorkerContext::reportException): same.
        (WebCore::WorkerContext::addMessage): same.
        (WebCore::WorkerContext::postMessage): same.

        * loader/WorkerThreadableLoader.cpp:
        (WebCore::WorkerThreadableLoader::WorkerThreadableLoader):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::MainThreadBridge):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::destroy):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::cancel):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didSendData):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didReceiveResponse):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didReceiveData):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didFinishLoading):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didFail):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didFailRedirectCheck):
        (WebCore::WorkerThreadableLoader::MainThreadBridge::didReceiveAuthenticationCancellation):
        Use WorkerLoaderProxy instead of WorkerMessagingProxy for the MainThreadBridge.
        Mostly rename.

        (WebCore::WorkerThreadableLoader::MainThreadBridge::mainThreadCreateLoader):
        In addition to using WorkerLoaderProxy instead of WorkerMessagingProxy, the check for
        AskedToTerminate is removed. It seems to be an optimization for a very small number of cases
        when worker termination is requested a very short time before the request to load something
        (XHR or importScript) was dispatched on the main thread.

        * loader/WorkerThreadableLoader.h:
        Now keeps a pointer to WorkerLoaderProxy rather then to a WorkerMessagingProxy. This allows
        to implement WorkerThreadableLoader for Chromium.

        * workers/WorkerLoaderProxy.h: Added.
        (WebCore::WorkerLoaderProxy::~WorkerLoaderProxy):

        * workers/WorkerMessagingProxy.cpp:
        (WebCore::WorkerMessagingProxy::startWorkerContext):
        (WebCore::WorkerMessagingProxy::postTaskToLoader): Added ASSERT since this needs to be implemented for nested workers.
        * workers/WorkerMessagingProxy.h:
        Derived from WorkerLoaderProxy, the methods for posting tasks cross-thread are now virtual.
        Removed unused postTaskToWorkerContext() method.

        * workers/WorkerThread.cpp:
        (WebCore::WorkerThread::create):
        (WebCore::WorkerThread::WorkerThread):
        * workers/WorkerThread.h:
        (WebCore::WorkerThread::workerLoaderProxy):
        * workers/WorkerThread.cpp:
        (WebCore::WorkerThread::create):
        (WebCore::WorkerThread::WorkerThread):
        (WebCore::WorkerThread::workerThread):
        * workers/WorkerThread.h:
        (WebCore::WorkerThread::workerLoaderProxy):
        (WebCore::WorkerThread::workerObjectProxy):
        WorkerThread gets a new member of type WorkerLoaderProxy&, and accessor.
        Also, existing WorkerObjectProxy* member is now WorkerObjectProxy& because it can't be null.

2009-06-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=26238
        Add parseDate helper to HTTPParsers, which uses WTF::parseDateFromNullTerminatedCharacters.

        * ForwardingHeaders/runtime/DateMath.h: Removed.
        * ForwardingHeaders/wtf/DateMath.h: Copied from WebCore/ForwardingHeaders/runtime/DateMath.h.
        * platform/network/HTTPParsers.cpp:
        (WebCore::parseDate): Added.
        * platform/network/HTTPParsers.h:
        * platform/network/ResourceResponseBase.cpp:
        (WebCore::parseDateValueInHeader): Changed to use the new helper.

2009-06-08  Adam Langley  <agl@google.com>

        Reviewed by Eric Siedel.

        Chromium Linux ignored the background color on <select>s. Rather
        than encode magic colours, we start with a base color (specified
        via CSS) and derive the other colors from it. Thus, setting the
        CSS background-color now correctly changes the colour of the
        control.

        This should not change the appearence controls without
        background-colors. However, <select>s with a background-color
        will now renderer correctly, which may require rebaselining
        pixel tests in the Chromium tree.

        https://bugs.webkit.org/show_bug.cgi?id=26030
        http://code.google.com/p/chromium/issues/detail?id=12596

        * platform/graphics/Color.cpp:
        (WebCore::Color::getHSL): new member
        * platform/graphics/Color.h:
        * rendering/RenderThemeChromiumLinux.cpp:
        (WebCore::RenderThemeChromiumLinux::systemColor):
        (WebCore::brightenColor):
        (WebCore::paintButtonLike):

2009-06-08  Victor Wang <victorw@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26087
        Bug 26087: Removing element in JS crashes Chrome tab if it fired the change event

        Fix tab crash caused by destroying the popup list that fired the change event on abandon.

        If a popup list is abandoned (press a key to jump to an item
        and then use tab or mouse to get away from the select box),
        the current code fires a change event in PopupListBox::updateFromElemt().
        The JS that listens to this event may destroy the object and cause the
        rest of popup list code crashes.

        The updateFromElement() is called before abandon() and this causes
        the selected index to be discarded after updateFromElement(). From
        the code comments, this appears to be the reason why valueChanged is
        called in updateFromElement.

        Fix the issue by removing the valueChanged call in updateFromElement,
        saving the selected index that we should accept on abandon and pass
        it to the valueChange in abandon().

        A manual test has been added.

        * manual-tests/chromium: Added.
        * manual-tests/chromium/onchange-reload-popup.html: Added.
        * platform/chromium/PopupMenuChromium.cpp:
        (WebCore::PopupListBox::PopupListBox):
        (WebCore::PopupListBox::handleKeyEvent):
        (WebCore::PopupListBox::abandon):
        (WebCore::PopupListBox::updateFromElement):

2009-06-08  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Disable a few warnings on Windows

        * WebCore.pro:

2009-06-08  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Don't enable ENABLE_PLUGIN_PACKAGE_SIMPLE_HASH on Windows
        
        This define was brought in after refactoring some code from
        PluginPackage(Qt|Gtk).cpp into the shared PluginPackage.cpp.

        * WebCore.pro:

2009-06-08  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Use $QMAKE_PATH_SEP instead of hardcoded / to fix Windows build

        * WebCore.pro:

2009-06-08  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Ariya Hidayat.

        [Qt] Build fix when NETSCAPE_PLUGIN_API support is turned off
        https://bugs.webkit.org/show_bug.cgi?id=26244

        * WebCore.pro: Define PLUGIN_PACKAGE_SIMPLE_HASH only if
        NETSCAPE_PLUGIN_API is turned on
        * plugins/PluginPackage.cpp: Guard initializeBrowserFuncs()
        * plugins/PluginViewNone.cpp: Match guards with PluginView.h

2009-06-07  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        - fix <rdar://problem/6931661> -[WebView _selectionIsAll] returns YES
          when the selection is inside a text field.

        * editing/VisibleSelection.cpp:
        (WebCore::VisibleSelection::isAll): Return false if the selection is in
        a shadow tree.

2009-06-07  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=26106
        [GTK] Crashes when you keep a combo open during a page transition, then close it

        Hide the combo popup and disconnect from its signals during
        PopupMenu destruction to handle this exceptional case with no
        crash.

        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenu::~PopupMenu):
        (WebCore::PopupMenu::menuUnmapped):

2009-06-06  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Fix for <rdar://problem/6930540>
        REGRESSION (r43797): Serif and fantasy font-family names are wrong in result of getComputedStyle

        Test: fast/css/font-family-builtins.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::identifierForFamily): Fix typo. Fantasy family should be
        -webkit-fantasy not, -webkit-serif.

2009-06-06  Sam Weinig  <sam@webkit.org>

        Reviewed by Brady Eidson.

        Fix for <rdar://problem/6936235>
        Need to support StorageEvent.storageArea to meet the Web Storage spec

        * storage/LocalStorageArea.cpp:
        (WebCore::LocalStorageArea::dispatchStorageEvent): Pass the localStorage for
        the frame being dispatched to.
        * storage/SessionStorageArea.cpp:
        (WebCore::SessionStorageArea::dispatchStorageEvent): Ditto, only for sessionStorage.

        * storage/StorageEvent.cpp:
        (WebCore::StorageEvent::StorageEvent):
        (WebCore::StorageEvent::initStorageEvent):
        * storage/StorageEvent.h:
        (WebCore::StorageEvent::create):
        (WebCore::StorageEvent::storageArea):
        * storage/StorageEvent.idl:
        Add storageArea member.

2009-06-05  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Anders Carlsson.

        Fix WMLInputElement initialization code. Don't call initialize() on attach(), let
        WMLCardElement handle initialization once, after the document has been parsed.

        To keep layout tests working introduce a new function in Document.idl: initializeWMLPageState().
        WMLTestCase.js (the wml/ layout test framework) will use it to simulate a regular WML document,
        whose variable state gets initialized on WMLDocument::finishedParsing(). Force initialization
        of the WML variable state, right after the dynamically created elements have been inserted into the tree.

        * dom/Document.cpp:
        (WebCore::Document::initializeWMLPageState):
        * dom/Document.h:
        * dom/Document.idl:
        * wml/WMLCardElement.cpp:
        (WebCore::WMLCardElement::handleIntrinsicEventIfNeeded):
        * wml/WMLDocument.cpp:
        (WebCore::WMLDocument::finishedParsing):
        (WebCore::WMLDocument::initialize):
        * wml/WMLDocument.h:
        * wml/WMLInputElement.cpp:
        (WebCore::WMLInputElement::initialize):
        * wml/WMLInputElement.h:

2009-06-05  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Add ononline and onoffline attributes for the <body> element. 

        * html/HTMLAttributeNames.in: Added ononlineAttr and onofflineAttr.
        * html/HTMLBodyElement.cpp:
        (WebCore::HTMLBodyElement::parseMappedAttribute): Map ononlineAttr
        and onofflineAttr to window event listeners.

2009-06-05  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Add missing includes of config.h

        * platform/qt/QWebPopup.cpp:
        * platform/text/qt/TextBreakIteratorQt.cpp:

2009-06-05  Fumitoshi Ukai  <ukai@google.com>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26215
        Try to fix the Chromium build.

        * platform/graphics/chromium/GlyphPageTreeNodeChromiumWin.cpp:
        (WebCore::fillBMPGlyphs):
        (WebCore::fillNonBMPGlyphs):

2009-06-05  Shinichiro Hamaji  <hamaji@chromium.org>

        Bug 26160: Compile fails in MacOSX when GNU fileutils are installed

        <https://bugs.webkit.org/show_bug.cgi?id=26160>

        Reviewed by Alexey Proskuryakov.

        Use /bin/ln instead of ln for cases where this command is used with -h option.
        As this option is not supported by GNU fileutils, this change helps users 
        who have GNU fileutils in their PATH.

        * WebCore.xcodeproj/project.pbxproj:

2009-06-03  Ben Murdoch  <benm@google.com>

        <https://bugs.webkit.org/show_bug.cgi?id=25710> HTML5 Database stops executing transactions if the URL hash changes while a transaction is open and an XHR is in progress.

        Reviewed by Alexey Proskuryakov.

        Fix a bug that causes database transactions to fail if a history navigation to a hash fragment of the same document is made while resources (e.g. an XHR) are loading

        Test: storage/hash-change-with-xhr.html

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::stopLoading):
        * loader/DocumentLoader.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::stopLoading):
        (WebCore::FrameLoader::stopAllLoaders):
        * loader/FrameLoader.h:
        * loader/FrameLoaderTypes.h:
        (WebCore::):
        * page/Page.cpp:
        (WebCore::Page::goToItem):
        * WebCore.base.exp:

2009-06-03  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Make sure the correct config.h is included when shadowbuilding

        * WebCore.pro:

2009-06-05  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        Fix Qt build after r44452

        * platform/network/qt/QNetworkReplyHandler.cpp:
        (WebCore::QNetworkReplyHandler::sendResponseIfNeeded):

2009-06-05  Tor Arne Vestbø  <tor.arne.vestbo@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Remove some dead code (MenuEventProxy)

        * WebCore.pro:
        * platform/ContextMenu.h:
        * platform/qt/ContextMenuQt.cpp:
        * platform/qt/MenuEventProxy.h: Removed.

2009-06-05  Xan Lopez  <xlopez@igalia.com>

        More build fixes.

        * platform/graphics/gtk/GlyphPageTreeNodePango.cpp:
        (WebCore::GlyphPage::fill):

2009-06-05  Xan Lopez  <xlopez@igalia.com>

        Fix the GTK+ build.

        * GNUmakefile.am:
        * platform/graphics/gtk/FontCacheGtk.cpp:
        (WebCore::FontCache::getFontDataForCharacters):
        * platform/graphics/gtk/GlyphPageTreeNodeGtk.cpp:
        (WebCore::GlyphPage::fill):

2009-06-05  Antti Koivisto  <antti@apple.com>

        Try to fix Windows (and possibly other platforms) build.

        Restore ResourceResponseBase::lastModifiedDate() and setLastModifiedDate() removed in previous commit.
        for now since PluginStream used on some platforms expects them and calculations differ from plain 
        Last-modified header value.
        
        Also include <wtf/MathExtras.h> to get isfinite().

        * platform/network/ResourceResponseBase.cpp:
        (WebCore::ResourceResponseBase::adopt):
        (WebCore::ResourceResponseBase::copyData):
        (WebCore::ResourceResponseBase::setLastModifiedDate):
        (WebCore::ResourceResponseBase::lastModifiedDate):
        * platform/network/ResourceResponseBase.h:
        * platform/network/cf/ResourceResponseCFNet.cpp:
        (WebCore::ResourceResponse::platformLazyInit):

2009-06-03  Antti Koivisto  <antti@apple.com>

        Reviewed by Dave Kilzer.

        https://bugs.webkit.org/show_bug.cgi?id=13128
        Safari not obeying cache header
        
        Implement RFC 2616 cache expiration calculations in WebKit instead of
        relying on the networking layer.

        * ForwardingHeaders/runtime/DateMath.h: Added.
        * WebCore.base.exp:
        * loader/Cache.cpp:
        (WebCore::Cache::revalidationSucceeded):
        * loader/CachedResource.cpp:
        (WebCore::CachedResource::CachedResource):
        (WebCore::CachedResource::isExpired):
        (WebCore::CachedResource::currentAge):
        (WebCore::CachedResource::freshnessLifetime):
        (WebCore::CachedResource::setResponse):
        (WebCore::CachedResource::updateResponseAfterRevalidation):
        (WebCore::CachedResource::mustRevalidate):
        * loader/CachedResource.h:
        * platform/network/ResourceResponseBase.cpp:
        (WebCore::ResourceResponseBase::ResourceResponseBase):
        (WebCore::ResourceResponseBase::adopt):
        (WebCore::ResourceResponseBase::copyData):
        (WebCore::ResourceResponseBase::setHTTPHeaderField):
        (WebCore::ResourceResponseBase::parseCacheControlDirectives):
        (WebCore::ResourceResponseBase::cacheControlContainsNoCache):
        (WebCore::ResourceResponseBase::cacheControlContainsMustRevalidate):
        (WebCore::ResourceResponseBase::cacheControlMaxAge):
        (WebCore::parseDateValueInHeader):
        (WebCore::ResourceResponseBase::date):
        (WebCore::ResourceResponseBase::age):
        (WebCore::ResourceResponseBase::expires):
        (WebCore::ResourceResponseBase::lastModified):
        (WebCore::ResourceResponseBase::isAttachment):
        (WebCore::ResourceResponseBase::compare):
        * platform/network/ResourceResponseBase.h:
        * platform/network/cf/ResourceResponseCFNet.cpp:
        (WebCore::ResourceResponse::platformLazyInit):
        * platform/network/mac/ResourceResponseMac.mm:
        (WebCore::ResourceResponse::platformLazyInit):

2009-06-04  Roland Steiner <rolandsteiner@google.com>

        Reviewed by Eric Seidel.

        Bug 26201: Remove superfluous 'if' statements in RenderTable::addChild
        https://bugs.webkit.org/show_bug.cgi?id=26201

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::addChild): remove superfluous 'if' statements
       

2009-06-04  Roland Steiner <rolandsteiner@google.com>

        Reviewed by Eric Seidel.

        Bug 26202: add macros for primitive values to simplify CSSStyleSelector::applyProperty
        https://bugs.webkit.org/show_bug.cgi?id=26202

        * css/CSSStyleSelector.cpp: add HANDLE_INHERIT_AND_INITIAL_AND_PRIMITIVE[_WITH_VALUE] macros
        (WebCore::CSSStyleSelector::applyProperty): use new macros

2009-06-04  Roland Steiner <rolandsteiner@google.com>

        Reviewed by Eric Seidel

        Bug 26203: Move parsing of 'attr(X)' values to own method
        https://bugs.webkit.org/show_bug.cgi?id=26203

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseAttr): new method
        (WebCore::CSSParser::parseContent): use new parseAttr method
        * css/CSSParser.h:
        (WebCore::CSSParser::parseAttr): new method

2009-06-04  Roland Steiner <rolandsteiner@google.com>

        Reviewed by Eric Seidel.

        Bug 26205: RenderTableSection::addChild : correct comment
        https://bugs.webkit.org/show_bug.cgi?id=26205

        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::addChild): correct comment

2009-06-04  Roland Steiner <rolandsteiner@google.com>

        Reviewed by Eric Seidel.

        Bug 26204: RenderBlock : simplify handleSpecialChild, comment correction
        https://bugs.webkit.org/show_bug.cgi?id=26204

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::handleSpecialChild): simplify usage
        (WebCore::RenderBlock::handlePositionedChild): simplify usage
        (WebCore::RenderBlock::handleFloatingChild): simplify usage
        (WebCore::RenderBlock::handleRunInChild): simplify usage
        (WebCore::RenderBlock::layoutBlock): correct comment
        (WebCore::RenderBlock::layoutBlockChildren): simplify loop, change call to handleSpecialChild
        * rendering/RenderBlock.h: 
        (WebCore::RenderBlock::handleSpecialChild): change signature
        (WebCore::RenderBlock::handlePositionedChild): change signature
        (WebCore::RenderBlock::handleFloatingChild): change signature
        (WebCore::RenderBlock::handleRunInChild): change signature

2009-06-04  Dan Bernstein  <mitz@apple.com>

        - retry to fix the Tiger build

        * platform/graphics/mac/SimpleFontDataMac.mm:
        (WebCore::initFontData):

2009-06-04  Dan Bernstein  <mitz@apple.com>

        - try to fix the Tiger build

        * platform/graphics/SimpleFontData.h:

2009-06-04  Dan Bernstein  <mitz@apple.com>

        - try to fix the Leopard and Tiger builds

        * platform/graphics/SimpleFontData.h:

2009-06-04  Dan Bernstein  <mitz@apple.com>

        - try to fix the Windows build

        * platform/graphics/win/UniscribeController.cpp:
        (WebCore::UniscribeController::shapeAndPlaceItem):

2009-06-04  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        - make SimpleFontData's data members private
        - rename SimpleFontData's m_font member to m_platformData

        * platform/graphics/Font.h:
        (WebCore::Font::spaceWidth):
        * platform/graphics/SimpleFontData.cpp:
        (WebCore::SimpleFontData::SimpleFontData):
        * platform/graphics/SimpleFontData.h:
        (WebCore::SimpleFontData::platformData):
        (WebCore::SimpleFontData::spaceWidth):
        (WebCore::SimpleFontData::adjustedSpaceWidth):
        (WebCore::SimpleFontData::syntheticBoldOffset):
        (WebCore::SimpleFontData::spaceGlyph):
        (WebCore::SimpleFontData::getNSFont):
        (WebCore::SimpleFontData::getQtFont):
        (WebCore::SimpleFontData::getWxFont):
        * platform/graphics/WidthIterator.cpp:
        (WebCore::WidthIterator::advance):
        * platform/graphics/cairo/FontCairo.cpp:
        (WebCore::Font::drawGlyphs):
        * platform/graphics/chromium/SimpleFontDataChromiumWin.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::smallCapsFontData):
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        * platform/graphics/chromium/SimpleFontDataLinux.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::smallCapsFontData):
        (WebCore::SimpleFontData::containsCharacters):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        * platform/graphics/gtk/FontGtk.cpp:
        (WebCore::setPangoAttributes):
        * platform/graphics/gtk/SimpleFontDataGtk.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::containsCharacters):
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        (WebCore::SimpleFontData::setFont):
        * platform/graphics/gtk/SimpleFontDataPango.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::containsCharacters):
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        (WebCore::SimpleFontData::setFont):
        * platform/graphics/mac/CoreTextController.cpp:
        (WebCore::CoreTextController::adjustGlyphsAndAdvances):
        * platform/graphics/mac/FontMac.mm:
        (WebCore::Font::drawGlyphs):
        * platform/graphics/mac/FontMacATSUI.mm:
        (WebCore::initializeATSUStyle):
        (WebCore::overrideLayoutOperation):
        (WebCore::ATSULayoutParameters::initialize):
        * platform/graphics/mac/SimpleFontDataMac.mm:
        (WebCore::initFontData):
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformCharWidthInit):
        (WebCore::SimpleFontData::smallCapsFontData):
        (WebCore::SimpleFontData::containsCharacters):
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        (WebCore::SimpleFontData::checkShapesArabic):
        (WebCore::SimpleFontData::getCTFont):
        * platform/graphics/qt/SimpleFontDataQt.cpp:
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformCharWidthInit):
        * platform/graphics/win/FontCGWin.cpp:
        (WebCore::drawGDIGlyphs):
        (WebCore::Font::drawGlyphs):
        * platform/graphics/win/SimpleFontDataCGWin.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformCharWidthInit):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        * platform/graphics/win/SimpleFontDataCairoWin.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformDestroy):
        (WebCore::SimpleFontData::platformWidthForGlyph):
        (WebCore::SimpleFontData::setFont):
        * platform/graphics/win/SimpleFontDataWin.cpp:
        (WebCore::SimpleFontData::initGDIFont):
        (WebCore::SimpleFontData::smallCapsFontData):
        (WebCore::SimpleFontData::containsCharacters):
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::widthForGDIGlyph):
        (WebCore::SimpleFontData::scriptFontProperties):
        * platform/graphics/wx/SimpleFontDataWx.cpp:
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::platformWidthForGlyph):

2009-06-04  Paul Godavari  <paul@chromium.org>

        Reviewed by Eric Seidel.

        Initialize the width of PopupMenuListBox properly for Mac Chromium.

        Added a test that works only with this patch applied. The test is
        a manual one, since the hit testing infrastructure in the layout
        tests sends keyboard and mouse events to the main window and not
        the cocoa control that implements the popup up, which means we can't
        select items from the popup up.

        https://bugs.webkit.org/show_bug.cgi?id=25904


        * manual-tests/select-narrow-width.html: Added.
        * platform/chromium/PopupMenuChromium.cpp:
        (WebCore::PopupListBox::PopupListBox):
        (WebCore::PopupContainer::showExternal):

2009-06-04  Brent Fulgham  <bfulgham@webkit.org>

        Unreviewed Windows build correction.

        * WebCore.vcproj/WebCore.vcproj: Add missing 'ReplaceNodeWithSpanCommand.cpp'
          and 'ReplaceNodeWithSpanCommand.h'

2009-02-03  Eric Seidel  <eric@webkit.org>

        Reviewed by Justin Garcia.

        Make sure execCommand("bold") on <b style="text-decoration: underline">test</b>
        only removes the bold and not the underline.
        https://bugs.webkit.org/show_bug.cgi?id=23496

        Test: editing/execCommand/convert-style-elements-to-spans.html

        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSStyleDeclaration.h:
        (WebCore::CSSStyleDeclaration::isEmpty):
        * dom/NamedAttrMap.h:
        (WebCore::NamedAttrMap::isEmpty):
        * editing/ApplyStyleCommand.cpp:
        (WebCore::isUnstyledStyleSpan):
        (WebCore::isSpanWithoutAttributesOrUnstyleStyleSpan):
        (WebCore::ApplyStyleCommand::applyBlockStyle):
        (WebCore::ApplyStyleCommand::applyRelativeFontStyleChange):
        (WebCore::ApplyStyleCommand::implicitlyStyledElementShouldBeRemovedWhenApplyingStyle):
        (WebCore::ApplyStyleCommand::replaceWithSpanOrRemoveIfWithoutAttributes):
        (WebCore::ApplyStyleCommand::removeCSSStyle):
        (WebCore::ApplyStyleCommand::applyTextDecorationStyle):
        (WebCore::ApplyStyleCommand::removeInlineStyle):
        (WebCore::ApplyStyleCommand::addInlineStyleIfNeeded):
        * editing/ApplyStyleCommand.h:
        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::replaceNodeWithSpanPreservingChildrenAndAttributes):
        * editing/CompositeEditCommand.h:
        * editing/RemoveNodePreservingChildrenCommand.cpp:
        (WebCore::RemoveNodePreservingChildrenCommand::RemoveNodePreservingChildrenCommand):
        * editing/ReplaceNodeWithSpanCommand.cpp: Added.
        (WebCore::ReplaceNodeWithSpanCommand::ReplaceNodeWithSpanCommand):
        (WebCore::swapInNodePreservingAttributesAndChildren):
        (WebCore::ReplaceNodeWithSpanCommand::doApply):
        (WebCore::ReplaceNodeWithSpanCommand::doUnapply):
        * editing/ReplaceNodeWithSpanCommand.h: Added.
        (WebCore::ReplaceNodeWithSpanCommand::create):

2009-06-04  Brent Fulgham  <bfulgham@webkit.org>

        Unreviewed build fix for Windows Cairo target.

        Add missing post-build command to copy history/cf contents
        to output directory.

        * WebCore.vcproj/WebCore.vcproj: Update Debug_Cairo and Release_Cairo
          target post-build steps with copy commands.

2009-06-04  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Simon Fraser.

        <rdar://problem/6854695> Movie controller thumb fails to scale with full page zoom
        
        Account for zoom level when drawing media controller thumb on Windows.

        * rendering/RenderMediaControls.cpp:
        (WebCore::RenderMediaControls::adjustMediaSliderThumbSize):

2009-06-04  David Hyatt  <hyatt@apple.com>

        Reviewed by Sam Weinig.

        Move DOM window focus/blur out of SelectionController and into FocusController.  Make sure it
        fires on the focused frame when the page activation state changes also.  This is covered by an existing
        layout test (albeit badly).  I have modified the test to be correct.

        * editing/SelectionController.cpp:
        (WebCore::SelectionController::setFocused):
        * page/FocusController.cpp:
        (WebCore::FocusController::setFocusedFrame):
        (WebCore::FocusController::setActive):

2009-06-04  Albert J. Wong  <ajwong@chromium.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=26148
        Adding in empty files to stage the extract of RenderThemeChromiumSkia
        from RenderThemeChromiumLinux and RenderThemeChromiumWindows.

        * rendering/RenderThemeChromiumSkia.cpp: Added.
        * rendering/RenderThemeChromiumSkia.h: Added.

2009-06-04  Andrei Popescu <andreip@google.com>

        Reviewed by Alexey Proskuryakov.

        https://bugs.webkit.org/show_bug.cgi?id=25562
        Potential crash after ApplicationCacheStorage::storeNewestCache() fails

              Fix the crash by checking the return value of cacheStorage().storeNewestCache(this)
              in WebCore::ApplicationCacheGroup::checkIfLoadIsComplete. If storeNewestCache failed,
              we run the cache failure steps:

        1. Fire the error events to all pending master entries, as well any other cache hosts
           currently associated with a cache in this group.
        2. Disassociate the pending master entries from the failed new cache.
        3. Reinstate the old "newest cache", if there was one.

        We also introduce two other changes:

        1. a mechanism to rollback storageID changes to the in-memory resource
           objects when the storing of an ApplicationCache object fails.

        2. defer removing the pending master entries from the list of pending master entries
           until the entire load is complete. This matches the HTML 5 spec better. To track
           if the load is complete we now introduce a counter for those pending master entries
           that haven't yet finshed downloading.

        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::ApplicationCacheGroup): initializes the new counter to 0
        (WebCore::ApplicationCacheGroup::selectCache): increments the counter when a new pending
        master entry is added.
        (WebCore::ApplicationCacheGroup::finishedLoadingMainResource): decrements the counter
        instead of removing the pending master entry.
        (WebCore::ApplicationCacheGroup::failedLoadingMainResource): decrements the counter
        instead of removing the pending master entry.
        (WebCore::ApplicationCacheGroup::setNewestCache): removes an assertion that no longer
        holds true. In particular, the newest cache is not necessarily new anymore. We can
        set an old cache as the new cache. This can happen if we failed to store a newly
        downloaded cache to the database and we are now reinstating the former newest cache.
        (WebCore::ApplicationCacheGroup::manifestNotFound): resets the counter to 0.
        (WebCore::ApplicationCacheGroup::checkIfLoadIsComplete): check if the loading is complete
        based on the counter instead of the list of pending master entries. Empty the list of
        master entries if the load is complete.
        * loader/appcache/ApplicationCacheGroup.h: add the new counter.
        * loader/appcache/ApplicationCacheStorage.cpp: introduce the journaling mechanism for
        in-memory resource objects.
        (WebCore::ResourceStorageIDJournal::~ResourceStorageIDJournal):
        (WebCore::ResourceStorageIDJournal::add):
        (WebCore::ResourceStorageIDJournal::commit):
        (WebCore::ResourceStorageIDJournal::Record::Record):
        (WebCore::ResourceStorageIDJournal::Record::restore):
        (WebCore::ApplicationCacheStorage::store): log the changes to the in-memory resource
        objects.
        (WebCore::ApplicationCacheStorage::storeNewestCache): create the journal object.
        * loader/appcache/ApplicationCacheStorage.h:  modify the signature of
        bool store(ApplicationCache*) to add a pointer to the logger object used to
        trace the changes to the storageID of the resource objects.

2009-06-04  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=26154
        Allow underscores in the hostnames we parse out of databaseIdentifiers.
        This code is used for HTML 5 database support.

        * page/SecurityOrigin.cpp:
        (WebCore::SecurityOrigin::createFromDatabaseIdentifier):

2009-06-04  Mihnea Ovidenie  <mihnea@adobe.com>

        Reviewed by Darin Adler.

        Bug 26084: Multiple missing images in webkit-mask-image prevent rendering
        https://bugs.webkit.org/show_bug.cgi?id=26084

        When painting multiple images, make sure that at least one image is valid before pushing a transparency layer.

        Added a manual test.

        * manual-tests/mask-composite-missing-images.html: Added.
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::paintMaskImages):

2009-06-04  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=26180
        Add a fast path for SecurityOrigin::equal. If "other == this" (where
        other is the other security origin), then we really don't need to do
        all the other (expensive) comparisons. We know it's equal.

        * page/SecurityOrigin.cpp:
        (WebCore::SecurityOrigin::equal):

2009-06-03  David Hyatt  <hyatt@apple.com>

        Reviewed by Sam Weinig.

        Improvements in how selection behaves with focus/activation and a reversion back to using isActive
        in the scrollbar theme code to remove a Chromium ifdef.

        * editing/SelectionController.cpp:
        (WebCore::SelectionController::SelectionController):
        Make the controller set its focused state correctly upon initial creation.

        (WebCore::SelectionController::setSelection):
        Make selection willing to shift the focus node if the selection is focused even if the
        selection is not active.  Whether or not the Page is active is irrelevant to focus changes.

        (WebCore::SelectionController::setFocused):
        * editing/SelectionController.h:
        (WebCore::SelectionController::isFocused):
        Add a new isFocused() method so that code can check if the Selection is focused without caring
        about the active state.

        * page/Frame.cpp:
        (WebCore::Frame::setFocusedNodeIfNeeded):
        Allow focus shifts even when the selection is not active.

        * platform/mac/ScrollbarThemeMac.mm:
        (WebCore::ScrollbarThemeMac::paint):
        Revert Dan's change to directly talk to AppKit for checking active state.  Now that the WebCore isActive
        method works, ditch the Chromium-specific #ifdef and go back to the original code.

2009-06-04  Pierre d'Herbemont  <pdherbemont@apple.com>

        Reviewed by Darin Adler.

        Test: media/before-load-member-access.html
        
        https://bugs.webkit.org/show_bug.cgi?id=26081

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::played): Ensure that if m_playedTimeRanges,
        is not initialized we return a valid range, and don't attempt to use it.

2009-06-03  Kenneth Rohde Christiansen  <kenneth.christiansen@openbossa.org>

        Reviewed by Simon Hausmann.

        Implement a way to invalidate the FontCache used by the Qt port.

        * platform/graphics/qt/FontCacheQt.cpp:
        (WebCore::FontCache::invalidate):

2009-06-04  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Ariya Hidayat.

        https://bugs.webkit.org/show_bug.cgi?id=26015

        [Qt] Single-threaded QtWebKit configuration

        Turn off Database, DOM storage, icon database and Web Workers support
        when ENABLE_SINGLE_THREADED is turned on.

        Set SQLITE_THREADSAFE to false to turn off SQLite mutexes
        when ENABLE_SINGLE_THREADED is turned on.

        * WebCore.pro:

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        - add some assertions that Font methods are used on the main thread

        * platform/graphics/Font.cpp:
        (WebCore::Font::setShouldUseSmoothing):
        * platform/graphics/Font.h:
        (WebCore::Font::primaryFont):
        * platform/graphics/FontFastPath.cpp:
        (WebCore::Font::glyphDataForCharacter):

2009-06-03  Dan Bernstein  <mitz@apple.com>

        - Windows build fix

        Rolled out apparently-accidental changes to config.h from r44398. These
        were not part of the patch as reviewed.

        * config.h:

2009-06-03  Dmitry Titov  <dimich@chromium.org>

        Not reviewed, Chromium build fix.

        https://bugs.webkit.org/show_bug.cgi?id=26177
        Reverting 'private' to 'protected' on 2 classes.
        Chromium glue layer (not yet in Webkit tree) relies on ability to derive
        Chromium-specific platform classes and access the data members.
        See bug for more details.

        * platform/PlatformMouseEvent.h:
        * platform/PlatformWheelEvent.h:

2009-06-03  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Simon Fraser <simonfr@apple.com>.

        Fixed https://bugs.webkit.org/show_bug.cgi?id=26162

        This corrects an error when destroying an animation
        or transition where endAnimation was never getting
        called and therefore the hardware animation was never
        getting removed.

        This includes a manual-test since it's really impossible
        to make a meaningful automatic test for an animation
        bug like this.

        This has no effect unless accelerated compositing is 
        enabled.

        * manual-tests/interrupted-compound-transform.html: Added.
        * page/animation/ImplicitAnimation.cpp:
        (WebCore::ImplicitAnimation::~ImplicitAnimation):
        * page/animation/KeyframeAnimation.cpp:
        (WebCore::KeyframeAnimation::~KeyframeAnimation):

2009-06-03  Adam Langley  <agl@google.com>

        Reviewed by Eric Seidel.

        Make the scrollbar thumb size twice the width for Chromium Linux. This
        matches Firefox on Linux.

        This will need layout test pixel results to be rebaselined in the
        Chromium tree.

        http://code.google.com/p/chromium/issues/detail?id=12602
        https://bugs.webkit.org/show_bug.cgi?id=26176

        * platform/chromium/ScrollbarThemeChromiumLinux.cpp:
        (WebCore::ScrollbarThemeChromiumLinux::minimumThumbLength):
        * platform/chromium/ScrollbarThemeChromiumLinux.h:

2009-06-03  Adam Langley  <agl@google.com>

        Reviewed by Eric Seidel.

        Change Chromium scrollbar theme code to use different classes on
        Windows and Linux rather than suppling symbols. The ScrollbarTheme
        class is already using virtual dispatch, so there's no reason not to.

        This should not affect any layout tests.

        https://bugs.webkit.org/show_bug.cgi?id=26174

        * platform/chromium/ScrollbarThemeChromium.cpp:
        * platform/chromium/ScrollbarThemeChromium.h:
        * platform/chromium/ScrollbarThemeChromiumLinux.cpp:
        (WebCore::ScrollbarTheme::nativeTheme):
        (WebCore::ScrollbarThemeChromiumLinux::scrollbarThickness):
        (WebCore::ScrollbarThemeChromiumLinux::paintTrackPiece):
        (WebCore::ScrollbarThemeChromiumLinux::paintButton):
        (WebCore::ScrollbarThemeChromiumLinux::paintThumb):
        (WebCore::ScrollbarThemeChromiumLinux::buttonSize):
        * platform/chromium/ScrollbarThemeChromiumLinux.h: Added.
        * platform/chromium/ScrollbarThemeChromiumWin.cpp:
        (WebCore::ScrollbarTheme::nativeTheme):
        (WebCore::ScrollbarThemeChromiumWin::scrollbarThickness):
        (WebCore::ScrollbarThemeChromiumWin::invalidateOnMouseEnterExit):
        (WebCore::ScrollbarThemeChromiumWin::shouldSnapBackToDragOrigin):
        (WebCore::ScrollbarThemeChromiumWin::paintTrackPiece):
        (WebCore::ScrollbarThemeChromiumWin::paintButton):
        (WebCore::ScrollbarThemeChromiumWin::paintThumb):
        (WebCore::ScrollbarThemeChromiumWin::getThemeState):
        (WebCore::ScrollbarThemeChromiumWin::getThemeArrowState):
        (WebCore::ScrollbarThemeChromiumWin::getClassicThemeState):
        (WebCore::ScrollbarThemeChromiumWin::buttonSize):
        * platform/chromium/ScrollbarThemeChromiumWin.h: Added.

2009-06-03  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Enabling debugger requires that Scripts panel is already attached to the
        render tree. The reason is that recompile events result in script sources
        being added into the source frames. Prior to the global options introduced,
        debugger was enabled from the Scripts panel, so that it was guaranteed to
        exist. The InspectorController::enableDebugger API calls with no inspector
        frontend showing were failing though.

        https://bugs.webkit.org/show_bug.cgi?id=26145

        * WebCore.base.exp:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::setWindowVisible):
        (WebCore::InspectorController::scriptObjectReady):
        (WebCore::InspectorController::enableDebuggerFromFrontend):
        (WebCore::InspectorController::enableDebugger):
        * inspector/InspectorController.h:
        * inspector/InspectorController.idl:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::attachDebuggerWhenShown):
        * inspector/InspectorFrontend.h:
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.show):
        (WebInspector.ScriptsPanel.prototype.attachDebuggerWhenShown):
        * inspector/front-end/inspector.js:
        (WebInspector.attachDebuggerWhenShown):

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - fix a regression from the previous patch

        * platform/graphics/Font.cpp: Initialize shouldUseFontSmoothing to true.

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by Anders Carlsson.

        - eliminate WebCoreTextRenderer

        * WebCore.base.exp: Updated.
        * WebCore.xcodeproj/project.pbxproj: Removed WebCoreTextRenderer.{h,mm}
            and promoted WebFontCache.h to private.
        * platform/graphics/Font.cpp:
        (WebCore::Font::setShouldUseSmoothing): Added this static setter for
            a new file-static boolean.
        (WebCore::Font::shouldUseSmoothing): Added this static getter.
        * platform/graphics/Font.h: Decleared setShouldUseSmoothing() and
            shouldUseSmoothing().
        * platform/graphics/mac/FontMac.mm:
        (WebCore::Font::drawGlyphs): Use Font::shouldUseSmoothing() instead of
        WebCoreShouldUseFontSmoothing().
        * platform/graphics/mac/WebLayer.mm: Removed unneeded #import.
        * platform/mac/WebCoreTextRenderer.h: Removed.
        * platform/mac/WebCoreTextRenderer.mm: Removed.

2009-06-03  David Levin  <levin@chromium.org>

        Reviewed by Dimitri Glazkov.

        v8's ScriptController::evaluate should protect the Frame like the jsc version.
        https://bugs.webkit.org/show_bug.cgi?id=26172

        This change is simply copying protections done for Frame in the method
        WebCore::ScriptController::evaluate in the file js/ScriptController.cpp.

        * bindings/v8/ScriptController.cpp:
        (WebCore::ScriptController::evaluate):

2009-06-03  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/6841120> Use CTFontManager notifications instead
          of ATS notifications

        * platform/graphics/FontCache.h: Made it an error to destroy a
        FontCache instance.
        * platform/graphics/mac/FontCacheMac.mm:
        (WebCore::fontCacheRegisteredFontsChangedNotificationCallback): Added
        this notification callback for the
        kCTFontManagerRegisteredFontsChangedNotification, which calls
        invalidate().
        (WebCore::FontCache::platformInit): Register for
        kCTFontManagerRegisteredFontsChangedNotification.

2009-06-03  Kevin Watters  <kevinwatters@gmail.com>

        Reviewed by Kevin Ollivier.

        Use CGContextShowGlyphsWithAdvances to get more accurate text rendering on Mac.
        
        https://bugs.webkit.org/show_bug.cgi?id=26161

        * platform/wx/wxcode/mac/carbon/non-kerned-drawing.cpp:
        (WebCore::drawTextWithSpacing):

2009-06-03  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Reorder ResourcesPanel components initialization to unfreeze resource list scroller.

        https://bugs.webkit.org/show_bug.cgi?id=26159

        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel):

2009-06-03  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        - Fix for crash (preceded by assertion) in InspectorController::didCommitLoad
          when reloading or navigating with the Inspector open.
        - Fix for Inspector's Elements panel being empty when Inspector first appears.

        https://bugs.webkit.org/show_bug.cgi?id=26134
        https://bugs.webkit.org/show_bug.cgi?id=26135

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::scriptObjectReady):
        (WebCore::InspectorController::didLoadResourceFromMemoryCache):
        (WebCore::InspectorController::identifierForInitialRequest):
        (WebCore::InspectorController::ensureResourceTrackingSettingsLoaded):
        * inspector/InspectorController.h:

2009-06-03  Adam Roben  <aroben@apple.com>

        Windows build fix after r44379

        * svg/graphics/SVGImage.cpp: Move EmptyClients.h back down below the
        other #includes to fix a compiler warning on Windows.

2009-06-02  Kenneth Rohde Christiansen  <kenneth.christiansen@openbossa.org>

        Reviewed by Simon Hausmann.

        Add workaround for crash in Linux Flash Player when hosted by
        another toolkit than GTK+. Bug fixed at the Flash Player bugzilla,
        issue (FP-2140).

        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::setNPWindowIfNeeded):

2009-06-01  Kenneth Rohde Christiansen  <kenneth.christiansen@openbossa.org>

        Reviewed by Simon Hausmann.

        Refactor the Qt plugin code to use NPP_SetWindow correctly,
        to make resizing of plugins work.

        Attention was paid to make sure that the windowed plugins scroll
        synchronized with the page view. A manual test has been added.

        * manual-tests/qt/plugin-iframe.html: Added.
        * plugins/PluginView.cpp:
        (WebCore::PluginView::setFrameRect):
        (WebCore::PluginView::frameRectsChanged):
        * plugins/PluginView.h:
        * plugins/qt/PluginContainerQt.cpp:
        (PluginContainerQt::PluginContainerQt):
        * plugins/qt/PluginContainerQt.h:
        * plugins/qt/PluginPackageQt.cpp:
        (WebCore::PluginPackage::load):
        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::updatePluginWidget):
        (WebCore::PluginView::paint):
        (WebCore::PluginView::setParent):
        (WebCore::PluginView::setNPWindowRect):
        (WebCore::PluginView::setNPWindowIfNeeded):
        (WebCore::PluginView::handlePostReadFile):
        (WebCore::PluginView::getValue):
        (WebCore::PluginView::invalidateRect):
        (WebCore::PluginView::init):

2009-06-02  Darin Adler  <darin@apple.com>

        Reviewed by David Hyatt.

        Bug 26112: viewless WebKit -- make events work
        https://bugs.webkit.org/show_bug.cgi?id=26112

        The main fix here is to make mouse and wheel event coordinates in the coordinate
        system of the top level NSView rather than the NSWindow when in the viewless mode.
        This is the design Hyatt chose, but the event part of it wasn't done yet.

        Also fix FrameView to do normal reference counting instead of a strange model with
        an explicit deref near creation time.

        * WebCore.base.exp: Updated.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::eventLoopHandleMouseUp): Moved this function into the file
        to reduce conditionals in the header.
        (WebCore::EventHandler::eventLoopHandleMouseDragged): Ditto.

        * page/EventHandler.h: Reduced includes. Fixed formatting of Objective-C types.
        Made currentNSEvent a static member function. Added sendContextMenuEvent and
        eventMayStartDrag functions that takes NSEvent * so the conversion to PlatformMouseEvent
        can be done here rather than in WebKit. Reduced #if by making eventLoopHandleMouseUp and
        eventLoopHandleMouseDragged unconditional.

        * page/Frame.cpp:
        (WebCore::Frame::setView): Made this take a PassRefPtr since it takes ownership.
        (WebCore::Frame::createView): Changed to use RefPtr and FrameView::create and remove
        the explicit deref.

        * page/Frame.h: Changed setView to take a PassRefPtr.

        * page/FrameTree.cpp: Added newly-needed include.

        * page/FrameView.cpp:
        (WebCore::FrameView::FrameView): Got rid of one of the two constructors, and removed
        the initialization of m_refCount and call to show from the reamining one.
        (WebCore::FrameView::create): Added two create functions that do what the two
        constructors did before, except that they return a PassRefPtr to make sure the
        reference counting is handled correctly.
        (WebCore::FrameView::~FrameView): Removed assertion from when FrameView implemented
        its own reference counting.

        * page/FrameView.h: Inherit from RefCounted for reference counting. Made the
        constructor private and added create functions. Got rid of the hand-implemented
        reference counting in this class.

        * page/mac/EventHandlerMac.mm:
        (WebCore::currentNSEventSlot): Renamed currentEvent to currentNSEventSlot to
        make it more clear how it relates to currentNSEvent.
        (WebCore::EventHandler::currentNSEvent): Updated.
        (WebCore::CurrentEventScope::CurrentEventScope): Added. Use to set/reset the
        current event in a foolproof way.
        (WebCore::CurrentEventScope::~CurrentEventScope): Ditto.
        (WebCore::EventHandler::wheelEvent): Use CurrentEventScope. Pass the platform
        window in when constructing the PlatformWheelEvent.
        (WebCore::EventHandler::keyEvent): Use CurrentEventScope.
        (WebCore::lastEventIsMouseUp): Use currentNSEvent.
        (WebCore::EventHandler::passMouseDownEventToWidget): Ditto.
        (WebCore::EventHandler::eventLoopHandleMouseDragged): Ditto.
        (WebCore::EventHandler::eventLoopHandleMouseUp): Ditto.
        (WebCore::EventHandler::passSubframeEventToSubframe): Use
        currentPlatformMouseEvent to get a mouse event that has the appropriate
        platform window passed to create it.
        (WebCore::EventHandler::passWheelEventToWidget): Ditto.
        (WebCore::EventHandler::mouseDown): Ditto.
        (WebCore::EventHandler::mouseDragged): Ditto.
        (WebCore::EventHandler::mouseUp): Ditto.
        (WebCore::EventHandler::mouseMoved): Ditto.
        (WebCore::EventHandler::currentPlatformMouseEvent): Added. Passes the
        platform window that's now needed to create a PlatformMouseEvent.
        (WebCore::EventHandler::sendContextMenuEvent): Added.
        (WebCore::EventHandler::eventMayStartDrag): Added.

        * platform/HostWindow.h: Removed unneeded includes and constructor definition.

        * platform/PlatformMouseEvent.h: Sorted things in alphabetical order.
        Changed Mac constructor to take a windowView as well as the event. This is
        needed in viewless mode, since the "window" is actually an NSView, so the
        event has to know which view to compute the coordinates with. Made the
        same change to pointForEvent.
        * platform/PlatformWheelEvent.h: Ditto.

        * platform/mac/PlatformMouseEventMac.mm:
        (WebCore::pointForEvent): Convert point from window coordinates to view
        coordinates if a windowView is passed in. This is used in viewless mode.
        (WebCore::PlatformMouseEvent::PlatformMouseEvent): Ditto.
        * platform/mac/WheelEventMac.mm:
        (WebCore::PlatformWheelEvent::PlatformWheelEvent): Ditto.

        * platform/mac/WidgetMac.mm:
        (WebCore::Widget::convertFromContainingWindow): Fixed case where there
        is no platform widget and no parent. Before it would yield unpredictable
        results because of dispatching to a nil object and returning a structure.
        Now it returns the point without changing coordinates at all, which is what
        we need for this case in viewless mode.

        * rendering/RenderApplet.cpp: Removed unneeded includes.
        (WebCore::RenderApplet::intrinsicSize): Use widget function.
        (WebCore::RenderApplet::createWidgetIfNecessary): Ditto.

        * rendering/RenderApplet.h: Make more things private. Get rid of unneeded
        explicit destructor.

        * rendering/RenderFrame.cpp: Removed unneeded includes.
        (WebCore::RenderFrame::edgeInfo): Updated to use node function so header
        doesn't have to define element function.
        (WebCore::RenderFrame::viewCleared): Ditto. Also changed to use widget
        function.

        * rendering/RenderFrame.h: Removed unneeded includes. Made some things
        private. Got rid of element function.

        * rendering/RenderPart.cpp: Removed unneeded includes.
        (WebCore::RenderPart::~RenderPart): Changed to use clearWidget function.
        (WebCore::RenderPart::setWidget): Changed to use widget function.
        (WebCore::RenderPart::deleteWidget): Changed to use passed-in widget.
        This is now only called by the clearWidget function.

        * rendering/RenderPart.h: Removed unneeded forward declarations.
        Made more functions private. Updated deleteWidget to take widget argument.

        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::~RenderPartObject): use frameView function
        instead of getting at m_view directly.
        (WebCore::RenderPartObject::updateWidget): Ditto.
        (WebCore::RenderPartObject::layout): Ditto. Same for widget and m_widget.
        (WebCore::RenderPartObject::viewCleared): Ditto.

        * rendering/RenderPartObject.h: Made some functions private.

        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::RenderWidget): Initialize m_frameView with
        construction syntax instead of assignment.
        (WebCore::RenderWidget::destroy): Updated for name change of m_view
        to m_frameView.
        (WebCore::RenderWidget::~RenderWidget): Use clearWidget to delete
        the widget.
        (WebCore::RenderWidget::setWidget): Use clearWidget.
        (WebCore::RenderWidget::paint): Updated for name change of m_view
        to m_frameView.
        (WebCore::RenderWidget::deleteWidget): Changed to use passed-in widget.

        * rendering/RenderWidget.h: Made many functions protected, others
        private and made all data members private.

        * svg/animation/SMILTime.h: Removed unhelpful max and min functions. These
        just do what std::max and std::min will already do automatically for this
        type, so they are not helpful.

        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::SVGImage): Removed unneeded initial values for types
        that initialize to zero without anything explicit.
        (WebCore::SVGImage::~SVGImage): Update since m_frame and m_frameView are
        no longer stored.
        (WebCore::SVGImage::setContainerSize): Ditto.
        (WebCore::SVGImage::usesContainerSize): Ditto.
        (WebCore::SVGImage::size): Ditto.
        (WebCore::SVGImage::hasRelativeWidth): Ditto.
        (WebCore::SVGImage::hasRelativeHeight): Ditto.
        (WebCore::SVGImage::draw): Ditto.
        (WebCore::SVGImage::nativeImageForCurrentFrame): Ditto.
        (WebCore::SVGImage::dataChanged): Ditto.

        * svg/graphics/SVGImage.h: Removed unneeded includes and unneeded data
        members m_document, m_frame, m_frameView, and m_minSize.

2009-06-02  Adam Langley  <agl@google.com>

        Reviewed by Eric Seidel.

        The previous code was assuming that we'll be painting buttons on the scrollbar
        which isn't true on Linux. To reproduce, resize a page with scrollbars until
        they are less than two widths high.

        This will need pixel test baselines to be updated in the Chromium tree.

        * platform/chromium/ScrollbarThemeChromium.cpp: move this function...
        * platform/chromium/ScrollbarThemeChromiumWin.cpp:
        (WebCore::ScrollbarThemeChromium::trackRect): ... to here
        * platform/chromium/ScrollbarThemeChromiumLinux.cpp:
        (WebCore::ScrollbarThemeChromium::trackRect): add an alternative which
        doesn't remove the track when the scrollbar is less than two widths
        high.

2009-06-02  Mark Rowe  <mrowe@apple.com>

        Reviewed by Anders Carlsson.

        Remove workaround that was added to address <rdar://problem/5488678> as it no longer affects our Tiger builds.

        * Configurations/Base.xcconfig:

2009-06-02  Eric Seidel  <eric@webkit.org>

        Reviewed by Maciej Stachowiak.

        Insert*List on an stand-alone image in a content editable region ASSERTS
        ASSERTION FAILED: isStartOfParagraph(startOfParagraphToMove)
        https://bugs.webkit.org/show_bug.cgi?id=19066

        Attempt to fix this by noticing that we inserted the list inside
        the selection which includes the image, and re-adjust the selection
        to not include the list before trying to move the image into
        the list item.
        
        Test: editing/execCommand/list-wrapping-image-crash.html

        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::doApply):

2009-06-02  Eric Seidel  <eric@webkit.org>

        Reviewed by Darin Adler.

        Rename PositionIterator members in hope of further clarity
        https://bugs.webkit.org/show_bug.cgi?id=24854

        Rename m_parent to m_anchorNode (since although it's always the parent
        of the previous m_child member, it is not always the parent of the effective position)
        Rename m_child to m_nodeAfterPositionInAnchor to make clear that it's the node
        directly following the position.  This member is often NULL, but is always
        a child of m_parent, now m_anchorNode if set.
        Rename m_offset to m_offsetInAnchor (since it's interpreted relative to m_anchorNode)

        * dom/PositionIterator.cpp:
        (WebCore::PositionIterator::operator Position):
        (WebCore::PositionIterator::increment):
        (WebCore::PositionIterator::decrement):
        (WebCore::PositionIterator::atStart):
        (WebCore::PositionIterator::atEnd):
        (WebCore::PositionIterator::atStartOfNode):
        (WebCore::PositionIterator::atEndOfNode):
        (WebCore::PositionIterator::isCandidate):
        * dom/PositionIterator.h:
        (WebCore::PositionIterator::PositionIterator):
        (WebCore::PositionIterator::node):
        (WebCore::PositionIterator::offsetInLeafNode):

2009-06-02  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Eric Seidel.

        Bug 17167: Failures in fast/dom/Node/initial-values.html

        This partly solve a compatibility issue with other browsers. It will also
        make us more consistent while handling XHTML element.

        The issue is that when we create an XHTML element inside an HTML document
        (as it is the case when calling createElementNS), we default to the HTML
        behaviour in nodeName. As we cannot test if an HTMLElement is an XHTML
        element, our fix is to check whether it has a prefix and then default
        to XML behaviour for nodeName.

        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::nodeName): Add a prefix check before
        returning the uppercase tagName (HTML behaviour).

2009-06-02  Eric Seidel  <eric@webkit.org>

        Reviewed by Maciej Stachowiak.

        Add a compareBoundaryPoints which takes RangeBoundaryPoints
        https://bugs.webkit.org/show_bug.cgi?id=25500

        I noticed the need for this function when removing compareBoundaryPoints(Position, Position)
        This patch is almost entirely minus lines.

        No functional changes, thus no tests.

        * dom/Range.cpp:
        (WebCore::Range::setStart):
        (WebCore::Range::setEnd):
        (WebCore::Range::compareBoundaryPoints):
        (WebCore::Range::boundaryPointsValid):
        * dom/Range.h:

2009-06-02  Eric Seidel  <eric@webkit.org>

        Reviewed by Maciej Stachowiak.

        Remove Range::compareBoundaryPoints(Position, Position) per Darin's suggestion in bug 25056
        https://bugs.webkit.org/show_bug.cgi?id=25500

        Darin indicated the Range should deal only with primitive DOM node/offset
        pairs, and that Position (which is a more robust editing construct) should have
        its own comparison functions and that Range.h should not mention Position at all.

        Turns out that Position already has a comparePositions() function (which knows
        how to additionally handled positions in shadow trees).  So I've just changed
        all callers of compareBoundaryPoints(Position, Position) to use the existing
        comparePositions() function.  I've also added a comparePositions which takes
        VisiblePositions for convenience.

        * dom/Range.cpp:
        * dom/Range.h:
        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::updateStartEnd):
        (WebCore::ApplyStyleCommand::applyBlockStyle):
        (WebCore::ApplyStyleCommand::applyRelativeFontStyleChange):
        (WebCore::ApplyStyleCommand::applyInlineStyle):
        (WebCore::ApplyStyleCommand::applyInlineStyleToRange):
        (WebCore::ApplyStyleCommand::removeInlineStyle):
        (WebCore::ApplyStyleCommand::nodeFullySelected):
        (WebCore::ApplyStyleCommand::nodeFullyUnselected):
        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::deleteInsignificantText):
        (WebCore::CompositeEditCommand::moveParagraphContentsToNewBlockIfNecessary):
        (WebCore::CompositeEditCommand::moveParagraphs):
        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::initializeStartEnd):
        (WebCore::DeleteSelectionCommand::handleGeneralDelete):
        (WebCore::DeleteSelectionCommand::mergeParagraphs):
        * editing/SelectionController.cpp:
        (WebCore::SelectionController::nodeWillBeRemoved):
        * editing/VisibleSelection.cpp:
        (WebCore::VisibleSelection::toNormalizedRange):
        * editing/htmlediting.cpp:
        (WebCore::comparePositions):
        * editing/htmlediting.h:
        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMousePressEventSingleClick):

2009-06-02  Albert J. Wong  <ajwong@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26122
        Upstream v8_utility.h functions into V8Utilities.h.  This patch has
        some transitional code to make upstreaming easier.  This code will
        be deleted in a few days.

        * bindings/v8/ScriptFunctionCall.cpp:
        (WebCore::ScriptFunctionCall::construct): NewInstance -> newInstance.
        * bindings/v8/V8Utilities.h:
        (WebCore::AllowAllocation::AllowAllocation): Function added.
        (WebCore::AllowAllocation::~AllowAllocation): Function added.
        (WebCore::SafeAllocation::NewInstance): Function added.
        * bindings/v8/WorkerContextExecutionProxy.cpp:
        (WebCore::WorkerContextExecutionProxy::initContextIfNeeded):
        NewInstance -> newInstance.
        (WebCore::WorkerContextExecutionProxy::toV8): NewInstance ->
        newInstance.

2009-06-02  Dan Bernstein  <mitz@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/6940747> Search field’s focus ring is outset

        * rendering/RenderThemeWin.cpp:
        (WebCore::RenderThemeWin::adjustSearchFieldStyle): Set the focused
        search field outline offset to -2.

2009-06-02  Sam Weinig  <sam@webkit.org>

        Reviewed by Alexey Proskuryakov.

        Add list of unimplemented event handlers to DOMWindow.

        * page/DOMWindow.idl:

2009-06-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=26133
        Adapt and import py-dom-xpath tests

        Tests: fast/xpath/py-dom-xpath/abbreviations.html
               fast/xpath/py-dom-xpath/axes.html
               fast/xpath/py-dom-xpath/data.html
               fast/xpath/py-dom-xpath/expressions.html
               fast/xpath/py-dom-xpath/functions.html
               fast/xpath/py-dom-xpath/nodetests.html
               fast/xpath/py-dom-xpath/paths.html
               fast/xpath/py-dom-xpath/predicates.html

        Fix bugs found with this test suite:
        - name and local-name were incorrect for processing instructions (XPath expanded-name
        doesn't match DOM exactly);
        - name, local-name and namespace functions should crash on attribute nodes;
        - attemps to make node sets from other types were not detected as errors.

        No performance impact.

        * xml/XPathExpressionNode.h: Track type conversion errors that happen during evaluation.
        An error won't stop evaluation, but an exception will be raised afterwards. We could also
        detect conversion errors at compile time, but not if we're going to support XPath variables
        (which is unnecessary for XPathEvaluator, but will be necessary if we decide to make our own
        XSLT one day).

        * xml/XPathExpression.cpp: (WebCore::XPathExpression::evaluate): Check whether a type
        conversion exception occurred during evaluation, and raise an excpetion if it did.

        * xml/XPathFunctions.cpp:
        (WebCore::XPath::expandedNameLocalPart):
        (WebCore::XPath::expandedName):
        XPath name(), local-name() and namespace-uri() functions are defined in terms of expanded-name,
        which doesn't match anything available via DOM exactly. Calculate the expanded name properly.
        (WebCore::XPath::FunNamespaceURI::evaluate): This function could crash if used with an
        attribute node, because it released what was possibly the only reference to attribute node
        before using it. Changed the function to avoid such situation.
        (WebCore::XPath::FunLocalName::evaluate): Ditto. Also, used the new expandedNameLocalPart()
        to work properly with processing instruction nodes.
        (WebCore::XPath::FunName::evaluate): Ditto (using expandedName()).
        (WebCore::XPath::FunCount::evaluate): Signal an error if the argument is not a node-set
        (by using toNodeSet unconditionally, which will raise an error, and return an empty set).

        * xml/XPathPath.cpp: (WebCore::XPath::Filter::evaluate): Signal an error if the expression
        evaluation result is not a node-set.

        * xml/XPathPath.h: (WebCore::XPath::Filter::resultType): A Filter's result is actually
        always a node-set (this is not so for FilterExpr production in the spec, but is for us,
        because we don't naively map BNF productions to classes).

        * xml/XPathPredicate.cpp: (WebCore::XPath::Union::evaluate): Signal an error if either side
        is not a node-set.

        * xml/XPathStep.cpp: Removed an unnecesary include.

        * xml/XPathValue.cpp:
        (WebCore::XPath::Value::toNodeSet): Signal an error if conversion fails.
        (WebCore::XPath::Value::modifiableNodeSet): Ditto.
        (WebCore::XPath::Value::toNumber): Don't allow inputs that don't match XPath Number production
        (in particular, those using exponential notation).

2009-06-01  Sam Weinig  <sam@webkit.org>

        Reviewed by Brady Eidson.

        Part of https://bugs.webkit.org/show_bug.cgi?id=26100
        Add missing event handler properties to the DOMWindow

        Added oncontextmenu, oninput, and onmessage event handlers to
        the DOMWindow. Aditionally, the onloadstart, onprogress, onstalled,
        and onsuspend event handlers were implemented but not added to
        DOMWindow.idl.

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::oninput):
        (WebCore::DOMWindow::setOninput):
        (WebCore::DOMWindow::onmessage):
        (WebCore::DOMWindow::setOnmessage):
        (WebCore::DOMWindow::oncontextmenu):
        (WebCore::DOMWindow::setOncontextmenu):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:

2009-06-01  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Darin Adler.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26123

        Remove a redundant checkEncodedString call when constructing a
        KURL object from a string.

        * platform/KURL.cpp:
        (WebCore::KURL::KURL):

2009-06-01  Dimitri Glazkov  <dglazkov@chromium.org>

        Unreviewed, build fix.

        Reposition platform guard, improperly placed by http://trac.webkit.org/changeset/44340
        Bad Dimitri.

        * platform/KeyboardCodes.h: Repositioned the guard to avoid nested
            WebCore namespace declarations.

2009-06-01  Dimitri Glazkov  <dglazkov@chromium.org>

        Unreviewed, build fix.

        * platform/KeyboardCodes.h: Integrated contents of platform/chromium/KeyboardCodes.h
            with a stern FIXME.
        * platform/chromium/KeyboardCodes.h: Removed.

2009-06-01  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric Seidel.

        Fix assertion error in --filters enabled debug builds.
        Instead of using RefPtr<AtomicStringImpl> as keys for the hash maps in SVGFilterBuilder, just use AtomicString objects.

        * svg/graphics/filters/SVGFilterBuilder.cpp:
        (WebCore::SVGFilterBuilder::SVGFilterBuilder):
        (WebCore::SVGFilterBuilder::add):
        (WebCore::SVGFilterBuilder::getEffectById):
        * svg/graphics/filters/SVGFilterBuilder.h:

2009-06-01  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric Seidel.

        Fix --filters enabled build on Mac.
        Remove unnecessary 'boundingBox' parameter from finishRenderSVGContent() method.
        Kill several warnings, to make build pass.

        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::paint):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::paint):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::paint):
        * rendering/SVGRenderSupport.cpp:
        (WebCore::SVGRenderBase::finishRenderSVGContent):
        * rendering/SVGRenderSupport.h:
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBoxPaintWalker::chunkEndCallback):
        * svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::setStdDeviation):
        * svg/graphics/filters/SVGFEFlood.cpp:
        (WebCore::FEFlood::FEFlood):

2009-06-01  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Dave Hyatt.

        Fix Chromium build by adding an #ifdef, restoring the code path to that
        before http://trac.webkit.org/changeset/44287.

        * platform/mac/ScrollbarThemeMac.mm:
        (WebCore::ScrollbarThemeMac::paint): Added an #ifdef.

2009-06-01  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        Remove last pieces of the old SVG filter system. They are not
        usable with our current filter system. The new filter effects
        will replace the functionality step by step.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * svg/graphics/cairo: Removed.
        * svg/graphics/cairo/SVGResourceFilterCairo.cpp: Removed.
        * svg/graphics/cg: Removed.
        * svg/graphics/cg/SVGResourceFilterCg.cpp: Removed.
        * svg/graphics/cg/SVGResourceFilterCg.mm: Removed.
        * svg/graphics/filters/SVGFilterEffect.cpp: Removed.
        * svg/graphics/filters/SVGFilterEffect.h: Removed.
        * svg/graphics/filters/cg: Removed.
        * svg/graphics/filters/cg/SVGFEHelpersCg.h: Removed.
        * svg/graphics/filters/cg/SVGFEHelpersCg.mm: Removed.
        * svg/graphics/filters/cg/SVGFilterEffectCg.mm: Removed.
        * svg/graphics/filters/cg/WKArithmeticFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKArithmeticFilter.h: Removed.
        * svg/graphics/filters/cg/WKArithmeticFilter.m: Removed.
        * svg/graphics/filters/cg/WKComponentMergeFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKComponentMergeFilter.h: Removed.
        * svg/graphics/filters/cg/WKComponentMergeFilter.m: Removed.
        * svg/graphics/filters/cg/WKDiffuseLightingFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKDiffuseLightingFilter.h: Removed.
        * svg/graphics/filters/cg/WKDiffuseLightingFilter.m: Removed.
        * svg/graphics/filters/cg/WKDiscreteTransferFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKDiscreteTransferFilter.h: Removed.
        * svg/graphics/filters/cg/WKDiscreteTransferFilter.m: Removed.
        * svg/graphics/filters/cg/WKDisplacementMapFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKDisplacementMapFilter.h: Removed.
        * svg/graphics/filters/cg/WKDisplacementMapFilter.m: Removed.
        * svg/graphics/filters/cg/WKDistantLightFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKDistantLightFilter.h: Removed.
        * svg/graphics/filters/cg/WKDistantLightFilter.m: Removed.
        * svg/graphics/filters/cg/WKGammaTransferFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKGammaTransferFilter.h: Removed.
        * svg/graphics/filters/cg/WKGammaTransferFilter.m: Removed.
        * svg/graphics/filters/cg/WKIdentityTransferFilter.h: Removed.
        * svg/graphics/filters/cg/WKIdentityTransferFilter.m: Removed.
        * svg/graphics/filters/cg/WKLinearTransferFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKLinearTransferFilter.h: Removed.
        * svg/graphics/filters/cg/WKLinearTransferFilter.m: Removed.
        * svg/graphics/filters/cg/WKNormalMapFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKNormalMapFilter.h: Removed.
        * svg/graphics/filters/cg/WKNormalMapFilter.m: Removed.
        * svg/graphics/filters/cg/WKPointLightFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKPointLightFilter.h: Removed.
        * svg/graphics/filters/cg/WKPointLightFilter.m: Removed.
        * svg/graphics/filters/cg/WKSpecularLightingFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKSpecularLightingFilter.h: Removed.
        * svg/graphics/filters/cg/WKSpecularLightingFilter.m: Removed.
        * svg/graphics/filters/cg/WKSpotLightFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKSpotLightFilter.h: Removed.
        * svg/graphics/filters/cg/WKSpotLightFilter.m: Removed.
        * svg/graphics/filters/cg/WKTableTransferFilter.cikernel: Removed.
        * svg/graphics/filters/cg/WKTableTransferFilter.h: Removed.
        * svg/graphics/filters/cg/WKTableTransferFilter.m: Removed.
        * svg/graphics/mac: Removed.
        * svg/graphics/mac/SVGResourceFilterPlatformDataMac.h: Removed.
        * svg/graphics/mac/SVGResourceFilterPlatformDataMac.mm: Removed.
        * svg/graphics/qt: Removed.
        * svg/graphics/qt/SVGResourceFilterQt.cpp: Removed.
        * svg/graphics/skia: Removed.
        * svg/graphics/skia/SVGResourceFilterSkia.cpp: Removed.

2009-06-01  Dmitry Titov  <dimich@chromium.org>

        Fix the previous checkin (ttp://trac.webkit.org/changeset/44327).
        This adds a comment suggested during review.

        * platform/ThreadGlobalData.cpp:
        (WebCore::ThreadGlobalData::~ThreadGlobalData): Add comment clarifying the change.

2009-06-01  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=25973
        Avoid calling CurrentThread() in thread-specific destructors in OSX Chromium.
        Pthreads invoke thread-specific destructors after WTF::detachThread() is called and ThreadIdentifier
        for the thread removed from the WTF thread map. Calling CurrentThread() in such destructor causes
        the ThreadIdentifier to be re-created and inserted into the map again. Since Pthreads on OSX reuse
        the pthread_t between threads, the next created thread will have the same pthread_t and cause an assert
        in establishIdentifierForPthreadHandle() since the id is already in the map.

        The behavior is covered by existing test LayoutTests/fast/workers/worker-terminate.html, which currently fails
        on OSX Chromium and will stop failing after this change.

        * platform/ThreadGlobalData.h:
        * platform/ThreadGlobalData.cpp:
        (WebCore::ThreadGlobalData::~ThreadGlobalData):
        Store the result of "isMainThread()" in a member variable during construction of thread-specific data
        to avoid calling IsMainThread() in destructor, since the latter calls CurrentThread() in OSX Chromium.

2009-06-01  David Levin  <levin@chromium.org>

        Reviewed by Darin Alder and Maciej Stachowiak.

        Bug 26057: StringImpl should share buffers with UString.
        https://bugs.webkit.org/show_bug.cgi?id=26057

        This change results in the following performance improvements:
        On http://www.hixie.ch/tests/adhoc/perf/dom/artificial/core/001.html
        the time went from 78ms to 40ms for append (other times remained constant).

        On http://www.hixie.ch/tests/adhoc/perf/dom/artificial/core/002.html,
        the time went from 3900ms to 2600ms.

        For http://dromaeo.com/?dom, the time for DomModification improved by ~6%.
        Other tests in dom seemed to be faster across several runs but within the
        margin of error (except DOM Attributes which was slightly ~1.5% worse).

        Existing tests cover this code and there is no new functionality
        that is exposed to test.

        * platform/text/AtomicString.cpp:
        (WebCore::AtomicString::add):
        * platform/text/String.cpp:
        (WebCore::String::String):
        (WebCore::String::operator UString):
        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::StringImpl):
        (WebCore::StringImpl::~StringImpl):
        (WebCore::StringImpl::create): Consumes a shared buffer.
        (WebCore::StringImpl::ustring): Shares the StringImpl's buffer with the UString.
        (WebCore::StringImpl::sharedBuffer): Exposes the buffer that may be shared.
        * platform/text/StringImpl.h:
        (WebCore::StringImpl::hasTerminatingNullCharacter):
        (WebCore::StringImpl::inTable):
        (WebCore::StringImpl::setInTable): Converted the bools to be inside of PtrAndFlags
        to avoid growing StringImpl in size.

2009-06-01  Dimitri Glazkov  <dglazkov@chromium.org>

        Unreviewed, build fix.

        V8 bindings follow-up to to DOMWindow-related cleanup:
        http://trac.webkit.org/changeset/44215

        * bindings/v8/ScriptController.cpp: Removed disconnectFrame(), relocated
            its body to destructor.
        * bindings/v8/ScriptController.h: Removed disconnectFrame() decl.

2009-05-28  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        - Add panel enabler to the resources panel.
        - Add session / always options into the panel enabler.
        - Make enabled status for three panels sticky (globally).
        - Persist enabled status using InspectorController::Settings
        - Make InspectorController produce no network-related overhead when
          resources panel is not enabled.

        https://bugs.webkit.org/show_bug.cgi?id=26046

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::InspectorController):
        (WebCore::InspectorController::setWindowVisible):
        (WebCore::InspectorController::populateScriptObjects):
        (WebCore::InspectorController::identifierForInitialRequest):
        (WebCore::InspectorController::willSendRequest):
        (WebCore::InspectorController::didReceiveResponse):
        (WebCore::InspectorController::didReceiveContentLength):
        (WebCore::InspectorController::didFinishLoading):
        (WebCore::InspectorController::didFailLoading):
        (WebCore::InspectorController::resourceRetrievedByXMLHttpRequest):
        (WebCore::InspectorController::scriptImported):
        (WebCore::InspectorController::enableResourceTracking):
        (WebCore::InspectorController::disableResourceTracking):
        (WebCore::InspectorController::startUserInitiatedProfiling):
        (WebCore::InspectorController::enableProfiler):
        (WebCore::InspectorController::disableProfiler):
        (WebCore::InspectorController::enableDebugger):
        (WebCore::InspectorController::disableDebugger):
        * inspector/InspectorController.h:
        (WebCore::InspectorController::Setting::Setting):
        (WebCore::InspectorController::resourceTrackingEnabled):
        * inspector/InspectorController.idl:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::resourceTrackingWasEnabled):
        (WebCore::InspectorFrontend::resourceTrackingWasDisabled):
        * inspector/InspectorFrontend.h:
        * inspector/front-end/PanelEnablerView.js:
        (WebInspector.PanelEnablerView.enableOption):
        (WebInspector.PanelEnablerView):
        (WebInspector.PanelEnablerView.prototype._windowResized):
        (WebInspector.PanelEnablerView.prototype.alwaysWasChosen):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel.prototype._enableProfiling):
        (WebInspector.ProfilesPanel.prototype._toggleProfiling):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel):
        (WebInspector.ResourcesPanel.prototype.get statusBarItems):
        (WebInspector.ResourcesPanel.prototype.resourceTrackingWasEnabled):
        (WebInspector.ResourcesPanel.prototype.resourceTrackingWasDisabled):
        (WebInspector.ResourcesPanel.prototype.reset):
        (WebInspector.ResourcesPanel.prototype._updateSidebarWidth):
        (WebInspector.ResourcesPanel.prototype._enableResourceTracking):
        (WebInspector.ResourcesPanel.prototype._toggleResourceTracking):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._enableDebugging):
        (WebInspector.ScriptsPanel.prototype._toggleDebugging):
        * inspector/front-end/inspector.css:
        * inspector/front-end/inspector.js:
        (WebInspector.resourceTrackingWasEnabled):
        (WebInspector.resourceTrackingWasDisabled):

2009-06-01  Drew Wilson  <atwilson@google.com>

        Reviewed by Darin Adler.  Landed (and tweaked) by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=25902

        Added WorkerContext.close()

        Test: fast/workers/worker-close.html

        * workers/WorkerContext.cpp:
        (WebCore::WorkerContext::close):
        * workers/WorkerContext.h:
        * workers/WorkerContext.idl:
        * workers/WorkerMessagingProxy.cpp:
        (WebCore::WorkerMessagingProxy::workerContextDestroyedInternal):

2009-06-01  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=12471
        XPathResult not invalidated for documents retrieved via XMLHttpRequest

        Test: fast/xpath/detached-subtree-invalidate-iterator.html and existing tests in dom/svg/level3/xpath.

        Use DOM tree version instead of DOMSubtreeModified events to invalidate, which is more
        reliable and much faster.

        * xml/XPathExpression.cpp:
        (WebCore::XPathExpression::evaluate):
        * xml/XPathResult.cpp:
        (WebCore::XPathResult::XPathResult):
        (WebCore::XPathResult::~XPathResult):
        (WebCore::XPathResult::invalidIteratorState):
        (WebCore::XPathResult::iterateNext):
        * xml/XPathResult.h:
        (WebCore::XPathResult::create):

2009-06-01  Brett Wilson  <brettw@chromium.org>

        Reviewed by Darin Adler.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=25750

        Test: fast/transforms/bounding-rect-zoom.html

        Make getClientRects and getBoundingClientRect account for ther zoom
        factor.

        * dom/Element.cpp:
        (WebCore::adjustFloatPointForAbsoluteZoom):
        (WebCore::adjustFloatQuadForAbsoluteZoom):
        (WebCore::adjustIntRectForAbsoluteZoom):
        (WebCore::Element::getClientRects):
        (WebCore::Element::getBoundingClientRect):

2009-06-01  Tony Chang  <tony@chromium.org>

        Reviewed by Dimitri Glazkov.  Landed by Adam Barth.

        https://bugs.webkit.org/show_bug.cgi?id=26026

        Fix an infinite loop when using the keyboard in Chromium select
        popups.

        Not testable since it involves sending a keyboard event to
        the popup, which is not possible (eventSender sends the key
        events through webview, we want to go through the webwidget).

        * platform/chromium/PopupMenuChromium.cpp:

2009-06-01  Nate Chapin  <japhet@google.com>

        Reviewed by Dimitri Glazkov.  Landed by Adam Barth.

        If a url with an anchor is being loaded, ensure that the anchor remains locked in view until the page
        has finished loading compeltely or the user has manually scrolled.  Refreshing an anchor url after
        scrolling to a new location on the page will still result in jumping to the new location.
        
        https://bugs.webkit.org/show_bug.cgi?id=26034

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::gotoAnchor): Set anchor lock after navigating to anchor.
        (WebCore::FrameLoader::completed): Release anchor lock.
        * page/FrameView.cpp:
        (WebCore::FrameView::FrameView): Ensure anchor lock starts unset.
        (WebCore::FrameView::reset): Ensure anchor lock starts unset.
        (WebCore::FrameView::layout): If anchor lock is set, force a gotoAnchor() after layout.
        (WebCore::FrameView::scrollRectIntoViewRecursively): Release anchor lock if a programmatic scroll begins.
        (WebCore::FrameView::setWasScrolledByUser): Release anchor lock if user manually scrolls.
        (WebCore::FrameView::setScrollPosition): Release anchor lock if a programmatic scroll begins.
        * page/FrameView.h:
        (WebCore::FrameView::lockedToAnchor): Added.
        (WebCore::FrameView::setLockedToAnchor): Added.

2009-05-31  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        WebKit needs cross-platform filter system
        [https://bugs.webkit.org/show_bug.cgi?id=19991]

        A short clean-up. FilterBuilder is SVG specific. Move it
        to svg/graphics/filters and rename it to SVGFilterBuilder. 

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * svg/FilterBuilder.cpp: Removed.
        * svg/FilterBuilder.h: Removed.
        * svg/SVGFilterElement.cpp:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/graphics/SVGResourceFilter.cpp:
        (WebCore::SVGResourceFilter::SVGResourceFilter):
        * svg/graphics/SVGResourceFilter.h:
        (WebCore::SVGResourceFilter::builder):
        * svg/graphics/filters/SVGFilterBuilder.cpp: Added.
        (WebCore::SVGFilterBuilder::SVGFilterBuilder):
        (WebCore::SVGFilterBuilder::add):
        (WebCore::SVGFilterBuilder::getEffectById):
        (WebCore::SVGFilterBuilder::clearEffects):
        * svg/graphics/filters/SVGFilterBuilder.h: Added.
        (WebCore::SVGFilterBuilder::lastEffect):

2009-05-31  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=13233
        Need to implement an optimizing XPath evaluator

        Avoid sorting results of hierarchical paths that are naturally sorted. On a flat data structure
        with 128K nodes and a simple XPath expression, this changes evaluation time from 1.5 minutes
        to 33 ms.

        * xml/XPathNodeSet.h: Keep track of whether subtrees rooted at nodes in set are disjoint,
        which is useful for optimization.
        (WebCore::XPath::NodeSet::NodeSet): Removed, it was identical to compiler generated one.
        (WebCore::XPath::NodeSet::operator=): Ditto.
        (WebCore::XPath::NodeSet::swap): Ditto.
        (WebCore::XPath::NodeSet::isSorted): Single element sets are always sorted, even if sort()
        was never called.
        (WebCore::XPath::NodeSet::markSubtreesDisjoint): Just like being sorted, the new flag is
        maintained by callers.
        (WebCore::XPath::NodeSet::subtreesAreDisjoint): A single element set only has one subtree.
        Currently, the only way for a set to gain this flag is to be produced from a single element
        set with a hierarchical location path.

        * xml/XPathPath.cpp: (WebCore::XPath::LocationPath::evaluate): Use the new flag to avoid
        maintaining a set of unique nodes, and to avoid sorting the result.

2009-05-31  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=13233
        Need to implement an optimizing XPath evaluator

        This patch adds some infrastructure and simple optimizations. Namely,
        - we now avoid building a full NodeSet just to evaluate a predicate in some cases;
        - "/descendant-or-self::node()/child::" is optimized to iterate the tree once when possible;

        * xml/XPathExpressionNode.cpp:
        (WebCore::XPath::Expression::Expression):
        * xml/XPathExpressionNode.h:
        (WebCore::XPath::Expression::addSubExpression):
        (WebCore::XPath::Expression::isContextNodeSensitive):
        (WebCore::XPath::Expression::isContextPositionSensitive):
        (WebCore::XPath::Expression::isContextSizeSensitive):
        (WebCore::XPath::Expression::setIsContextNodeSensitive):
        (WebCore::XPath::Expression::setIsContextPositionSensitive):
        (WebCore::XPath::Expression::setIsContextSizeSensitive):
        XPath expression now knows its result type, and whether evaluation depends on context.

        * xml/XPathFunctions.cpp:
        (WebCore::XPath::FunLast::resultType):
        (WebCore::XPath::FunLast::FunLast):
        (WebCore::XPath::FunPosition::resultType):
        (WebCore::XPath::FunPosition::FunPosition):
        (WebCore::XPath::FunCount::resultType):
        (WebCore::XPath::FunId::resultType):
        (WebCore::XPath::FunLocalName::resultType):
        (WebCore::XPath::FunLocalName::FunLocalName):
        (WebCore::XPath::FunNamespaceURI::resultType):
        (WebCore::XPath::FunNamespaceURI::FunNamespaceURI):
        (WebCore::XPath::FunName::resultType):
        (WebCore::XPath::FunName::FunName):
        (WebCore::XPath::FunString::resultType):
        (WebCore::XPath::FunString::FunString):
        (WebCore::XPath::FunConcat::resultType):
        (WebCore::XPath::FunStartsWith::resultType):
        (WebCore::XPath::FunContains::resultType):
        (WebCore::XPath::FunSubstringBefore::resultType):
        (WebCore::XPath::FunSubstringAfter::resultType):
        (WebCore::XPath::FunSubstring::resultType):
        (WebCore::XPath::FunStringLength::resultType):
        (WebCore::XPath::FunStringLength::FunStringLength):
        (WebCore::XPath::FunNormalizeSpace::resultType):
        (WebCore::XPath::FunNormalizeSpace::FunNormalizeSpace):
        (WebCore::XPath::FunTranslate::resultType):
        (WebCore::XPath::FunBoolean::resultType):
        (WebCore::XPath::FunNot::resultType):
        (WebCore::XPath::FunTrue::resultType):
        (WebCore::XPath::FunFalse::resultType):
        (WebCore::XPath::FunLang::resultType):
        (WebCore::XPath::FunLang::FunLang):
        (WebCore::XPath::FunNumber::resultType):
        (WebCore::XPath::FunNumber::FunNumber):
        (WebCore::XPath::FunSum::resultType):
        (WebCore::XPath::FunFloor::resultType):
        (WebCore::XPath::FunCeiling::resultType):
        (WebCore::XPath::FunRound::resultType):
        (WebCore::XPath::Function::setArguments):
        Set optimization details for the expression. Normally, a function does not introduce context
        node set dependency, but some use context node as default argument, or otherwise use the context.

        * xml/XPathFunctions.h: Tweaked style.

        * xml/XPathPath.cpp:
        (WebCore::XPath::Filter::Filter): A filter is as context node set sensitive as its expression is.
        (WebCore::XPath::LocationPath::LocationPath): A location path can only be context node sensitive,
        and only if the path relative.
        (WebCore::XPath::LocationPath::appendStep): Invoke compile-time Step optimizations.
        (WebCore::XPath::LocationPath::insertFirstStep): Ditto.
        (WebCore::XPath::Path::Path): A path is as context node set sensitive as its filter is.

        * xml/XPathPath.h:
        (WebCore::XPath::Filter::resultType): Result type of a filter is the same as of its expression
        (useful filters return NodeSets, of course).
        (WebCore::XPath::LocationPath::setAbsolute): An absolute location path if context node set
        insensitive.
        (WebCore::XPath::LocationPath::resultType): A path's result is always a node set.
        (WebCore::XPath::Path::resultType): Ditto.

        * xml/XPathPredicate.h:
        (WebCore::XPath::Number::resultType): Return a proper result type.
        (WebCore::XPath::StringExpression::resultType): Ditto.
        (WebCore::XPath::Negative::resultType): Ditto.
        (WebCore::XPath::NumericOp::resultType): Ditto.
        (WebCore::XPath::EqTestOp::resultType): Ditto.
        (WebCore::XPath::LogicalOp::resultType): Ditto.
        (WebCore::XPath::Union::resultType): Ditto.
        (WebCore::XPath::Predicate::isContextPositionSensitive): A predicate can be context position
        sensitive even if its expression is not, because e.g. [5] is a shortcut for [position()=5].
        (WebCore::XPath::Predicate::isContextSizeSensitive): This matches expression result.

        * xml/XPathStep.h:
        (WebCore::XPath::Step::NodeTest::Kind): Removed unused ElementNodeTest, which was previously
        borrowed from XPath 2.0 to express some optimizations.
        (WebCore::XPath::Step::NodeTest::mergedPredicates): To avoid building a huge node set and
        filtering it with predicates, we now try to apply predicates while enumerating an axis.
        (WebCore::XPath::Step::nodeTest): Expose m_nodeTest.

        * xml/XPathStep.cpp:
        (WebCore::XPath::Step::~Step): The step owns NodeTest merged predicates, so it is still
        possible to copy NodeTests.
        (WebCore::XPath::Step::optimize): Merge predicates into NodeTest if possible.
        (WebCore::XPath::optimizeStepPair): Optimize some expressions containing "//".
        (WebCore::XPath::Step::predicatesAreContextListInsensitive): The above optimization is only
        possible if there are no context sensitive predicates for "//".
        (WebCore::XPath::Step::evaluate): Track context position for the first merged predicate.
        (WebCore::XPath::nodeMatchesBasicTest): Check whether the node matches node test, ignoring
        merged predicates.
        (WebCore::XPath::nodeMatches): Additionally check merged predicates, and update position.
        (WebCore::XPath::Step::nodesInAxis): Check merged predicates in optimized attribute code
        path.

        * xml/XPathVariableReference.h: (WebCore::XPath::VariableReference::resultType): Variable
        references are not used with XPathEvaluator, so we'll only need them if we decide to
        reimplement XSLT. The type of variable reference is not known at compile time.

2009-05-31  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Dan Bernstein.

        Remove unused JSEventTargetBase.h

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSEventTargetBase.h: Removed.

2009-05-31  Sam Weinig  <sam@webkit.org>

        Reviewed by Dan Bernstein.

        Part of https://bugs.webkit.org/show_bug.cgi?id=26100
        Add missing event handler properties to the DOMWindow

        Add missing oncanplay, oncanplaythrough, ondurationchange, onemptied,
        onended, onloadeddata, onloadedmetadata, onpause, onplay, onplaying,
        onratechange, onseeked, onseeking, ontimeupdate, onvolumechange,
        onwaiting, onloadstart, onprogress, onstalled, onsuspend, ondrag,
        ondragend, ondragenter, ondragleave, ondragover, ondragstart and 
        ondrop event handlers to the DOMWindow.

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::ondrag):
        (WebCore::DOMWindow::setOndrag):
        (WebCore::DOMWindow::ondragend):
        (WebCore::DOMWindow::setOndragend):
        (WebCore::DOMWindow::ondragenter):
        (WebCore::DOMWindow::setOndragenter):
        (WebCore::DOMWindow::ondragleave):
        (WebCore::DOMWindow::setOndragleave):
        (WebCore::DOMWindow::ondragover):
        (WebCore::DOMWindow::setOndragover):
        (WebCore::DOMWindow::ondragstart):
        (WebCore::DOMWindow::setOndragstart):
        (WebCore::DOMWindow::ondrop):
        (WebCore::DOMWindow::setOndrop):
        (WebCore::DOMWindow::oncanplay):
        (WebCore::DOMWindow::setOncanplay):
        (WebCore::DOMWindow::oncanplaythrough):
        (WebCore::DOMWindow::setOncanplaythrough):
        (WebCore::DOMWindow::ondurationchange):
        (WebCore::DOMWindow::setOndurationchange):
        (WebCore::DOMWindow::onemptied):
        (WebCore::DOMWindow::setOnemptied):
        (WebCore::DOMWindow::onended):
        (WebCore::DOMWindow::setOnended):
        (WebCore::DOMWindow::onloadeddata):
        (WebCore::DOMWindow::setOnloadeddata):
        (WebCore::DOMWindow::onloadedmetadata):
        (WebCore::DOMWindow::setOnloadedmetadata):
        (WebCore::DOMWindow::onpause):
        (WebCore::DOMWindow::setOnpause):
        (WebCore::DOMWindow::onplay):
        (WebCore::DOMWindow::setOnplay):
        (WebCore::DOMWindow::onplaying):
        (WebCore::DOMWindow::setOnplaying):
        (WebCore::DOMWindow::onratechange):
        (WebCore::DOMWindow::setOnratechange):
        (WebCore::DOMWindow::onseeked):
        (WebCore::DOMWindow::setOnseeked):
        (WebCore::DOMWindow::onseeking):
        (WebCore::DOMWindow::setOnseeking):
        (WebCore::DOMWindow::ontimeupdate):
        (WebCore::DOMWindow::setOntimeupdate):
        (WebCore::DOMWindow::onvolumechange):
        (WebCore::DOMWindow::setOnvolumechange):
        (WebCore::DOMWindow::onwaiting):
        (WebCore::DOMWindow::setOnwaiting):
        (WebCore::DOMWindow::onloadstart):
        (WebCore::DOMWindow::setOnloadstart):
        (WebCore::DOMWindow::onprogress):
        (WebCore::DOMWindow::setOnprogress):
        (WebCore::DOMWindow::onstalled):
        (WebCore::DOMWindow::setOnstalled):
        (WebCore::DOMWindow::onsuspend):
        (WebCore::DOMWindow::setOnsuspend):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:

2009-05-31  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Part of https://bugs.webkit.org/show_bug.cgi?id=26100
        Add missing event handler properties to the DOMWindow

        Add missing onstorage event handler to the DOMWindow.

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::onstorage):
        (WebCore::DOMWindow::setOnstorage):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:

2009-05-30  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=26110
        Update online/offline events to match the current spec.
        - Also adds window.ononline and window.onoffline event handler
          properties.

        * page/DOMWindow.cpp:
        (WebCore::DOMWindow::onoffline):
        (WebCore::DOMWindow::setOnoffline):
        (WebCore::DOMWindow::ononline):
        (WebCore::DOMWindow::setOnonline):
        * page/DOMWindow.h:
        * page/DOMWindow.idl:
        * page/Page.cpp:
        (WebCore::networkStateChanged):

2009-05-31  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        WebKit needs cross-platform filter system
        [https://bugs.webkit.org/show_bug.cgi?id=19991]

        Make use of the new filter system in WebCore for SVG. Deleted Mac bindings
        and replace it by a platform independent code. Calculation of subRegions
        is missing but needed for a first filter effect.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/filters/Filter.h:
        (WebCore::Filter::~Filter):
        (WebCore::Filter::setSourceImage):
        * rendering/SVGRenderSupport.cpp:
        (WebCore::SVGRenderBase::prepareToRenderSVGContent):
        (WebCore::SVGRenderBase::finishRenderSVGContent):
        * svg/FilterBuilder.h:
        (WebCore::FilterBuilder::lastEffect):
        * svg/SVGFEBlendElement.cpp:
        (WebCore::SVGFEBlendElement::SVGFEBlendElement):
        (WebCore::SVGFEBlendElement::build):
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::SVGFEColorMatrixElement):
        (WebCore::SVGFEColorMatrixElement::build):
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::SVGFEComponentTransferElement):
        (WebCore::SVGFEComponentTransferElement::build):
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::SVGFECompositeElement):
        (WebCore::SVGFECompositeElement::build):
        * svg/SVGFECompositeElement.h:
        * svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::SVGFEDiffuseLightingElement):
        (WebCore::SVGFEDiffuseLightingElement::build):
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDisplacementMapElement.cpp:
        (WebCore::SVGFEDisplacementMapElement::SVGFEDisplacementMapElement):
        (WebCore::SVGFEDisplacementMapElement::build):
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEFloodElement.cpp:
        (WebCore::SVGFEFloodElement::SVGFEFloodElement):
        (WebCore::SVGFEFloodElement::build):
        * svg/SVGFEFloodElement.h:
        * svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::SVGFEGaussianBlurElement):
        (WebCore::SVGFEGaussianBlurElement::build):
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::SVGFEImageElement):
        (WebCore::SVGFEImageElement::notifyFinished):
        (WebCore::SVGFEImageElement::build):
        * svg/SVGFEImageElement.h:
        * svg/SVGFEMergeElement.cpp:
        (WebCore::SVGFEMergeElement::SVGFEMergeElement):
        (WebCore::SVGFEMergeElement::build):
        * svg/SVGFEMergeElement.h:
        * svg/SVGFEOffsetElement.cpp:
        (WebCore::SVGFEOffsetElement::SVGFEOffsetElement):
        (WebCore::SVGFEOffsetElement::build):
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::SVGFESpecularLightingElement):
        (WebCore::SVGFESpecularLightingElement::build):
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFETileElement.cpp:
        (WebCore::SVGFETileElement::SVGFETileElement):
        (WebCore::SVGFETileElement::build):
        * svg/SVGFETileElement.h:
        * svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::SVGFETurbulenceElement):
        (WebCore::SVGFETurbulenceElement::build):
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFilterElement.cpp:
        (WebCore::SVGFilterElement::canvasResource):
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::setStandardAttributes):
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        (WebCore::SVGFilterPrimitiveStandardAttributes::contextElement):
        * svg/graphics/SVGResourceFilter.cpp:
        (WebCore::SVGResourceFilter::SVGResourceFilter):
        (WebCore::SVGResourceFilter::addFilterEffect):
        (WebCore::SVGResourceFilter::filterBBoxForItemBBox):
        (WebCore::SVGResourceFilter::prepareFilter):
        (WebCore::SVGResourceFilter::applyFilter):
        (WebCore::SVGResourceFilter::externalRepresentation):
        * svg/graphics/SVGResourceFilter.h:
        (WebCore::SVGResourceFilter::filterBoundingBox):
        (WebCore::SVGResourceFilter::setFilterBoundingBox):
        (WebCore::SVGResourceFilter::itemBoundingBox):
        (WebCore::SVGResourceFilter::setItemBoundingBox):
        (WebCore::SVGResourceFilter::builder):

2009-05-31  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        WebKit needs cross-platform filter system
        [https://bugs.webkit.org/show_bug.cgi?id=19991]

        Adding 'in1' attribute support for <feFlood>, as specified in SVG 1.1.
        This change helps creating test cases, once filters are activated.

        * svg/SVGFEFloodElement.cpp:
        (WebCore::SVGFEFloodElement::SVGFEFloodElement):
        (WebCore::SVGFEFloodElement::parseMappedAttribute):
        (WebCore::SVGFEFloodElement::build):
        * svg/SVGFEFloodElement.h:
        * svg/SVGFEFloodElement.idl:
        * svg/graphics/filters/SVGFEFlood.cpp:
        (WebCore::FEFlood::FEFlood):
        (WebCore::FEFlood::create):
        * svg/graphics/filters/SVGFEFlood.h:

2009-05-31  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        WebKit needs cross-platform filter system
        [https://bugs.webkit.org/show_bug.cgi?id=19991]

        Replace all occurrences of SVGResourceFilter by Filter. This is the last 
        step for a SVG independent filter system. Every other part of WebCore can
        use the filter system by creating a new Filter object.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/filters/FEBlend.cpp:
        (WebCore::FEBlend::apply):
        * platform/graphics/filters/FEBlend.h:
        * platform/graphics/filters/FEColorMatrix.cpp:
        (WebCore::FEColorMatrix::apply):
        * platform/graphics/filters/FEColorMatrix.h:
        * platform/graphics/filters/FEComponentTransfer.cpp:
        (WebCore::FEComponentTransfer::apply):
        * platform/graphics/filters/FEComponentTransfer.h:
        * platform/graphics/filters/FEComposite.cpp:
        (WebCore::FEComposite::apply):
        * platform/graphics/filters/FEComposite.h:
        * platform/graphics/filters/Filter.h: Added.
        (WebCore::Filter::setSourceImage):
        (WebCore::Filter::sourceImage):
        * platform/graphics/filters/FilterEffect.h:
        * platform/graphics/filters/SourceAlpha.cpp:
        (WebCore::SourceAlpha::apply):
        * platform/graphics/filters/SourceAlpha.h:
        * platform/graphics/filters/SourceGraphic.cpp:
        (WebCore::SourceGraphic::apply):
        * platform/graphics/filters/SourceGraphic.h:
        * svg/Filter.cpp: Removed.
        * svg/Filter.h: Removed.
        * svg/graphics/filters/SVGFEConvolveMatrix.cpp:
        (WebCore::FEConvolveMatrix::apply):
        * svg/graphics/filters/SVGFEConvolveMatrix.h:
        * svg/graphics/filters/SVGFEDiffuseLighting.cpp:
        (WebCore::FEDiffuseLighting::apply):
        * svg/graphics/filters/SVGFEDiffuseLighting.h:
        * svg/graphics/filters/SVGFEDisplacementMap.cpp:
        (WebCore::FEDisplacementMap::apply):
        * svg/graphics/filters/SVGFEDisplacementMap.h:
        * svg/graphics/filters/SVGFEFlood.cpp:
        (WebCore::FEFlood::apply):
        * svg/graphics/filters/SVGFEFlood.h:
        * svg/graphics/filters/SVGFEGaussianBlur.cpp:
        (WebCore::FEGaussianBlur::apply):
        * svg/graphics/filters/SVGFEGaussianBlur.h:
        * svg/graphics/filters/SVGFEImage.cpp:
        (WebCore::FEImage::apply):
        * svg/graphics/filters/SVGFEImage.h:
        * svg/graphics/filters/SVGFEMerge.cpp:
        (WebCore::FEMerge::apply):
        * svg/graphics/filters/SVGFEMerge.h:
        * svg/graphics/filters/SVGFEMorphology.cpp:
        (WebCore::FEMorphology::apply):
        * svg/graphics/filters/SVGFEMorphology.h:
        * svg/graphics/filters/SVGFEOffset.cpp:
        (WebCore::FEOffset::apply):
        * svg/graphics/filters/SVGFEOffset.h:
        * svg/graphics/filters/SVGFESpecularLighting.cpp:
        (WebCore::FESpecularLighting::apply):
        * svg/graphics/filters/SVGFESpecularLighting.h:
        * svg/graphics/filters/SVGFETile.cpp:
        (WebCore::FETile::apply):
        * svg/graphics/filters/SVGFETile.h:
        * svg/graphics/filters/SVGFETurbulence.cpp:
        (WebCore::FETurbulence::apply):
        * svg/graphics/filters/SVGFETurbulence.h:
        * svg/graphics/filters/SVGFilter.cpp: Added.
        (WebCore::SVGFilter::SVGFilter):
        (WebCore::SVGFilter::calculateEffectSubRegion):
        (WebCore::SVGFilter::create):
        * svg/graphics/filters/SVGFilter.h: Added.

2009-05-30  Kevin Ollivier  <kevino@theolliviers.com>

        Build fix for platforms without plugins support.

        * plugins/PluginViewNone.cpp:
        (WebCore::PluginView::userAgentStatic):
        (WebCore::PluginView::getValueStatic):

2009-05-30  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=25979

        Fix regression, local WML files won't load anymore, as the mimetype isn't correctly detected.    
        Bug filed at <rdar://problem/6917571> to cover this CFNetwork limitation.

        * platform/network/mac/ResourceHandleMac.mm:
        (-[WebCoreResourceHandleAsDelegate connection:didReceiveResponse:]):

2009-05-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=26091
        Make storage events match the current spec.
        - Storage event listeners are added to the window.
        - Storage events are dispatched to the window.

        Updated existing tests.

        * dom/Document.cpp:
        (WebCore::Document::dispatchWindowEvent):
        * dom/Document.h:
        * dom/Node.cpp:
        * dom/Node.h:
        * html/HTMLBodyElement.cpp:
        (WebCore::HTMLBodyElement::parseMappedAttribute):
        * storage/LocalStorageArea.cpp:
        (WebCore::LocalStorageArea::dispatchStorageEvent):
        * storage/SessionStorageArea.cpp:
        (WebCore::SessionStorageArea::dispatchStorageEvent):

2009-05-30  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson.

        Bug 26097: REGRESSION (r44283): Tab key doesn't work when focus is on a <select> element

        Test: fast/forms/focus-control-to-page.html

        * dom/SelectElement.h: Made destructor protected. Tweaked a bit.

        * html/HTMLSelectElement.cpp: Removed unneeded includes.
        (WebCore::HTMLSelectElement::remove): Removed unneeded range check of the
        result of optionToListIndex.
        (WebCore::HTMLSelectElement::parseMappedAttribute): Removed code to set the
        unused attribute, m_minwidth.
        (WebCore::HTMLSelectElement::defaultEventHandler): The actual bug fix.
        Call through to the base class defaultEventHandler if the event hasn't
        been handled yet.

        * html/HTMLSelectElement.h: Removed unneeded includes. Made a lot more functions
        private. Removed unused minWidth function and m_minwidth data member.

2009-05-30  Fridrich Strba  <fridrich.strba@bluewin.ch>

        Reviewed by Holger Freyther.

        The two KeyboardCodes.h files are basically identical and the
        qt one is properly #ifdef-ed for different win32 systems. Share
        them between Qt and Gtk implementations.

        * GNUmakefile.am:
        * platform/KeyboardCodes.h: Copied from WebCore/platform/qt/KeyboardCodes.h.
        * platform/gtk/KeyboardCodes.h: Removed.
        * platform/qt/KeyboardCodes.h: Removed.

2009-05-30  Jeremy Orlow  <jorlow@chromium.org>

        Reviewed by Sam Weinig.

        LocalStorage and SessionStorage's implicit setters do not correctly 
        handle null.  The custom JS bindings should convert to strings
        unconditionally and not try to handle null specially.
        https://bugs.webkit.org/show_bug.cgi?id=25970

        Tests: storage/domstorage/localstorage/string-conversion.html
               storage/domstorage/sessionstorage/string-conversion.html

        * bindings/js/JSStorageCustom.cpp:
        (WebCore::JSStorage::customPut):

2009-05-30  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - fix <rdar://problem/6935192> REGRESSION (Safari 3-TOT): Scroll
          bars in key window draw as inactive if the WebView is not active

        Test: platform/mac/scrollbars/key-window-not-first-responder.html

        * platform/mac/ScrollbarThemeMac.mm:
        (WebCore::ScrollbarThemeMac::paint): Use the window's key state instead
        of the WebView's first responder state to switch between active and
        inactive state.

2009-05-30  Dan Bernstein  <mitz@apple.com>

        Reviewed by Simon Fraser.

        - fix https://bugs.webkit.org/show_bug.cgi?id=18445
          <rdar://problem/5931174> Assertion failure in CSSGradientValue::image
          with -webkit-gradient as body's background

        Test: fast/backgrounds/body-generated-image-propagated-to-root.html

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintFillLayerExtended): Check if this
        is the root element painting a background layer propagated from the
        body, and if it is, use the body's renderer as the client to
        StyleImage::image().

2009-05-30  Holger Hans Peter Freyther  <zecke@selfish.org>

        Unreviewed build fix for AXObjectCache.

        For !HAVE(ACCESSIBILITY) postNotification was defined twice. Move
        that into the #ifdef.

        * accessibility/AXObjectCache.cpp:

2009-05-29  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=26072

        Add support for the last missing WML element: <select>. This patch adds WMLSelectElement, providing
        the same functionality HTMLSelectElement has. The WML specific features will follow soon.
    
        Add simple testcase covering <select> element rendering: fast/wml/select.wml

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/OptionElement.cpp:
        (WebCore::OptionElement::optionIndex):
        (WebCore::isOptionElement):
        * dom/OptionElement.h:
        * dom/OptionGroupElement.cpp:
        (WebCore::isOptionGroupElement):
        * dom/OptionGroupElement.h:
        * dom/SelectElement.cpp:
        (WebCore::SelectElement::accessKeySetSelectedIndex):
        (WebCore::toSelectElement):
        * dom/SelectElement.h:
        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::index):
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::accessKeySetSelectedIndex):
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::paintItemForeground):
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::itemIsEnabled):
        (WebCore::RenderMenuList::itemIsLabel):
        * wml/WMLFormControlElement.cpp:
        (WebCore::WMLFormControlElement::attach):
        (WebCore::WMLFormControlElement::recalcStyle):
        * wml/WMLFormControlElement.h:
        * wml/WMLInputElement.cpp:
        (WebCore::WMLInputElement::attach):
        * wml/WMLOptGroupElement.cpp:
        (WebCore::WMLOptGroupElement::insertBefore):
        (WebCore::WMLOptGroupElement::replaceChild):
        (WebCore::WMLOptGroupElement::removeChild):
        (WebCore::WMLOptGroupElement::appendChild):
        (WebCore::WMLOptGroupElement::removeChildren):
        (WebCore::ownerSelectElement):
        (WebCore::WMLOptGroupElement::accessKeyAction):
        (WebCore::WMLOptGroupElement::childrenChanged):
        (WebCore::WMLOptGroupElement::parseMappedAttribute):
        (WebCore::WMLOptGroupElement::attach):
        (WebCore::WMLOptGroupElement::detach):
        (WebCore::WMLOptGroupElement::recalcSelectOptions):
        * wml/WMLOptionElement.cpp:
        (WebCore::ownerSelectElement):
        (WebCore::WMLOptionElement::accessKeyAction):
        (WebCore::WMLOptionElement::childrenChanged):
        (WebCore::WMLOptionElement::parseMappedAttribute):
        (WebCore::WMLOptionElement::attach):
        (WebCore::WMLOptionElement::detach):
        (WebCore::WMLOptionElement::insertedIntoDocument):
        * wml/WMLSelectElement.cpp: Added.
        (WebCore::WMLSelectElement::WMLSelectElement):
        (WebCore::WMLSelectElement::~WMLSelectElement):
        (WebCore::WMLSelectElement::formControlType):
        (WebCore::WMLSelectElement::isKeyboardFocusable):
        (WebCore::WMLSelectElement::isMouseFocusable):
        (WebCore::WMLSelectElement::selectAll):
        (WebCore::WMLSelectElement::recalcStyle):
        (WebCore::WMLSelectElement::dispatchFocusEvent):
        (WebCore::WMLSelectElement::dispatchBlurEvent):
        (WebCore::WMLSelectElement::selectedIndex):
        (WebCore::WMLSelectElement::setSelectedIndex):
        (WebCore::WMLSelectElement::saveFormControlState):
        (WebCore::WMLSelectElement::restoreFormControlState):
        (WebCore::WMLSelectElement::childrenChanged):
        (WebCore::WMLSelectElement::parseMappedAttribute):
        (WebCore::WMLSelectElement::createRenderer):
        (WebCore::WMLSelectElement::appendFormData):
        (WebCore::WMLSelectElement::optionToListIndex):
        (WebCore::WMLSelectElement::listToOptionIndex):
        (WebCore::WMLSelectElement::reset):
        (WebCore::WMLSelectElement::defaultEventHandler):
        (WebCore::WMLSelectElement::accessKeyAction):
        (WebCore::WMLSelectElement::setActiveSelectionAnchorIndex):
        (WebCore::WMLSelectElement::setActiveSelectionEndIndex):
        (WebCore::WMLSelectElement::updateListBoxSelection):
        (WebCore::WMLSelectElement::listBoxOnChange):
        (WebCore::WMLSelectElement::menuListOnChange):
        (WebCore::WMLSelectElement::activeSelectionStartListIndex):
        (WebCore::WMLSelectElement::activeSelectionEndListIndex):
        (WebCore::WMLSelectElement::accessKeySetSelectedIndex):
        (WebCore::WMLSelectElement::setRecalcListItems):
        (WebCore::WMLSelectElement::scrollToSelection):
        (WebCore::WMLSelectElement::insertedIntoTree):
        * wml/WMLSelectElement.h: Added.
        (WebCore::WMLSelectElement::canSelectAll):
        (WebCore::WMLSelectElement::canStartSelection):
        (WebCore::WMLSelectElement::size):
        (WebCore::WMLSelectElement::multiple):
        (WebCore::WMLSelectElement::listItems):
        * wml/WMLTagNames.in:

2009-05-29  David Levin  <levin@chromium.org>

        Reviewed by NOBODY (build fix for windows).

        http://trac.webkit.org/changeset/44279 left in a "Vector<WCHAR> localeNameBuf"
        that it was trying to replace.  Resulting in this variable being defined twice (and
        the second time incorrectly).

        * platform/win/Language.cpp:
        (WebCore::localeInfo):

2009-05-29  Takeshi Yoshino  <tyoshino@google.com>

        Reviewed by Darin Alder.

        https://bugs.webkit.org/show_bug.cgi?id=26018

        Fix behavior of the Element View of the Web Inspector for double
        clicking the element outline tree.

        Double clicking the element outline tree should
        1) on attribute: enter attribute editing mode
        2) on text: enter text editing mode
        3) otherwise: change root node to the parent element of double clicked
           element.

        Now, 3) is broken. For example, clicking <html> clears the element
        outline view.

        rootDOMNode should be updated to this.representedObject.parentNode, not
        this.parent.representedObject which is parent inside the element
        outline tree itself.

        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype.ondblclick):

2009-05-29  David Moore  <davemoore@google.com>

        Reviewed by Darin Alder.

        https://bugs.webkit.org/show_bug.cgi?id=26001
        Change many of the uses of String::adopt() to String::createUninitialized().
        This allows those strings to use an inlined buffer for their characters.

        * dom/StyleElement.cpp:
        Loop over nodes to precompute length of string and then
        write the characters into the allocated inline buffer
        (WebCore::StyleElement::process):
        * dom/Text.cpp:
        Loop over nodes to precompute length of string and then
        write the characters into the allocated inline buffer
        (WebCore::Text::wholeText):
        (WebCore::Text::rendererIsNeeded):
        (WebCore::Text::createRenderer):
        (WebCore::Text::createWithLengthLimit):
        (WebCore::Text::formatForDebugger):
        * platform/text/String.cpp:
        (WebCore::String::append):
        (WebCore::String::insert):
        (WebCore::String::truncate):
        (WebCore::String::remove):
        * platform/text/StringBuilder.cpp:
        (WebCore::StringBuilder::toString):
        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::lower):
        (WebCore::StringImpl::upper):
        (WebCore::StringImpl::secure):
        (WebCore::StringImpl::foldCase):
        (WebCore::StringImpl::replace):
        * platform/text/TextCodecLatin1.cpp:
        (WebCore::TextCodecLatin1::decode):
        * platform/text/TextCodecUserDefined.cpp:
        (WebCore::TextCodecUserDefined::decode):
        * platform/win/Language.cpp:
        (WebCore::localeInfo):

2009-05-29  Takeshi Yoshino  <tyoshino@google.com>

        Reviewed by Darin Alder.

        Bug 25911: Apply href in base elements to anchors shown on the source viewer
        https://bugs.webkit.org/show_bug.cgi?id=25911

        In rendering HTML sources, parse base elements to apply the base URI to
        anchors shown on the source viewer.

        This issue was originally reported to the Chromium issue tracker.
        http://code.google.com/p/chromium/issues/detail?id=2418

        Test: fast/frames/viewsource-link-on-href-value.html

        * html/HTMLViewSourceDocument.cpp:
        (WebCore::HTMLViewSourceDocument::addViewSourceToken):

2009-05-29  Rob Buis  <rwlbuis@gmail.com>

        Reviewed by David Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=22429
        document.styleSheets collection ignores media=presentation

        Ensure that stylesheets though <link> show up in document.styleSheets regardless of media attribute.

        Test: fast/css/sheet-collection-link.html

        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::process):

2009-05-29  Jian Li  <jianli@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26069
        Fix a crash in custom V8 bindings code for XMLHttpRequest.

        Test: fast/xmlhttprequest/xmlhttprequest-open-after-iframe-onload-remove-self.html

        * bindings/v8/custom/V8XMLHttpRequestCustom.cpp:
        (WebCore::CALLBACK_FUNC_DECL):

2009-05-29  David Levin  <levin@chromium.org>

        Reviewed by Darin Adler.

        Bug 26074: SQLTransaction::executeSQL does an unnecessary call to String::copy.
        https://bugs.webkit.org/show_bug.cgi?id=26074

        The constructor for SQLStatement already does a copy for this string.

        * storage/SQLTransaction.cpp:
        (WebCore::SQLTransaction::executeSQL):

2009-05-29  Darin Adler  <darin@apple.com>

        Fix build; the new Cairo code compiled on Windows only.

        * platform/graphics/gtk/FontPlatformData.h: Added syntheticBold
        and syntheticOblique functions as in the Windows version to make it
        easier to use this cross-platform. Later we can make data members
        private as in the Windows version.
        * platform/graphics/mac/FontPlatformData.h: Ditto.

2009-05-29  Alexander Macdonald  <alexmac@adobe.com>

        Reviewed by Darin Adler.

        Added support for synthetic bold/oblique font rendering
        on platforms that use cairo.

        * platform/graphics/SimpleFontData.h:
        * platform/graphics/cairo/FontCairo.cpp:
        (WebCore::Font::drawGlyphs):
        * platform/graphics/gtk/SimpleFontDataGtk.cpp:
        (WebCore::SimpleFontData::platformInit):
        * platform/graphics/gtk/SimpleFontDataPango.cpp:
        (WebCore::SimpleFontData::platformInit):
        * platform/graphics/win/SimpleFontDataCairoWin.cpp:
        (WebCore::SimpleFontData::platformInit):

2009-05-29  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Beth Dakin.

        Bug 26024: AX: possible to fail assertion because AXPostNotification calls accessibilityIsIgnored
        https://bugs.webkit.org/show_bug.cgi?id=26024

        AX notifications are posted after a one shot timer so that notifications are not performed mid-layout.
        Consolidated postNotification and postNotificationToElement into one method.

        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::AXObjectCache):
        (WebCore::AXObjectCache::notificationPostTimerFired):
        (WebCore::AXObjectCache::postNotification):
        (WebCore::AXObjectCache::selectedChildrenChanged):
        * accessibility/AXObjectCache.h:
        (WebCore::AXObjectCache::postNotification):
        (WebCore::AXObjectCache::postPlatformNotification):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::handleActiveDescendantChanged):
        * accessibility/chromium/AXObjectCacheChromium.cpp:
        (WebCore::AXObjectCache::postPlatformNotification):
        * accessibility/gtk/AXObjectCacheAtk.cpp:
        (WebCore::AXObjectCache::postPlatformNotification):
        * accessibility/mac/AXObjectCacheMac.mm:
        (WebCore::AXObjectCache::postPlatformNotification):
        * accessibility/win/AXObjectCacheWin.cpp:
        (WebCore::AXObjectCache::postPlatformNotification):
        * dom/Document.cpp:
        (WebCore::Document::implicitClose):
        * editing/Editor.cpp:
        (WebCore::Editor::respondToChangedContents):
        * editing/mac/SelectionControllerMac.mm:
        (WebCore::SelectionController::notifyAccessibilityForSelectionChange):
        * page/FrameView.cpp:
        (WebCore::FrameView::layout):
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::setInnerTextValue):

2009-05-29  Brent Fulgham  <bfulgham@webkit.org>

        Reviewed by Adam Roben.

        Build fix for Windows Cairo target.
        https://bugs.webkit.org/show_bug.cgi?id=25972

        Compiler mistakenly selects SMILTime min/max instead of STL version,
        resulting in a build error.  This change makes the meaning of the
        min/max explicit and avoids the problem.

        * html/TimeRanges.h:
        (WebCore::TimeRanges::Range::unionWithOverlappingOrContiguousRange):

2009-05-29  Gustavo Noronha Silva  <gns@gnome.org>

        Reviewed by Jan Alonzo.

        Make SoupMessage a member of ResourceRequest, instead of creating
        it in startHttp. Implement updating of ResourceRequest from
        SoupMessage, and vice versa.

        * GNUmakefile.am:
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::~ResourceHandle):
        (WebCore::gotHeadersCallback):
        (WebCore::ResourceHandle::startHttp):
        * platform/network/soup/ResourceRequest.h:
        (WebCore::ResourceRequest::ResourceRequest):
        (WebCore::ResourceRequest::~ResourceRequest):
        * platform/network/soup/ResourceRequestSoup.cpp: Added.
        (WTF::SoupURI):
        (WebCore::ResourceRequest::soupMessage):
        (WebCore::ResourceRequest::ResourceRequest):
        (WebCore::ResourceRequest::doUpdateResourceRequest):
        (WebCore::ResourceRequest::doUpdatePlatformRequest):

2009-05-28  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26068
        V8: Remove the remaining b8::Locker usage in worker code.
        This completes the fix for https://bugs.webkit.org/show_bug.cgi?id=25944,
        since the patches for enabling timers and that bug have "crossed in the queue".
        Existing LayoutTests/fast/workers/worker-timeout.html covers this fix (will start work in Chromium).

        * bindings/v8/ScheduledAction.cpp:
        (WebCore::ScheduledAction::execute):

2009-05-28  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Reviewed by Xan Lopez.

        Simplify the Accept-Encoding header we are sending out, for it
        seems some servers do not enjoy parsing the full, explicit
        version.

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::startHttp):

2009-05-28  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        Added a new build flag --filters. This replaces the old --svg-filters and enables
        other parts of WebKit to use some basic filters of platform/graphics/filters if needed.
        This patch also fixes a bug in dom/DOMImplementation.cpp where we used SVG_FILTER. This flag
        doesn't exist and was replaced by FILTERS as well as all SVG_FILTERS occurrences.
        Filters are not working yet. This patch is just a preperation. Filters are deactivated by
        default. 

        * Configurations/FeatureDefines.xcconfig:
        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.pro:
        * bindings/objc/DOM.mm:
        (WebCore::createElementClassMap):
        * dom/DOMImplementation.cpp:
        (WebCore::isSVG10Feature):
        (WebCore::isSVG11Feature):
        * page/DOMWindow.idl:
        * platform/graphics/filters/FEBlend.cpp:
        * platform/graphics/filters/FEBlend.h:
        * platform/graphics/filters/FEColorMatrix.cpp:
        * platform/graphics/filters/FEColorMatrix.h:
        * platform/graphics/filters/FEComponentTransfer.cpp:
        * platform/graphics/filters/FEComponentTransfer.h:
        * platform/graphics/filters/FEComposite.cpp:
        * platform/graphics/filters/FEComposite.h:
        * platform/graphics/filters/FilterEffect.cpp:
        * platform/graphics/filters/FilterEffect.h:
        * platform/graphics/filters/SourceAlpha.cpp:
        * platform/graphics/filters/SourceAlpha.h:
        * platform/graphics/filters/SourceGraphic.cpp:
        * platform/graphics/filters/SourceGraphic.h:
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::selfWillPaint):
        * rendering/RenderSVGModelObject.cpp:
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::selfWillPaint):
        * rendering/SVGRenderSupport.cpp:
        (WebCore::SVGRenderBase::prepareToRenderSVGContent):
        (WebCore::SVGRenderBase::finishRenderSVGContent):
        (WebCore::SVGRenderBase::filterBoundingBoxForRenderer):
        * svg/Filter.cpp:
        * svg/Filter.h:
        * svg/FilterBuilder.cpp:
        * svg/FilterBuilder.h:
        * svg/SVGComponentTransferFunctionElement.cpp:
        * svg/SVGComponentTransferFunctionElement.h:
        * svg/SVGComponentTransferFunctionElement.idl:
        * svg/SVGFEBlendElement.cpp:
        * svg/SVGFEBlendElement.h:
        * svg/SVGFEBlendElement.idl:
        * svg/SVGFEColorMatrixElement.cpp:
        * svg/SVGFEColorMatrixElement.h:
        * svg/SVGFEColorMatrixElement.idl:
        * svg/SVGFEComponentTransferElement.cpp:
        * svg/SVGFEComponentTransferElement.h:
        * svg/SVGFEComponentTransferElement.idl:
        * svg/SVGFECompositeElement.cpp:
        * svg/SVGFECompositeElement.h:
        * svg/SVGFECompositeElement.idl:
        * svg/SVGFEDiffuseLightingElement.cpp:
        * svg/SVGFEDiffuseLightingElement.h:
        * svg/SVGFEDiffuseLightingElement.idl:
        * svg/SVGFEDisplacementMapElement.cpp:
        * svg/SVGFEDisplacementMapElement.h:
        * svg/SVGFEDisplacementMapElement.idl:
        * svg/SVGFEDistantLightElement.cpp:
        * svg/SVGFEDistantLightElement.h:
        * svg/SVGFEDistantLightElement.idl:
        * svg/SVGFEFloodElement.cpp:
        * svg/SVGFEFloodElement.h:
        * svg/SVGFEFloodElement.idl:
        * svg/SVGFEFuncAElement.cpp:
        * svg/SVGFEFuncAElement.h:
        * svg/SVGFEFuncAElement.idl:
        * svg/SVGFEFuncBElement.cpp:
        * svg/SVGFEFuncBElement.h:
        * svg/SVGFEFuncBElement.idl:
        * svg/SVGFEFuncGElement.cpp:
        * svg/SVGFEFuncGElement.h:
        * svg/SVGFEFuncGElement.idl:
        * svg/SVGFEFuncRElement.cpp:
        * svg/SVGFEFuncRElement.h:
        * svg/SVGFEFuncRElement.idl:
        * svg/SVGFEGaussianBlurElement.cpp:
        * svg/SVGFEGaussianBlurElement.h:
        * svg/SVGFEGaussianBlurElement.idl:
        * svg/SVGFEImageElement.cpp:
        * svg/SVGFEImageElement.h:
        * svg/SVGFEImageElement.idl:
        * svg/SVGFELightElement.cpp:
        * svg/SVGFELightElement.h:
        * svg/SVGFEMergeElement.cpp:
        * svg/SVGFEMergeElement.h:
        * svg/SVGFEMergeElement.idl:
        * svg/SVGFEMergeNodeElement.cpp:
        * svg/SVGFEMergeNodeElement.h:
        * svg/SVGFEMergeNodeElement.idl:
        * svg/SVGFEOffsetElement.cpp:
        * svg/SVGFEOffsetElement.h:
        * svg/SVGFEOffsetElement.idl:
        * svg/SVGFEPointLightElement.cpp:
        * svg/SVGFEPointLightElement.h:
        * svg/SVGFEPointLightElement.idl:
        * svg/SVGFESpecularLightingElement.cpp:
        * svg/SVGFESpecularLightingElement.h:
        * svg/SVGFESpecularLightingElement.idl:
        * svg/SVGFESpotLightElement.cpp:
        * svg/SVGFESpotLightElement.h:
        * svg/SVGFESpotLightElement.idl:
        * svg/SVGFETileElement.cpp:
        * svg/SVGFETileElement.h:
        * svg/SVGFETileElement.idl:
        * svg/SVGFETurbulenceElement.cpp:
        * svg/SVGFETurbulenceElement.h:
        * svg/SVGFETurbulenceElement.idl:
        * svg/SVGFilterElement.cpp:
        * svg/SVGFilterElement.h:
        * svg/SVGFilterElement.idl:
        * svg/SVGFilterPrimitiveStandardAttributes.cpp:
        * svg/SVGFilterPrimitiveStandardAttributes.h:
        * svg/graphics/SVGResourceFilter.cpp:
        * svg/graphics/SVGResourceFilter.h:
        * svg/graphics/cairo/SVGResourceFilterCairo.cpp:
        * svg/graphics/cg/SVGResourceFilterCg.cpp:
        * svg/graphics/cg/SVGResourceFilterCg.mm:
        * svg/graphics/filters/SVGDistantLightSource.h:
        * svg/graphics/filters/SVGFEConvolveMatrix.cpp:
        * svg/graphics/filters/SVGFEConvolveMatrix.h:
        * svg/graphics/filters/SVGFEDiffuseLighting.cpp:
        * svg/graphics/filters/SVGFEDiffuseLighting.h:
        * svg/graphics/filters/SVGFEDisplacementMap.cpp:
        * svg/graphics/filters/SVGFEDisplacementMap.h:
        * svg/graphics/filters/SVGFEFlood.cpp:
        * svg/graphics/filters/SVGFEFlood.h:
        * svg/graphics/filters/SVGFEGaussianBlur.cpp:
        * svg/graphics/filters/SVGFEGaussianBlur.h:
        * svg/graphics/filters/SVGFEImage.cpp:
        * svg/graphics/filters/SVGFEImage.h:
        * svg/graphics/filters/SVGFEMerge.cpp:
        * svg/graphics/filters/SVGFEMerge.h:
        * svg/graphics/filters/SVGFEMorphology.cpp:
        * svg/graphics/filters/SVGFEMorphology.h:
        * svg/graphics/filters/SVGFEOffset.cpp:
        * svg/graphics/filters/SVGFEOffset.h:
        * svg/graphics/filters/SVGFESpecularLighting.cpp:
        * svg/graphics/filters/SVGFESpecularLighting.h:
        * svg/graphics/filters/SVGFETile.cpp:
        * svg/graphics/filters/SVGFETile.h:
        * svg/graphics/filters/SVGFETurbulence.cpp:
        * svg/graphics/filters/SVGFETurbulence.h:
        * svg/graphics/filters/SVGFilterEffect.cpp:
        * svg/graphics/filters/SVGFilterEffect.h:
        * svg/graphics/filters/SVGLightSource.cpp:
        * svg/graphics/filters/SVGLightSource.h:
        * svg/graphics/filters/SVGPointLightSource.h:
        * svg/graphics/filters/SVGSpotLightSource.h:
        * svg/graphics/filters/cg/SVGFEHelpersCg.h:
        * svg/graphics/filters/cg/SVGFEHelpersCg.mm:
        * svg/graphics/filters/cg/SVGFilterEffectCg.mm:
        * svg/graphics/filters/cg/WKArithmeticFilter.h:
        * svg/graphics/filters/cg/WKArithmeticFilter.m:
        * svg/graphics/filters/cg/WKComponentMergeFilter.h:
        * svg/graphics/filters/cg/WKComponentMergeFilter.m:
        * svg/graphics/filters/cg/WKDiffuseLightingFilter.h:
        * svg/graphics/filters/cg/WKDiffuseLightingFilter.m:
        * svg/graphics/filters/cg/WKDiscreteTransferFilter.h:
        * svg/graphics/filters/cg/WKDiscreteTransferFilter.m:
        * svg/graphics/filters/cg/WKDisplacementMapFilter.h:
        * svg/graphics/filters/cg/WKDisplacementMapFilter.m:
        * svg/graphics/filters/cg/WKDistantLightFilter.h:
        * svg/graphics/filters/cg/WKDistantLightFilter.m:
        * svg/graphics/filters/cg/WKGammaTransferFilter.h:
        * svg/graphics/filters/cg/WKGammaTransferFilter.m:
        * svg/graphics/filters/cg/WKIdentityTransferFilter.h:
        * svg/graphics/filters/cg/WKIdentityTransferFilter.m:
        * svg/graphics/filters/cg/WKLinearTransferFilter.h:
        * svg/graphics/filters/cg/WKLinearTransferFilter.m:
        * svg/graphics/filters/cg/WKNormalMapFilter.h:
        * svg/graphics/filters/cg/WKNormalMapFilter.m:
        * svg/graphics/filters/cg/WKPointLightFilter.h:
        * svg/graphics/filters/cg/WKPointLightFilter.m:
        * svg/graphics/filters/cg/WKSpecularLightingFilter.h:
        * svg/graphics/filters/cg/WKSpecularLightingFilter.m:
        * svg/graphics/filters/cg/WKSpotLightFilter.h:
        * svg/graphics/filters/cg/WKSpotLightFilter.m:
        * svg/graphics/filters/cg/WKTableTransferFilter.h:
        * svg/graphics/filters/cg/WKTableTransferFilter.m:
        * svg/graphics/mac/SVGResourceFilterPlatformDataMac.h:
        * svg/graphics/mac/SVGResourceFilterPlatformDataMac.mm:
        * svg/graphics/qt/SVGResourceFilterQt.cpp:
        * svg/graphics/skia/SVGResourceFilterSkia.cpp:
        * svg/svgtags.in:

2009-05-28  Brett Wilson  <brettw@chromium.org>

        Unreviewed, build fix.

        https://bugs.webkit.org/show_bug.cgi?id=26067

        Add casts for scale function to make more explicit what is happening
        and fix a compiler warning.

        * platform/graphics/IntSize.h:
        (WebCore::IntSize::scale):

2009-05-28  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Remove the returnValueSlot concept from JSDOMWindowBase. Now that windows
        are not cleared on navigation it is no longer necessary.

        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::JSDOMWindowBaseData::JSDOMWindowBaseData):
        (WebCore::JSDOMWindowBase::willRemoveFromWindowShell):
        * bindings/js/JSDOMWindowBase.h:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::showModalDialog):

2009-05-19  Xan Lopez  <xlopez@igalia.com>

        Reviewed by Jan Alonzo and Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=25415
        [GTK][ATK] Please implement support for get_text_at_offset

        Implement atk_text_get_text_{at,after,before}_offset.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:

2009-05-28  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Rubber-stamped by Darin Adler.

        Remove unnecessary destructor from InputElementData/OptionElementData.

        * dom/InputElement.cpp:
        * dom/InputElement.h:
        * dom/OptionElement.cpp:
        * dom/OptionElement.h:

2009-05-28  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=26062

        Refactor code from all virtual methods in HTMLSelectElement (that are also needed for WMLSelectElement)
        in the recently introduced SelectElement abstract base class. Follow the same design sheme that InputElement uses.

        A follow-up patch can now easily add WMLSelectElement.

        * dom/OptionElement.h:
        * dom/SelectElement.cpp:
        (WebCore::SelectElement::selectAll):
        (WebCore::SelectElement::saveLastSelection):
        (WebCore::isOptionElement):
        (WebCore::isOptionGroupElement):
        (WebCore::SelectElement::nextSelectableListIndex):
        (WebCore::SelectElement::previousSelectableListIndex):
        (WebCore::SelectElement::setActiveSelectionAnchorIndex):
        (WebCore::SelectElement::setActiveSelectionEndIndex):
        (WebCore::SelectElement::updateListBoxSelection):
        (WebCore::SelectElement::listBoxOnChange):
        (WebCore::SelectElement::menuListOnChange):
        (WebCore::SelectElement::scrollToSelection):
        (WebCore::SelectElement::recalcStyle):
        (WebCore::SelectElement::setRecalcListItems):
        (WebCore::SelectElement::recalcListItems):
        (WebCore::SelectElement::selectedIndex):
        (WebCore::SelectElement::setSelectedIndex):
        (WebCore::SelectElement::optionToListIndex):
        (WebCore::SelectElement::listToOptionIndex):
        (WebCore::SelectElement::dispatchFocusEvent):
        (WebCore::SelectElement::dispatchBlurEvent):
        (WebCore::SelectElement::deselectItems):
        (WebCore::SelectElement::saveFormControlState):
        (WebCore::SelectElement::restoreFormControlState):
        (WebCore::SelectElement::parseMultipleAttribute):
        (WebCore::SelectElement::appendFormData):
        (WebCore::SelectElement::reset):
        (WebCore::SelectElement::menuListDefaultEventHandler):
        (WebCore::SelectElement::listBoxDefaultEventHandler):
        (WebCore::SelectElement::defaultEventHandler):
        (WebCore::SelectElement::lastSelectedListIndex):
        (WebCore::stripLeadingWhiteSpace):
        (WebCore::SelectElement::typeAheadFind):
        (WebCore::SelectElement::insertedIntoTree):
        (WebCore::SelectElementData::SelectElementData):
        (WebCore::SelectElementData::checkListItems):
        (WebCore::SelectElementData::listItems):
        * dom/SelectElement.h:
        (WebCore::SelectElementData::multiple):
        (WebCore::SelectElementData::setMultiple):
        (WebCore::SelectElementData::size):
        (WebCore::SelectElementData::setSize):
        (WebCore::SelectElementData::usesMenuList):
        (WebCore::SelectElementData::lastOnChangeIndex):
        (WebCore::SelectElementData::setLastOnChangeIndex):
        (WebCore::SelectElementData::lastOnChangeSelection):
        (WebCore::SelectElementData::activeSelectionState):
        (WebCore::SelectElementData::setActiveSelectionState):
        (WebCore::SelectElementData::activeSelectionAnchorIndex):
        (WebCore::SelectElementData::setActiveSelectionAnchorIndex):
        (WebCore::SelectElementData::activeSelectionEndIndex):
        (WebCore::SelectElementData::setActiveSelectionEndIndex):
        (WebCore::SelectElementData::cachedStateForActiveSelection):
        (WebCore::SelectElementData::shouldRecalcListItems):
        (WebCore::SelectElementData::setShouldRecalcListItems):
        (WebCore::SelectElementData::rawListItems):
        (WebCore::SelectElementData::repeatingChar):
        (WebCore::SelectElementData::setRepeatingChar):
        (WebCore::SelectElementData::lastCharTime):
        (WebCore::SelectElementData::setLastCharTime):
        (WebCore::SelectElementData::typedString):
        (WebCore::SelectElementData::setTypedString):
        * html/HTMLOptionElement.h:
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::HTMLSelectElement):
        (WebCore::HTMLSelectElement::recalcStyle):
        (WebCore::HTMLSelectElement::formControlType):
        (WebCore::HTMLSelectElement::selectedIndex):
        (WebCore::HTMLSelectElement::deselectItems):
        (WebCore::HTMLSelectElement::setSelectedIndex):
        (WebCore::HTMLSelectElement::activeSelectionStartListIndex):
        (WebCore::HTMLSelectElement::activeSelectionEndListIndex):
        (WebCore::HTMLSelectElement::saveFormControlState):
        (WebCore::HTMLSelectElement::restoreFormControlState):
        (WebCore::HTMLSelectElement::parseMappedAttribute):
        (WebCore::HTMLSelectElement::canSelectAll):
        (WebCore::HTMLSelectElement::selectAll):
        (WebCore::HTMLSelectElement::createRenderer):
        (WebCore::HTMLSelectElement::appendFormData):
        (WebCore::HTMLSelectElement::optionToListIndex):
        (WebCore::HTMLSelectElement::listToOptionIndex):
        (WebCore::HTMLSelectElement::recalcListItems):
        (WebCore::HTMLSelectElement::setRecalcListItems):
        (WebCore::HTMLSelectElement::reset):
        (WebCore::HTMLSelectElement::dispatchFocusEvent):
        (WebCore::HTMLSelectElement::dispatchBlurEvent):
        (WebCore::HTMLSelectElement::defaultEventHandler):
        (WebCore::HTMLSelectElement::setActiveSelectionAnchorIndex):
        (WebCore::HTMLSelectElement::setActiveSelectionEndIndex):
        (WebCore::HTMLSelectElement::updateListBoxSelection):
        (WebCore::HTMLSelectElement::menuListOnChange):
        (WebCore::HTMLSelectElement::listBoxOnChange):
        (WebCore::HTMLSelectElement::saveLastSelection):
        (WebCore::HTMLSelectElement::setOption):
        (WebCore::HTMLSelectElement::scrollToSelection):
        (WebCore::HTMLSelectElement::insertedIntoTree):
        * html/HTMLSelectElement.h:
        (WebCore::HTMLSelectElement::size):
        (WebCore::HTMLSelectElement::multiple):
        (WebCore::HTMLSelectElement::listItems):
        * wml/WMLOptionElement.cpp:
        (WebCore::WMLOptionElement::text):
        * wml/WMLOptionElement.h:


        * dom/OptionElement.h:
        * dom/SelectElement.cpp:
        (WebCore::SelectElement::selectAll):
        (WebCore::SelectElement::saveLastSelection):
        (WebCore::isOptionElement):
        (WebCore::isOptionGroupElement):
        (WebCore::SelectElement::nextSelectableListIndex):
        (WebCore::SelectElement::previousSelectableListIndex):
        (WebCore::SelectElement::setActiveSelectionAnchorIndex):
        (WebCore::SelectElement::setActiveSelectionEndIndex):
        (WebCore::SelectElement::updateListBoxSelection):
        (WebCore::SelectElement::listBoxOnChange):
        (WebCore::SelectElement::menuListOnChange):
        (WebCore::SelectElement::scrollToSelection):
        (WebCore::SelectElement::recalcStyle):
        (WebCore::SelectElement::setRecalcListItems):
        (WebCore::SelectElement::recalcListItems):
        (WebCore::SelectElement::selectedIndex):
        (WebCore::SelectElement::setSelectedIndex):
        (WebCore::SelectElement::optionToListIndex):
        (WebCore::SelectElement::listToOptionIndex):
        (WebCore::SelectElement::dispatchFocusEvent):
        (WebCore::SelectElement::dispatchBlurEvent):
        (WebCore::SelectElement::deselectItems):
        (WebCore::SelectElement::saveFormControlState):
        (WebCore::SelectElement::restoreFormControlState):
        (WebCore::SelectElement::parseMultipleAttribute):
        (WebCore::SelectElement::appendFormData):
        (WebCore::SelectElement::reset):
        (WebCore::SelectElement::menuListDefaultEventHandler):
        (WebCore::SelectElement::listBoxDefaultEventHandler):
        (WebCore::SelectElement::defaultEventHandler):
        (WebCore::SelectElement::lastSelectedListIndex):
        (WebCore::stripLeadingWhiteSpace):
        (WebCore::SelectElement::typeAheadFind):
        (WebCore::SelectElement::insertedIntoTree):
        (WebCore::SelectElementData::SelectElementData):
        (WebCore::SelectElementData::~SelectElementData):
        (WebCore::SelectElementData::checkListItems):
        (WebCore::SelectElementData::listItems):
        * dom/SelectElement.h:
        (WebCore::SelectElementData::multiple):
        (WebCore::SelectElementData::setMultiple):
        (WebCore::SelectElementData::size):
        (WebCore::SelectElementData::setSize):
        (WebCore::SelectElementData::usesMenuList):
        (WebCore::SelectElementData::lastOnChangeIndex):
        (WebCore::SelectElementData::setLastOnChangeIndex):
        (WebCore::SelectElementData::lastOnChangeSelection):
        (WebCore::SelectElementData::activeSelectionState):
        (WebCore::SelectElementData::setActiveSelectionState):
        (WebCore::SelectElementData::activeSelectionAnchorIndex):
        (WebCore::SelectElementData::setActiveSelectionAnchorIndex):
        (WebCore::SelectElementData::activeSelectionEndIndex):
        (WebCore::SelectElementData::setActiveSelectionEndIndex):
        (WebCore::SelectElementData::cachedStateForActiveSelection):
        (WebCore::SelectElementData::shouldRecalcListItems):
        (WebCore::SelectElementData::setShouldRecalcListItems):
        (WebCore::SelectElementData::rawListItems):
        (WebCore::SelectElementData::repeatingChar):
        (WebCore::SelectElementData::setRepeatingChar):
        (WebCore::SelectElementData::lastCharTime):
        (WebCore::SelectElementData::setLastCharTime):
        (WebCore::SelectElementData::typedString):
        (WebCore::SelectElementData::setTypedString):
        * html/HTMLOptionElement.h:
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::HTMLSelectElement):
        (WebCore::HTMLSelectElement::recalcStyle):
        (WebCore::HTMLSelectElement::formControlType):
        (WebCore::HTMLSelectElement::selectedIndex):
        (WebCore::HTMLSelectElement::deselectItems):
        (WebCore::HTMLSelectElement::setSelectedIndex):
        (WebCore::HTMLSelectElement::activeSelectionStartListIndex):
        (WebCore::HTMLSelectElement::activeSelectionEndListIndex):
        (WebCore::HTMLSelectElement::saveFormControlState):
        (WebCore::HTMLSelectElement::restoreFormControlState):
        (WebCore::HTMLSelectElement::parseMappedAttribute):
        (WebCore::HTMLSelectElement::canSelectAll):
        (WebCore::HTMLSelectElement::selectAll):
        (WebCore::HTMLSelectElement::createRenderer):
        (WebCore::HTMLSelectElement::appendFormData):
        (WebCore::HTMLSelectElement::optionToListIndex):
        (WebCore::HTMLSelectElement::listToOptionIndex):
        (WebCore::HTMLSelectElement::recalcListItems):
        (WebCore::HTMLSelectElement::setRecalcListItems):
        (WebCore::HTMLSelectElement::reset):
        (WebCore::HTMLSelectElement::dispatchFocusEvent):
        (WebCore::HTMLSelectElement::dispatchBlurEvent):
        (WebCore::HTMLSelectElement::defaultEventHandler):
        (WebCore::HTMLSelectElement::setActiveSelectionAnchorIndex):
        (WebCore::HTMLSelectElement::setActiveSelectionEndIndex):
        (WebCore::HTMLSelectElement::updateListBoxSelection):
        (WebCore::HTMLSelectElement::menuListOnChange):
        (WebCore::HTMLSelectElement::listBoxOnChange):
        (WebCore::HTMLSelectElement::saveLastSelection):
        (WebCore::HTMLSelectElement::setOption):
        (WebCore::HTMLSelectElement::scrollToSelection):
        (WebCore::HTMLSelectElement::insertedIntoTree):
        * html/HTMLSelectElement.h:
        (WebCore::HTMLSelectElement::size):
        (WebCore::HTMLSelectElement::multiple):
        (WebCore::HTMLSelectElement::listItems):
        * wml/WMLOptionElement.cpp:
        (WebCore::WMLOptionElement::text):
        * wml/WMLOptionElement.h:

2009-05-28  Adam Roben  <aroben@apple.com>

        Don't try to use the new combobox parts on Vista in Classic mode

        Fixes:
        <rdar://problem/6929277> REGRESSION (r42289+r42350): Windows Classic
        theme: drop down lists in Preferences get a line/square
        <rdar://problem/6929298> REGRESSION (r42289): Windows Classic: drop
        down lists are black with a circle on many sites

        Reviewed by Steve Falkenburg.

        * rendering/RenderThemeWin.cpp:
        (WebCore::RenderThemeWin::paintMenuList): Only use the new combobox
        parts when we have a theme (i.e., when we're not in Classic mode).
        When we don't have a theme, fall back to the pre-r42289 code.

2009-05-27  Peter Kasting  <pkasting@google.com>

        Reviewed by Simon Fraser.

        https://bugs.webkit.org/show_bug.cgi?id=25659
        Avoid calling frameCount() unnecessarily (which could lead to extra
        GIF decoding).

        * platform/graphics/BitmapImage.cpp:
        (WebCore::BitmapImage::destroyDecodedDataIfNecessary):

2009-05-28  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Oliver Hunt.
        
        https://bugs.webkit.org/show_bug.cgi?id=8736

        Tests: fast/borders/border-radius-constraints.html
               fast/borders/border-radius-split-inline.html
               
        When the sum of the corner radii on a side exceed the length of the side,
        reduce the radii according to CSS 3 rules.
        
        Add RenderStyle::getBorderRadiiForRect() to fetch corner radii, applying
        the constraints. Use that for painting borders, box-shadow, clipping replaced
        elements

        * platform/graphics/IntSize.h:
        (WebCore::IntSize::scale):
        Add a scale method that scales by a float (using C rounding rules, like IntRect::scale()).

        * platform/graphics/Path.cpp:
        Make the QUARTER const static.

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::pushContentsClip):
        Use getBorderRadiiForRect to fetch border radii.

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintFillLayerExtended):
        Use getBorderRadiiForRect to fetch border radii.

        (WebCore::RenderBoxModelObject::paintBorder):
        Use getBorderRadiiForRect to fetch border radii, and fix a bug when drawing
        borders for split inlines, which used to apply the radii for each segment,
        and no longer does.

        (WebCore::RenderBoxModelObject::paintBoxShadow):
        Use getBorderRadiiForRect to fetch border radii.

        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::paint):
        Use getBorderRadiiForRect to fetch border radii for clipping.

        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::paint):
        Use getBorderRadiiForRect to fetch border radii for clipping.

        * rendering/style/RenderStyle.h:
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::getBorderRadiiForRect):
        New bottleneck method to fetch corner radiil given a rect, applying the constraint
        rules.

2009-05-28  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=26005
        Optimization for XPath //* does not preserve context size

        Test: fast/xpath/position.html

        Fixed the bug by removing the incorrect optimization, and made enough micro-optimizations to
        get a performance progression on my tests.

        * xml/XPathPath.h: Removed broken optimizeStepPair().

        * xml/XPathPath.cpp:
        (WebCore::XPath::LocationPath::evaluate): Style fix.
        (WebCore::XPath::LocationPath::appendStep): Don't call optimizeStepPair().
        (WebCore::XPath::LocationPath::insertFirstStep): Ditto.
        (WebCore::XPath::Path::Path): Style fix.

        * xml/XPathStep.cpp:
        (WebCore::XPath::primaryNodeType): Turned this member function into a static inline helper.
        (WebCore::XPath::nodeMatches): Ditto. Don't check for namespace axis, which is unsupported
        (and might never be).
        (WebCore::XPath::Step::nodesInAxis): Updated for the new nodeMatches() signature.

        * xml/XPathStep.h:
        (WebCore::XPath::Step::NodeTest::data):
        (WebCore::XPath::Step::NodeTest::namespaceURI):
        Made these data members AtomicString to avoid repeated conversions. This is the biggest
        performance win here.

        * xml/XPathUtil.cpp: (WebCore::XPath::stringValue): Reserve some capacity upfront.

2009-05-28  Stephen White  <senorblanco@chromium.org>

        Reviewed by Dimitri Glazkov.

        When creating a linear or radial gradient with a single stop
        at offset 1.0, the Skia layer was allocating 3 stops, but only
        filling 2, leaving one uninitialized.  Only 2 stops are necessary
        in this case, at offsets (0.0, 1.0).

        http://bugs.webkit.org/show_bug.cgi?id=26063

        Covered by: LayoutTests/svg/W3C-SVG-1.1/pservers-grad-16-b.svg
                    LayoutTests/svg/custom/gradient-stop-corner-cases.svg
                    LayoutTests/svg/custom/js-late-gradient-and-object-creation.svg

        * platform/graphics/skia/GradientSkia.cpp:
        (WebCore::totalStopsNeeded):

2009-05-28  Yury Semikhatsky  <yurys@chromium.org>

        Reviewed by Timothy Hatcher.

        https://bugs.webkit.org/show_bug.cgi?id=26041
        Allow adding resource source to WebInspector.SourceFrame asynchronously.

        Provide common implementation for InspectorController::addResourceSourceToFrame and
        InspectorController::addSourceToFrame methods.

        * bindings/js/JSInspectorControllerCustom.cpp:
        * bindings/v8/custom/V8InspectorControllerCustom.cpp:
        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::addResourceSourceToFrame):
        * inspector/InspectorController.h:
        * inspector/InspectorController.idl:
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype.revealLine):
        (WebInspector.SourceFrame.prototype.highlightLine):
        (WebInspector.SourceFrame.prototype._loaded):
        (WebInspector.SourceFrame.prototype._isContentLoaded):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView.prototype.setupSourceFrameIfNeeded):
        (WebInspector.SourceView.prototype._contentLoaded):

2009-05-28  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Xan Lopez.

        After r44177 we had a problem when increasing the size
        of the window the scrollbars stayed and were not hidden.
        This was due WebCore giving up on the Scrollbar as it became
        unnecessary but the GtkAdjustment remained unchanged.
        So from the point of view of the GtkScrolledWindow scrolling
        was still necessary and the GtkScrollbar kept being displayed.

        Solve the issue by resetting the GtkAdjustment in the
        destructor of ScrollbarGtk.

        * platform/gtk/ScrollbarGtk.cpp:
        (ScrollbarGtk::~ScrollbarGtk):

2009-05-28  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Adler.

        Clean up window.open()'s use of lexical and dynamic scope.

        (Added one unreviewed tweak: use dynamicFrame instead of lexicalFrame
        for DOMWindow::allowPopUp.)

        Test: http/tests/security/frameNavigation/context-for-window-open.html

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::toDynamicFrame):
        (WebCore::processingUserGesture):
        (WebCore::completeURL):
        * bindings/js/JSDOMBinding.h:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::createWindow):
        (WebCore::JSDOMWindow::open):
        (WebCore::JSDOMWindow::showModalDialog):
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::CALLBACK_FUNC_DECL):
        (WebCore::createWindow):

2009-05-27  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Oliver Hunt.

        https://bugs.webkit.org/show_bug.cgi?id=26056
        XPath string() function can be very slow

        * xml/XPathUtil.cpp: (WebCore::XPath::stringValue): Use an intermediate Vector when appending.

2009-05-27  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        - fix <rdar://problem/6927761> <isindex> placeholder text is unstylable
          and initially not visible

        Test: fast/forms/isindex-placeholder.html

        * css/html4.css: Added a default style for <isindex> placeholder text.
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::parseMappedAttribute): Changed to call
        the new protected function updatePlaceholderVisibility().
        * html/HTMLInputElement.h:
        (WebCore::HTMLInputElement::updatePlaceholderVisibility): Added this
        protected function to allow HTMLIsIndexElement::parseMappedAttribute()
        to invoke InputElement::updatePlaceholderVisibility().
        * html/HTMLIsIndexElement.cpp:
        (WebCore::HTMLIsIndexElement::parseMappedAttribute): Call
        updatePlaceholderVisibility() when parsing the placeholder attribute.
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::createInnerTextStyle): If there
        is no placeholder pseudo-element style, use the normal style.

2009-05-27  Sam Weinig  <sam@webkit.org>

        Reviewed by Maciej Stachowiak.

        More cleanup of DOMWindow related functions.

        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::willRemoveFromWindowShell): Renamed from JSDOMWindowBase::clear()
        * bindings/js/JSDOMWindowBase.h:

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::showModalDialog): Update Comment.

        * bindings/js/JSDOMWindowShell.cpp:
        * bindings/js/JSDOMWindowShell.h:
        Remove JSDOMWindowShell::clear().  It was unused.

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::clearWindowShell):

2009-05-27  Sam Weinig  <sam@webkit.org>

        Reviewed by David Hyatt.

        Miscellaneous cleanup of DOMWindow related functions.

        * bindings/js/JSDOMGlobalObject.cpp:
        (WebCore::JSDOMGlobalObject::~JSDOMGlobalObject): Fix poorly named variables.
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::supportsProfiling): Don't jump through hoops
        checking for null frames if the build does not support profiling.
        (WebCore::JSDOMWindowBase::clear): Use setCurrentEvent(0) instead of calling
        clearHelperObjectProperties().  It is clearer.
        * bindings/js/JSDOMWindowBase.h:
        Removed now unused clearHelperObjectProperties() function, empty disconnectFrame()
        function, and the empty destructor.
        * bindings/js/JSDOMWindowShell.cpp:
        * bindings/js/JSDOMWindowShell.h:
        Remove disconnectFrame() which only called JSDOMWindowBase::disconnectFrame(), which
        is a no-op.
        * page/Frame.cpp:
        (WebCore::Frame::~Frame):
        (WebCore::Frame::pageDestroyed):
        Remove calls to JSDOMWindowShell::disconnectFrame() which only called
        JSDOMWindowBase::disconnectFrame(), which is a no-op.

2009-05-27  Dimitri Glazkov  <dglazkov@chromium.org>

        Unreviewed, build fix.

        https://bugs.webkit.org/show_bug.cgi?id=25974
        Remove extra qualifiers from the ScheduledAction decl.

        * bindings/v8/ScheduledAction.h: Removed extraneous class qualifiers.

2009-05-27  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Unreviewed make distcheck fix. One more missing file.

        * GNUmakefile.am:

2009-05-27  Antonio Gomes   <antonio.gomes@openbossa.org>

        Reviewed by Simon Hausmann.

        [Qt] Fixed trunk build on Linux after r44126.

        * WebCore.pro:

2009-05-27  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/6926046> REGRESSION (r43972): http://www.youtube.com/html5 crashes on open

        * platform/graphics/MediaPlayer.cpp:
        (WebCore::MediaPlayer::load): Don't look for a media engine based on an empty MIME type.

2009-05-27  David Levin  <levin@chromium.org>

        Reviewed by Maciej Stachowiak.

        Bug 26029: FrameLoader::canLoad should allow calls with just a security origin
        https://bugs.webkit.org/show_bug.cgi?id=26029

        No functional changes, so no tests.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::canLoad):
        * loader/FrameLoader.h:

2009-05-27  Gustavo Noronha Silva  <gustavo.noronha@collabora.co.uk>

        Unreviewed build fix.

        Remove file that does not exist from the build.

        * GNUmakefile.am:

2009-05-27  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler.

        Remove two unneeded protected constructors, these classes have pure-virtual functions, and can't be constructed anyway.

        * dom/InputElement.h:
        * dom/OptionGroupElement.h:

2009-05-27  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=17725
        XPath should be case insensitive for HTML

        Test: fast/xpath/node-name-case-sensitivity.html

        * xml/XPathStep.cpp: (WebCore::XPath::Step::nodeMatches): Made node name check case insensitive
        for HTML elements in HTML documents.

2009-05-27  John Sullivan  <sullivan@apple.com>

        fixed <rdar://problem/6925482> repro crash in WebCore::DragController::dragExited dropping 
        bookmarks (at least) over Top Sites (at least)

        Reviewed by Kevin Decker

        * page/DragController.cpp:
        (WebCore::DragController::dragExited):
        nil check m_documentUnderMouse and take the "local file" case if it's nil

2009-05-27  Fridrich Strba  <fridrich.strba@bluewin.ch>

        Reviewed by Gustavo Noronha.

        When building on window, consider Windows specific files.

        * GNUmakefile.am:

2009-05-27  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=26031

        InputElementData is too heavy, save storing two pointers by passing them
        directly to the static helper functions (the only place which needs them). 

        * dom/InputElement.cpp:
        (WebCore::InputElement::dispatchFocusEvent):
        (WebCore::InputElement::dispatchBlurEvent):
        (WebCore::InputElement::updatePlaceholderVisibility):
        (WebCore::InputElement::updateFocusAppearance):
        (WebCore::InputElement::updateSelectionRange):
        (WebCore::InputElement::aboutToUnload):
        (WebCore::InputElement::setValueFromRenderer):
        (WebCore::InputElement::constrainValue):
        (WebCore::InputElement::handleBeforeTextInsertedEvent):
        (WebCore::InputElement::parseSizeAttribute):
        (WebCore::InputElement::parseMaxLengthAttribute):
        (WebCore::InputElement::updateValueIfNeeded):
        (WebCore::InputElement::notifyFormStateChanged):
        (WebCore::InputElementData::InputElementData):
        * dom/InputElement.h:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::HTMLInputElement):
        (WebCore::HTMLInputElement::updateFocusAppearance):
        (WebCore::HTMLInputElement::aboutToUnload):
        (WebCore::HTMLInputElement::dispatchFocusEvent):
        (WebCore::HTMLInputElement::dispatchBlurEvent):
        (WebCore::HTMLInputElement::setInputType):
        (WebCore::HTMLInputElement::setSelectionRange):
        (WebCore::HTMLInputElement::parseMappedAttribute):
        (WebCore::HTMLInputElement::setValue):
        (WebCore::HTMLInputElement::setValueFromRenderer):
        (WebCore::HTMLInputElement::setFileListFromRenderer):
        (WebCore::HTMLInputElement::defaultEventHandler):
        (WebCore::HTMLInputElement::constrainValue):
        * wml/WMLInputElement.cpp:
        (WebCore::WMLInputElement::WMLInputElement):
        (WebCore::WMLInputElement::dispatchFocusEvent):
        (WebCore::WMLInputElement::dispatchBlurEvent):
        (WebCore::WMLInputElement::updateFocusAppearance):
        (WebCore::WMLInputElement::aboutToUnload):
        (WebCore::WMLInputElement::setValue):
        (WebCore::WMLInputElement::setValueFromRenderer):
        (WebCore::WMLInputElement::parseMappedAttribute):
        (WebCore::WMLInputElement::defaultEventHandler):
        (WebCore::WMLInputElement::constrainValue):

2009-05-27  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=26033

        OptionElementData saves an Element pointer, which is unnessary.
        Just pass it to the static function calls directly.

        * dom/OptionElement.cpp:
        (WebCore::OptionElement::setSelectedState):
        (WebCore::OptionElement::collectOptionText):
        (WebCore::OptionElement::collectOptionTextRespectingGroupLabel):
        (WebCore::OptionElement::collectOptionValue):
        (WebCore::OptionElementData::OptionElementData):
        * dom/OptionElement.h:
        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::HTMLOptionElement):
        (WebCore::HTMLOptionElement::text):
        (WebCore::HTMLOptionElement::value):
        (WebCore::HTMLOptionElement::setSelected):
        (WebCore::HTMLOptionElement::setSelectedState):
        (WebCore::HTMLOptionElement::textIndentedToRespectGroupLabel):
        * wml/WMLOptionElement.cpp:
        (WebCore::WMLOptionElement::WMLOptionElement):
        (WebCore::WMLOptionElement::setSelectedState):
        (WebCore::WMLOptionElement::value):
        (WebCore::WMLOptionElement::textIndentedToRespectGroupLabel):

2009-05-27  Fridrich Strba  <fridrich.strba@bluewin.ch>

        Reviewed by Maciej Stachowiak.

        When building with MinGW, don't use the __declspec(dl{import,export})
        decorations and rely on the linker to use its nifty auto-import feature.
        It is extremely hard to get the decorations right with MinGW in general
        and impossible in WebKit, where the resulting shared library is linking 
        together some static libraries.

        * config.h:

2009-05-26  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Xan Lopez.

        https://bugs.webkit.org/show_bug.cgi?id=25613

        Add a WebCore::Widget that can embed GtkWidget with and
        without a GdkWindow. This can be used to embed any GtkWidget.

        Some bits are directly copied from the Scrollbar implementation
        but can not be easily shared here.

        * GNUmakefile.am:
        * platform/gtk/GtkPluginWidget.cpp: Added.
        (WebCore::GtkPluginWidget::GtkPluginWidget):
        (WebCore::GtkPluginWidget::invalidateRect):
        (WebCore::GtkPluginWidget::frameRectsChanged):
        (WebCore::GtkPluginWidget::paint):
        * platform/gtk/GtkPluginWidget.h: Added.

2009-05-26  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=25613.

        Implement Widget::setIsSelected for Gtk+ by searching
        for a property of the name "webkit-widget-is-selected" and if
        such property exists we are going to set it. We expect
        the property to take a boolean.

        * platform/gtk/WidgetGtk.cpp:
        (WebCore::Widget::setIsSelected):

2009-05-26  Sam Weinig  <sam@webkit.org>

        Reviewed by Brady Eidson.

        Fix for <rdar://problem/6916371>
        iWeb 'Announce' button does nothing after publishing to MobileMe

        Add ability to force content sniffing for all urls (including file: urls)

        * WebCore.base.exp:
        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::shouldContentSniffURL):
        (WebCore::ResourceHandle::forceContentSniffing):
        * platform/network/ResourceHandle.h:

2009-05-26  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=25996

        [Qt] Dead-code stripping for unix

        * WebCore.pro: Turn on GCC dead-code stripping flags for Unix

2009-05-10  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Dave Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=25646

        [GTK] Send onscroll events for the main FrameView

        WebKit/GTK+ is currently not sending any onscroll
        events for a frame with external adjustments. This is
        due the fact that the value-changed signal of the GtkAdjustment
        is handled by WebCore::ScrollView directly and is not going through
        the WebCore::Scrollbar -> WebCore::ScrollbarClient ->
        WebCore::FrameView::valueChanged -> WebCore::ScrollView::valueChanged
        path.

        Fix the above problem by wrapping the GtkAdjustment we get
        assigned from GTK+ in a ScrollbarGtk that will not have any
        visual appearance. Remove code from ScrollView that knows
        about adjustments and create a special case for
        WebCore::ScrollView::createScrollbar that will create such
        a special WebCore::ScrollbarGtk.

        * platform/ScrollView.cpp: Remove adjustment code
        (WebCore::ScrollView::setHasHorizontalScrollbar):
        (WebCore::ScrollView::setHasVerticalScrollbar):
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::wheelEvent):
        * platform/ScrollView.h: Remove adjustment code
        * platform/gtk/ScrollViewGtk.cpp:
        (WebCore::ScrollView::platformDestroy):
        (WebCore::ScrollView::createScrollbar):
        (WebCore::ScrollView::setGtkAdjustments):
        * platform/gtk/ScrollbarGtk.cpp:
        (ScrollbarGtk::createScrollbar): Special case.
        (ScrollbarGtk::ScrollbarGtk):  New ctor and work on the adjustment
        (ScrollbarGtk::~ScrollbarGtk): Disconnect signal
        (ScrollbarGtk::frameRectsChanged): Do nothing when we lack a platformWidget
        * platform/gtk/ScrollbarGtk.h:

2009-05-26  Cameron Zwarich  <zwarich@apple.com>

        Reviewed by Maciej Stachowiak.

        Bug 26035: Make ImageSource::frameHasAlphaAtIndex() return false for JPEGs with CG
        <https://bugs.webkit.org/show_bug.cgi?id=26035>
        <rdar://problem/6924087>

        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::frameHasAlphaAtIndex): return false if the image
        is JPEG, there is no image type, or m_decoder is null.

2009-05-26  Holger Hans Peter Freyther  <zecke@selfish.org>

        Unreviewed build fix for the JPEGImageDecoder.

        Revision 44167 removed stdio.h from the included headers and
        this will lead to an error that FILE is not known inside the
        jpeglib.h Put back the stdio.h include.

        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:

2009-05-26  Yichao Yin  <yichao.yin@torchmobile.com.cn>

        Reviewed by Maciej Stachowiak.

        Fix the crash issue while running layout tests after enalbed XHTMLMP
        https://bugs.webkit.org/show_bug.cgi?id=26017

        * dom/Document.cpp:
        (WebCore::Document::isXHTMLMPDocument):

2009-05-26  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6901751> 
        REGRESSION (r35515): Tiger crash painting the selection on registration page of car2go.com
        
        Don't use the WKCGContextIsSafeToClip function; it wasn't working correctly. Instead, just disable
        the improved selection drawing on Tiger.
        
        * WebCore.Tiger.exp:
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::clip):
        (WebCore::GraphicsContext::clipOut):
        (WebCore::GraphicsContext::clipOutEllipseInRect):
        (WebCore::GraphicsContext::clipPath):
        (WebCore::GraphicsContext::addInnerRoundedRectClip):
        (WebCore::GraphicsContext::strokeRect):
        * platform/mac/WebCoreSystemInterface.h:
        * platform/mac/WebCoreSystemInterface.mm:
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::fillSelectionGaps):

2009-05-26  Peter Kasting  <pkasting@google.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part two
        Mostly cosmetic changes, mainly to get image decoders for Cairo build to
        comply with WebKit style guidelines:
        * Fix header guard names
        * Fix initializer list wrapping
        * Fix class/function "{" wrapping
        * Fix wrapping of long boolean expressions
        * Fix whitespace around operators
        * Eliminate whitespace on otherwise-blank lines
        * No {} on single-line conditional arms
        * Use 0 instead of NULL
        * Don't #include "config.h" in headers

        Also a few non-cosmetic changes:
        * Remove unneeded #ifdef protecting the contents of these files.  The
          platforms listed don't match who uses these files anymore (even
          without considering Skia), and platforms which don't use them at all
          (like CG) aren't harmed by the files, since they don't have
          equivalently-named classes.  It's simpler to just ditch these.
        * Convert a use of Vector<>& into SharedBuffer*, since that's how the
          data is really stored anyway.
        * Use size() instead of m_size, for consistency with Skia code, and
          future-proofing (if a particular decoder wants to specialize this).
        * Move an ASSERT that was slightly more aggressive than necessary.
        * Change variable names/types for clarity/accuracy and to match Skia.
        * Remove unnecessary macro magic to work around a problem which no
          longer exists in the third-party JPEG headers.
        * Stop silencing a portability warning about setjmp (the vcproj/vsprops
          are the right place for this)
        * In Skia code, don't explicitly check |m_failed| before calling
          isSizeAvailable(), which itself checks |m_failed|.

        * platform/image-decoders/ImageDecoder.h: Fix header guards, "{" wrapping.
        (WebCore::RGBA32Buffer::):
        (WebCore::RGBA32Buffer::RGBA32Buffer): Fix initializer list wrapping.
        (WebCore::ImageDecoder::ImageDecoder): Fix initializer list wrapping.
        * platform/image-decoders/bmp/BMPImageDecoder.cpp: Remove unneeded #ifdef.
        * platform/image-decoders/bmp/BMPImageDecoder.h: Fix header guards, "{" wrapping.
        * platform/image-decoders/gif/GIFImageDecoder.cpp: Remove unneeded #ifdef, fix "{" wrapping.
        (WebCore::GIFImageDecoderPrivate::GIFImageDecoderPrivate): Use an initializer instead of a block-level statement.
        (WebCore::GIFImageDecoderPrivate::decode): Expect a SharedBuffer.
        (WebCore::GIFImageDecoderPrivate::getColorMap):
        (WebCore::GIFImageDecoder::GIFImageDecoder): Fix initializer list wrapping.
        (WebCore::GIFImageDecoder::frameCount): Add comment.
        (WebCore::GIFImageDecoder::frameBufferAtIndex): Explicitly cast, fix whitespace around operators.
        (WebCore::GIFImageDecoder::decode): Pass a SharedBuffer.
        (WebCore::GIFImageDecoder::initFrameBuffer): Use size() instead of m_size, move ASSERT, fix boolean wrapping, fix indenting.
        (WebCore::GIFImageDecoder::prepEmptyFrameBuffer): Use size() instead of m_size.
        (WebCore::GIFImageDecoder::haveDecodedRow): Use size() instead of m_size, eliminate unneeded whitespace, change variable name.
        (WebCore::GIFImageDecoder::frameComplete): Use size() instead of m_size, no {} on single-line conditional arms, fix boolean wrapping.
        * platform/image-decoders/gif/GIFImageDecoder.h: Fix header guards, "{" wrapping.
        * platform/image-decoders/gif/GIFImageReader.cpp: Remove unneeded #ifdef.
        (GIFImageReader::read):
        * platform/image-decoders/gif/GIFImageReader.h: Fix header guards, change variable type.
        * platform/image-decoders/ico/ICOImageDecoder.cpp: Remove unneeded #ifdef.
        * platform/image-decoders/ico/ICOImageDecoder.h: Fix header guards, "{" wrapping.
        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp: Remove unneeded #ifdef, macro magic, silencing of warning.
        (WebCore::JPEGImageDecoder::outputScanlines): Use size() instead of m_size, change variable name.
        * platform/image-decoders/jpeg/JPEGImageDecoder.h: Fix header guards, "{" wrapping.
        * platform/image-decoders/png/PNGImageDecoder.cpp: Remove unneeded #ifdef, silencing of warning, change variable type.
        (WebCore::PNGImageReader::PNGImageReader): Fix initializer list wrapping.
        (WebCore::PNGImageReader::close): Add comment, zero another member for consistency.
        (WebCore::PNGImageDecoder::PNGImageDecoder): Fix indenting.
        (WebCore::PNGImageDecoder::decodingFailed): Define in .cpp, not .h.
        (WebCore::PNGImageDecoder::rowAvailable):
        * platform/image-decoders/png/PNGImageDecoder.h: Fix header guards, "{" wrapping.
        * platform/image-decoders/skia/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::isSizeAvailable): Don't check m_failed unnecessarily.
        (WebCore::GIFImageDecoder::frameBufferAtIndex): Fix whitespace around operators.
        * platform/image-decoders/skia/GIFImageReader.h: "unsigned" is sufficient to convey "unsigned int".
        * platform/image-decoders/skia/ImageDecoder.h: Remove unnecessary #includes.
        (WebCore::ImageDecoder::ImageDecoder): Fix initializer list wrapping.
        * platform/image-decoders/skia/JPEGImageDecoder.cpp:
        (WebCore::JPEGImageReader::JPEGImageReader): Use 0 instead of NULL.
        (WebCore::JPEGImageDecoder::isSizeAvailable): Don't check m_failed unnecessarily.
        * platform/image-decoders/skia/PNGImageDecoder.cpp:
        (WebCore::PNGImageReader::PNGImageReader): Fix initializer list wrapping.
        (WebCore::PNGImageDecoder::PNGImageDecoder): Fix indenting.
        (WebCore::PNGImageDecoder::isSizeAvailable): Don't check m_failed unnecessarily.
        (WebCore::rowAvailable):
        * platform/image-decoders/skia/XBMImageDecoder.h: Don't #include config.h.
        * platform/image-decoders/xbm/XBMImageDecoder.cpp: Remove unneeded #ifdef.
        * platform/image-decoders/xbm/XBMImageDecoder.h: Fix header guards, "{" wrapping.

2009-05-26  Jian Li  <jianli@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=25944
        Remove the uses of V8 Locker in worker execution code. No additional test is needed.
        The normal WebKit layout tests should cover it. However, layout tests that start
        multiple workers will fail to pass due to test shell limitation in Chromium. To cover
        this, UI tests will be added (http://code.google.com/p/chromium/issues/detail?id=12554).

        * bindings/v8/V8WorkerContextEventListener.cpp:
        (WebCore::V8WorkerContextEventListener::handleEvent):
        * bindings/v8/WorkerContextExecutionProxy.cpp:
        (WebCore::WorkerContextExecutionProxy::dispose):
        (WebCore::WorkerContextExecutionProxy::initV8IfNeeded):
        (WebCore::WorkerContextExecutionProxy::evaluate):
        (WebCore::WorkerContextExecutionProxy::findOrCreateEventListenerHelper):
        (WebCore::WorkerContextExecutionProxy::RemoveEventListener):

2009-05-26  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=25974
        Enable timers in Chromuim workers.

        * bindings/v8/ScheduledAction.cpp:
        (WebCore::ScheduledAction::execute): Added function which can execute a callback using WorkerContext.
        * bindings/v8/ScheduledAction.h:
        (WebCore::ScheduledAction::ScheduledAction): added url parameter to capture the worker's location.
        * bindings/v8/custom/V8WorkerContextCustom.cpp:
        (WebCore::SetTimeoutOrInterval): replaced NotImplemented with code to create ScheduledAction and DOMTimer.
        Also, removed declarations for clearTimeout/clearInterval callbacks since they are now directly generated from IDL.

2009-05-26  Dimitri Glazkov  <dglazkov@chromium.org>

        Unreviewed, build fix.

        https://bugs.webkit.org/show_bug.cgi?id=23649
        Update V8 bindings to match SQLTransactionErrorCallback change.

        * bindings/v8/custom/V8CustomSQLTransactionErrorCallback.cpp:
        (WebCore::V8CustomSQLTransactionErrorCallback::handleEvent): Changed to return void.
        * bindings/v8/custom/V8CustomSQLTransactionErrorCallback.h: Ditto.

2009-05-26  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        Move FilterEffect to platform/graphics/filters. First step to get an
        SVG independent filter system.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/filters/FilterEffect.cpp: Added.
        (WebCore::FilterEffect::FilterEffect):
        (WebCore::FilterEffect::~FilterEffect):
        (WebCore::FilterEffect::externalRepresentation):
        * platform/graphics/filters/FilterEffect.h: Added.
        (WebCore::FilterEffect::xBoundingBoxMode):
        (WebCore::FilterEffect::setXBoundingBoxMode):
        (WebCore::FilterEffect::yBoundingBoxMode):
        (WebCore::FilterEffect::setYBoundingBoxMode):
        (WebCore::FilterEffect::widthBoundingBoxMode):
        (WebCore::FilterEffect::setWidthBoundingBoxMode):
        (WebCore::FilterEffect::heightBoundingBoxMode):
        (WebCore::FilterEffect::setHeightBoundingBoxMode):
        (WebCore::FilterEffect::subRegion):
        (WebCore::FilterEffect::setSubRegion):
        (WebCore::FilterEffect::resultImage):
        (WebCore::FilterEffect::setEffectBuffer):
        * svg/FilterEffect.cpp: Removed.
        * svg/FilterEffect.h: Removed.

2009-05-26  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=23649
        Update SQLTransactionErrorCallback to not return a value per changes in
        HTML5 spec.

        Test: storage/transaction-error-callback.html

        * bindings/js/JSCustomSQLTransactionErrorCallback.cpp:
        (WebCore::JSCustomSQLTransactionErrorCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionErrorCallback.h:
        * storage/SQLTransaction.cpp:
        (WebCore::SQLTransaction::SQLTransaction):
        (WebCore::SQLTransaction::postflightAndCommit):
        (WebCore::SQLTransaction::handleTransactionError):
        (WebCore::SQLTransaction::deliverTransactionErrorCallback):
        (WebCore::SQLTransaction::cleanupAfterTransactionErrorCallback):
        * storage/SQLTransaction.h:
        * storage/SQLTransactionErrorCallback.h:

2009-05-26  David Hyatt  <hyatt@apple.com>

        Reviewed by Darin Adler.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=25969

        Detect the case where we can fit without scrollbars when the view shrinks, so that we don't mistakenly
        continue to show scrollbars.

        Added two tests in fast/dynamic.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::updateScrollbars):

2009-05-26  Chris Fleizach  <cfleizach@apple.com>

        Reviewed by Mark Rowe.

        Bug 25801: change AccessibilityAria -> AccessibilityARIA
        https://bugs.webkit.org/show_bug.cgi?id=25801

        * GNUmakefile.am:
        * WebCore.order:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * accessibility/AXObjectCache.cpp:
        (WebCore::AXObjectCache::getOrCreate):
        * accessibility/AccessibilityARIAGrid.cpp: Copied from WebCore/accessibility/AccessibilityAriaGrid.cpp.
        (WebCore::AccessibilityARIAGrid::AccessibilityARIAGrid):
        (WebCore::AccessibilityARIAGrid::~AccessibilityARIAGrid):
        (WebCore::AccessibilityARIAGrid::create):
        (WebCore::AccessibilityARIAGrid::addChild):
        (WebCore::AccessibilityARIAGrid::addChildren):
        (WebCore::AccessibilityARIAGrid::cellForColumnAndRow):
        * accessibility/AccessibilityARIAGrid.h: Copied from WebCore/accessibility/AccessibilityAriaGrid.h.
        * accessibility/AccessibilityARIAGridCell.cpp: Copied from WebCore/accessibility/AccessibilityAriaGridCell.cpp.
        (WebCore::AccessibilityARIAGridCell::AccessibilityARIAGridCell):
        (WebCore::AccessibilityARIAGridCell::~AccessibilityARIAGridCell):
        (WebCore::AccessibilityARIAGridCell::create):
        (WebCore::AccessibilityARIAGridCell::parentTable):
        (WebCore::AccessibilityARIAGridCell::rowIndexRange):
        (WebCore::AccessibilityARIAGridCell::columnIndexRange):
        * accessibility/AccessibilityARIAGridCell.h: Copied from WebCore/accessibility/AccessibilityAriaGridCell.h.
        * accessibility/AccessibilityARIAGridRow.cpp: Copied from WebCore/accessibility/AccessibilityAriaGridRow.cpp.
        (WebCore::AccessibilityARIAGridRow::AccessibilityARIAGridRow):
        (WebCore::AccessibilityARIAGridRow::~AccessibilityARIAGridRow):
        (WebCore::AccessibilityARIAGridRow::create):
        (WebCore::AccessibilityARIAGridRow::parentTable):
        (WebCore::AccessibilityARIAGridRow::headerObject):
        * accessibility/AccessibilityARIAGridRow.h: Copied from WebCore/accessibility/AccessibilityAriaGridRow.h.
        * accessibility/AccessibilityAriaGrid.cpp: Removed.
        * accessibility/AccessibilityAriaGrid.h: Removed.
        * accessibility/AccessibilityAriaGridCell.cpp: Removed.
        * accessibility/AccessibilityAriaGridCell.h: Removed.
        * accessibility/AccessibilityAriaGridRow.cpp: Removed.
        * accessibility/AccessibilityAriaGridRow.h: Removed.

2009-05-26  Stephen White  <senorblanco@chromium.org>

        Reviewed by Dimitri Glazkov.

        https://bugs.webkit.org/show_bug.cgi?id=26012

        Fix the Skia path to normalize the given source rect when
        drawing patterns, so it accepts negative width/height (as CG does).
        Fixes Chromium bug http://www.crbug.com/6167.
        * platform/graphics/skia/ImageSkia.cpp:
        (WebCore::Image::drawPattern):

2009-05-26  Pavel Feldman  <pfeldman@chromium.org>

        Reviewed by Timothy Hatcher.

        Serialize calls to WebInspector. This is the first step where method 
        calls are being serialized to arrays (not yet JSON stringified ones) and 
        are being dispatched on the client. This change also allows client to override 
        InspectorFrontend, so that the serialized calls can be made on a given object
        instead of in-process WebInspector global. This will be the main control flow
        when InspectorController is decoupled from the in-process frontend.

        https://bugs.webkit.org/show_bug.cgi?id=26010

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::scriptObjectReady):
        (WebCore::InspectorController::overrideFrontendObject):
        (WebCore::InspectorController::show):
        (WebCore::InspectorController::populateScriptObjects):
        * inspector/InspectorController.h:
        * inspector/InspectorFrontend.cpp:
        (WebCore::InspectorFrontend::addMessageToConsole):
        (WebCore::InspectorFrontend::addResource):
        (WebCore::InspectorFrontend::updateResource):
        (WebCore::InspectorFrontend::removeResource):
        (WebCore::InspectorFrontend::updateFocusedNode):
        (WebCore::InspectorFrontend::setAttachedWindow):
        (WebCore::InspectorFrontend::inspectedWindowScriptObjectCleared):
        (WebCore::InspectorFrontend::showPanel):
        (WebCore::InspectorFrontend::populateInterface):
        (WebCore::InspectorFrontend::reset):
        (WebCore::InspectorFrontend::debuggerWasEnabled):
        (WebCore::InspectorFrontend::debuggerWasDisabled):
        (WebCore::InspectorFrontend::profilerWasEnabled):
        (WebCore::InspectorFrontend::profilerWasDisabled):
        (WebCore::InspectorFrontend::parsedScriptSource):
        (WebCore::InspectorFrontend::failedToParseScriptSource):
        (WebCore::InspectorFrontend::addProfile):
        (WebCore::InspectorFrontend::setRecordingProfile):
        (WebCore::InspectorFrontend::pausedScript):
        (WebCore::InspectorFrontend::resumedScript):
        (WebCore::InspectorFrontend::addDatabase):
        (WebCore::InspectorFrontend::addDOMStorage):
        (WebCore::InspectorFrontend::newFunctionCall):
        (WebCore::InspectorFrontend::callSimpleFunction):
        * inspector/InspectorFrontend.h:
        * inspector/front-end/inspector.js:
        (WebInspector.dispatch):

2009-05-25  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        <rdar://problem/6918671> REGRESSION (r41700): Crashes in debug DumpRenderTree at RefCountedBase::ref().

        * dom/QualifiedName.cpp: (WebCore::QualifiedName::QualifiedName):
        * dom/QualifiedName.h: (WebCore::QualifiedName::QualifiedNameImpl::QualifiedNameImpl):
        Adjust empty namespace before QNameComponentsTranslator black magic, not after.

2009-05-25  David Levin  <levin@chromium.org>

        Reviewed by Maciej Stachowiak and Oliver Hunt.

        Added forwarding headers.

        * ForwardingHeaders/wtf/CrossThreadRefCounted.h: Added.
        * ForwardingHeaders/wtf/OwnFastMallocPtr.h: Added.

2009-05-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        - WebCore side of <rdar://problem/6914001>.

        Add a new m_allowPopupsFromPlugin flag.
        
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::ScriptController):
        (WebCore::ScriptController::processingUserGesture):
        * bindings/js/ScriptController.h:
        (WebCore::ScriptController::setAllowPopupsFromPlugin):
        (WebCore::ScriptController::allowPopupsFromPlugin):

2009-05-25  Adam Barth  <abarth@webkit.org>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=26006

        Sort out our use of dynamicGlobalObject and lexicalGlobalObject for
        window.location.  The correct use appears to be as follows:

        1) Use dynamicGlobalObject to find the user gesture.
        2) Use dynamicGlobalObject to complete URLs.
        3) Use lexicalGlobalObject to find the referrer.
        4) Use lexicalGlobalObject for the frame navigation checks.
        5) Use lexicalGlobalObject for the XSS checks.

        Tests: http/tests/security/frameNavigation/context-for-location-assign.html
               http/tests/security/frameNavigation/context-for-location-href.html
               http/tests/security/frameNavigation/context-for-location.html

        * bindings/js/JSDOMBinding.cpp:
        (WebCore::shouldAllowNavigation):
        (WebCore::toLexicalFrame):
        (WebCore::processingUserGesture):
        (WebCore::completeURL):
        * bindings/js/JSDOMBinding.h:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::setLocation):
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::navigateIfAllowed):
        (WebCore::JSLocation::setHref):
        (WebCore::JSLocation::replace):
        (WebCore::JSLocation::reload):
        (WebCore::JSLocation::assign):
        (WebCore::JSLocation::toString):
        (WebCore::JSLocationPrototype::customPut):
        * bindings/v8/V8Utilities.cpp:
        (WebCore::processingUserGesture):
        (WebCore::shouldAllowNavigation):
        (WebCore::completeURL):
        (WebCore::navigateIfAllowed):
        * bindings/v8/V8Utilities.h:
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::V8Custom::WindowSetLocation):
        * bindings/v8/custom/V8LocationCustom.cpp:
        (WebCore::ACCESSOR_SETTER):
        (WebCore::CALLBACK_FUNC_DECL):

2009-05-25  Fridrich Strba  <fridrich.strba@bluewin.ch>

        Reviewed by Maciej Stachowiak.

        With Windows compilers older then MSVC 2005, the functions
        gmtime_s and localtime_s don't exist. The gmtime and localtime are
        on Windows always thread safe. So use them in the cases where
        gmtime_s and localtime_s are not present.

        * loader/FTPDirectoryDocument.cpp:
        * loader/FTPDirectoryParser.cpp:

2009-05-25  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        Follow up on r44120. PluginPackageMac.cpp is used
        by Qt on Mac and contained a copy of the m_browserFunc
        assignments and ::equal, ::hash and ::compareFileVersion.
        Change it to use the ones from PluginPackage.cpp as well.

        * plugins/mac/PluginPackageMac.cpp:
        (WebCore::PluginPackage::load):

2009-05-25  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        https://bugs.webkit.org/show_bug.cgi?id=25612

        Support conditionals in the tag factories, by placing
        feature #ifdefs around the individual factory functions
        and the registration.

        Made the Audio and Video elements conditional in the tag factories

        * html/HTMLTagNames.in:
        * dom/make_names.pl:

2009-05-25  Simon Hausmann  <simon.hausmann@nokia.com>

        Fix the Gtk build when video is disabled.

        * GNUmakefile.am: Always generate and compile the IDL files for the media
        elements. They contain proper feature #ifdefs.

2009-05-25  Simon Hausmann  <simon.hausmann@nokia.com>

        Fix the Qt build when video is disabled.

        * WebCore.pro: Always generate the IDL files for the media elements. They
        contain proper ENABLE(VIDEO) #ifdefs.

2009-05-25  Adam Barth  <abarth@webkit.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=26004

        The origin for postMessage should follow lexical scope, not dynamic
        scope.  Yes, this is a super-obscure corner case.

        Test: http/tests/security/postMessage/origin-follows-lexical-scope.html

        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::postMessage):
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::CALLBACK_FUNC_DECL):

2009-05-24  Darin Fisher  <darin@chromium.org>

        Reviewed by Mark Rowe.

        Fix build bustage related to PassOwnPtr changes.

        https://bugs.webkit.org/show_bug.cgi?id=25999

        * platform/graphics/chromium/TransparencyWin.cpp:

2009-05-24  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25988

        Minor cleanup in PluginPackage::hash. Let the compiler
        figure out the size of the array. Do not have it in the
        definition and specially not the in the call to
        StringImpl::hash.

        * plugins/PluginPackage.cpp:
        (WebCore::PluginPackage::hash):

2009-05-24  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25988

        Move ::hash, ::equal and ::compareFileVersion from
        the duplicated copies in PluginPackageQt.cpp and
        PluginPackageGtk to PluginPackage.cpp. We need to #ifdef
        this for the PluginPackageWin version. Use the new style
        ENABLE() for this feature/policy and enable it in the Gtk+
        and Qt buildsystem.

        * GNUmakefile.am:
        * WebCore.pro:
        * plugins/PluginPackage.cpp:
        (WebCore::PluginPackage::hash):
        (WebCore::PluginPackage::equal):
        (WebCore::PluginPackage::compareFileVersion):
        * plugins/gtk/PluginPackageGtk.cpp:
        * plugins/qt/PluginPackageQt.cpp:

2009-05-24  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25988

        So far the initialization of the browserfuncs struct
        is done in PluginPackageQt, PluginPackageGtk and
        PluginPackageWin there is no need for this duplication.

        The PluginPackageWin version got copied to PluginPackage

        * plugins/PluginPackage.cpp:
        (WebCore::PluginPackage::initializeBrowserFuncs):
        * plugins/PluginPackage.h:
        * plugins/gtk/PluginPackageGtk.cpp:
        (WebCore::PluginPackage::load):
        * plugins/qt/PluginPackageQt.cpp:
        (WebCore::PluginPackage::load):
        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackage::load):

2009-05-24  Dirk Schulze  <krit@webkit.org>

        Reviewed by Nikolas Zimmermann.

        WebKit needs cross-platform filter system
        [https://bugs.webkit.org/show_bug.cgi?id=19991]

        Added standard input for filter system.

        No testcases were added. Filter system is still off.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/filters/SourceAlpha.cpp: Added.
        (WebCore::SourceAlpha::create):
        (WebCore::SourceAlpha::effectName):
        (WebCore::SourceAlpha::apply):
        (WebCore::SourceAlpha::dump):
        * platform/graphics/filters/SourceAlpha.h: Added.
        (WebCore::SourceAlpha::SourceAlpha):
        * platform/graphics/filters/SourceGraphic.cpp: Added.
        (WebCore::SourceGraphic::create):
        (WebCore::SourceGraphic::effectName):
        (WebCore::SourceGraphic::apply):
        (WebCore::SourceGraphic::dump):
        * platform/graphics/filters/SourceGraphic.h: Added.
        (WebCore::SourceGraphic::SourceGraphic):
        * svg/FilterBuilder.cpp: Added.
        (WebCore::FilterBuilder::FilterBuilder):
        (WebCore::FilterBuilder::add):
        (WebCore::FilterBuilder::getEffectById):
        (WebCore::FilterBuilder::clearEffects):
        * svg/FilterBuilder.h:

2009-05-24  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25612

        Add support conditionals in the JSC bindings generator code for attributes,
        by placing feature #ifdefs around the setters/getters.

        Made the audio and video element specific DOM attributes conditional
        in the generated code, by moving the #ifdefs from the IDL files into
        the generated code. This allows for re-using the same generated code
        with or without ENABLE(VIDEO).

        * page/DOMWindow.idl:
        * bindings/scripts/CodeGeneratorJS.pm:

2009-05-23  Holger Hans Peter Freyther  <zecke@selfish.org>

        Unreviewed build fix for Qt. Change signature to have PassOwnPtr.

        * platform/text/qt/TextCodecQt.cpp:
        (WebCore::newTextCodecQt):

2009-05-23  Dan Bernstein  <mitz@apple.com>

        Reviewed by Darin Adler.

        - clean up ColorMac a little

        * platform/graphics/mac/ColorMac.h: Whitespace change.
        * platform/graphics/mac/ColorMac.mm: Removed redundant #import
        statements and sorted the remaining ones.
        (WebCore::makeRGBAFromNSColor): Replaced four Objective-C method calls
        with a single call and removed redundant casts to int.
        (WebCore::nsColor): Removed ".0f" from number literals used as CGFloats.
        In one case, this avoids an intermediate conversion to float before
        conversion to double on 64-bit.
        (WebCore::CGColorFromNSColor): Replaced four Objective-C method calls
        with a single call.
        (WebCore::focusRingColor):
        (+[WebCoreControlTintObserver controlTintDidChange]): Whitespace change.

2009-05-23  Jan Michael Alonzo  <jmalonzo@webkit.org>

        Reviewed by Xan Lopez.

        [Gtk] ROLE_ROW_HEADER should not be used for list item bullets/numbers
        https://bugs.webkit.org/show_bug.cgi?id=25900

        Use ATK_ROLE_TEXT for ListMarkerRole.

        * accessibility/gtk/AccessibilityObjectWrapperAtk.cpp:
        (atkRole):

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Reformat WebCore::requiresContextForWordBoundary()

        * platform/text/TextBoundaries.h:
        (WebCore::requiresContextForWordBoundary):

2009-05-23  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Not reviewed. Roll out ResourceHandle patch, that I accidently included in my last commit.

        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::shouldContentSniffURL):

2009-05-23  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=23808

        After a long journey, add the last missing ABC to share form control element support with HTMLSelectElement.
        RenderListBox/RenderMenuList operates on SelectElement instead of HTMLSelectElement now, querying selected index etc.
        This makes it possible to use these render objects for ie. WML, as it's done before for input & option elements.

        WMLSelectElement will be created soon, in a follow-up patch, adding more methods to SelectElement, sharing code between
        HTMLSelectElement/WMLSelectElement.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * accessibility/AccessibilityListBox.cpp:
        (WebCore::AccessibilityListBox::addChildren):
        (WebCore::AccessibilityListBox::doAccessibilityHitTest):
        * accessibility/AccessibilityListBoxOption.cpp:
        (WebCore::AccessibilityListBoxOption::listBoxOptionIndex):
        * accessibility/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::actionElement):
        * dom/Element.h:
        (WebCore::Element::isFormControlElement):
        (WebCore::Element::dispatchFormControlChangeEvent):
        * dom/SelectElement.cpp: Added.
        (WebCore::toSelectElement):
        * dom/SelectElement.h: Added.
        (WebCore::SelectElement::~SelectElement):
        * html/HTMLFormControlElement.cpp:
        (WebCore::HTMLFormControlElement::dispatchFormControlChangeEvent):
        * html/HTMLFormControlElement.h:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::setChecked):
        (WebCore::HTMLInputElement::defaultEventHandler):
        * html/HTMLOptionElement.cpp:
        (WebCore::HTMLOptionElement::index):
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::selectedIndex):
        (WebCore::HTMLSelectElement::lastSelectedListIndex):
        (WebCore::HTMLSelectElement::deselectItems):
        (WebCore::HTMLSelectElement::setSelectedIndex):
        (WebCore::HTMLSelectElement::length):
        (WebCore::HTMLSelectElement::remove):
        (WebCore::HTMLSelectElement::value):
        (WebCore::HTMLSelectElement::setValue):
        (WebCore::HTMLSelectElement::saveFormControlState):
        (WebCore::HTMLSelectElement::restoreFormControlState):
        (WebCore::HTMLSelectElement::selectAll):
        (WebCore::HTMLSelectElement::appendFormData):
        (WebCore::HTMLSelectElement::optionToListIndex):
        (WebCore::HTMLSelectElement::listToOptionIndex):
        (WebCore::HTMLSelectElement::recalcListItems):
        (WebCore::HTMLSelectElement::reset):
        (WebCore::HTMLSelectElement::dispatchFocusEvent):
        (WebCore::HTMLSelectElement::dispatchBlurEvent):
        (WebCore::HTMLSelectElement::menuListDefaultEventHandler):
        (WebCore::HTMLSelectElement::listBoxDefaultEventHandler):
        (WebCore::HTMLSelectElement::setActiveSelectionAnchorIndex):
        (WebCore::HTMLSelectElement::updateListBoxSelection):
        (WebCore::HTMLSelectElement::menuListOnChange):
        (WebCore::HTMLSelectElement::listBoxOnChange):
        (WebCore::HTMLSelectElement::saveLastSelection):
        (WebCore::HTMLSelectElement::typeAheadFind):
        (WebCore::HTMLSelectElement::nextSelectableListIndex):
        (WebCore::HTMLSelectElement::previousSelectableListIndex):
        (WebCore::HTMLSelectElement::setLength):
        (WebCore::HTMLSelectElement::checkListItems):
        * html/HTMLSelectElement.h:
        (WebCore::HTMLSelectElement::size):
        (WebCore::HTMLSelectElement::multiple):
        (WebCore::HTMLSelectElement::listItems):
        (WebCore::HTMLSelectElement::setActiveSelectionEndIndex):
        * platform/network/ResourceHandle.cpp:
        (WebCore::ResourceHandle::shouldContentSniffURL):
        * rendering/RenderFileUploadControl.cpp:
        (WebCore::RenderFileUploadControl::valueChanged):
        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::RenderListBox):
        (WebCore::RenderListBox::updateFromElement):
        (WebCore::RenderListBox::scrollToRevealSelection):
        (WebCore::RenderListBox::size):
        (WebCore::RenderListBox::numItems):
        (WebCore::RenderListBox::paintItemForeground):
        (WebCore::RenderListBox::paintItemBackground):
        (WebCore::RenderListBox::panScroll):
        (WebCore::RenderListBox::autoscroll):
        (WebCore::RenderListBox::stopAutoscroll):
        (WebCore::RenderListBox::valueChanged):
        (WebCore::RenderListBox::nodeAtPoint):
        * rendering/RenderListBox.h:
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::RenderMenuList):
        (WebCore::RenderMenuList::updateOptionsWidth):
        (WebCore::RenderMenuList::updateFromElement):
        (WebCore::RenderMenuList::setTextFromOption):
        (WebCore::RenderMenuList::showPopup):
        (WebCore::RenderMenuList::valueChanged):
        (WebCore::RenderMenuList::itemText):
        (WebCore::RenderMenuList::itemIsEnabled):
        (WebCore::RenderMenuList::itemStyle):
        (WebCore::RenderMenuList::itemBackgroundColor):
        (WebCore::RenderMenuList::listSize):
        (WebCore::RenderMenuList::selectedIndex):
        (WebCore::RenderMenuList::itemIsSeparator):
        (WebCore::RenderMenuList::itemIsLabel):
        (WebCore::RenderMenuList::itemIsSelected):
        (WebCore::RenderMenuList::setTextFromItem):
        * rendering/RenderMenuList.h:
        * rendering/RenderSlider.cpp:
        (WebCore::RenderSlider::setValueForPosition):

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Fix Gtk/Qt builds for PassOwnPtr

        * platform/graphics/cairo/ImageCairo.cpp:
        (WebCore::Image::drawPattern): Use an OwnPtr<ImageBuffer>
        instead of an std::auto_ptr<ImageBuffer> to store the result of
        ImageBuffer::create() now that it returns a
        PassOwnPtr<ImageBuffer>.
        * platform/graphics/qt/PathQt.cpp:
        (WebCore::Path::strokeContains): Ditto.
        (WebCore::Path::strokeBoundingRect): Ditto.

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Part 2 of 2: Bug 25495: Implement PassOwnPtr and replace uses of std::auto_ptr

        <https://bugs.webkit.org/show_bug.cgi?id=25495>

        Reviewed by Oliver Hunt.

        No test cases added since there is no change in behavior.

        * WebCore.base.exp: Updated export for
        HistoryItem::setRedirectURLs() which now takes a PassOwnPtr.
        * dom/Node.cpp:
        (WebCore::Node::childNodes): Use NodeListsNodeData::create()
        instead of new NodeListsNodeData.
        (WebCore::Node::registerDynamicNodeList): Ditto.
        (WebCore::Node::getElementsByTagNameNS): Ditto.
        (WebCore::Node::getElementsByName): Ditto.
        (WebCore::Node::getElementsByClassName): Ditto.
        * dom/NodeRareData.h:
        (WebCore::NodeListsNodeData::create): Added.  Implements
        create() pattern popularized by RefCounted classes.
        (WebCore::NodeListsNodeData::NodeListsNodeData): Declared
        private constructor.
        (WebCore::NodeRareData::setNodeLists): Now takes a PassOwnPtr<>
        instead of an auto_ptr<>.
        * history/HistoryItem.cpp:
        (WebCore::HistoryItem::setRedirectURLs): Ditto.
        * history/HistoryItem.h:
        (WebCore::HistoryItem::setRedirectURLs): Ditto.
        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::drawTextInternal): Use
        OwnPtr<> instead of auto_ptr<> for stack variable.
        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::createImageBuffer): Updated to use
        assignment operator now that ImageBuffer::create() returns a
        PassOwnPtr<>.
        * loader/EmptyClients.h:
        (WebCore::EmptyChromeClient::createHTMLParserQuirks): Return a
        PassOwnPtr<> instead of a raw HTMLParserQuirks pointer.
        * page/ChromeClient.h:
        (WebCore::ChromeClient::createHTMLParserQuirks): Ditto.
        * platform/graphics/GeneratedImage.cpp:
        (WebCore::GeneratedImage::drawPattern): Use OwnPtr<> instead of
        auto_ptr<> for stack variable.
        * platform/graphics/ImageBuffer.h:
        (WebCore::ImageBuffer::create): Return PassOwnPtr<> instead of
        auto_ptr<>.  Use OwnPtr<> instead of auto_ptr<> for stack
        variable.
        * platform/mac/ScrollbarThemeMac.mm:
        (WebCore::ScrollbarThemeMac::paint): Use OwnPtr<> instead of
        auto_ptr<> for stack variable.
        * platform/text/TextCodec.h:
        (WebCore::NewTextCodecFunction): Return PassOwnPtr<> instead of
        auto_ptr<>.
        * platform/text/TextCodecICU.cpp:
        (WebCore::newTextCodecICU): Ditto.
        * platform/text/TextCodecLatin1.cpp:
        (WebCore::newStreamingTextDecoderWindowsLatin1): Ditto.
        * platform/text/TextCodecUTF16.cpp:
        (WebCore::newStreamingTextDecoderUTF16LE): Ditto.
        (WebCore::newStreamingTextDecoderUTF16BE): Ditto.
        * platform/text/TextCodecUserDefined.cpp:
        (WebCore::newStreamingTextDecoderUserDefined): Ditto.
        * platform/text/TextEncodingRegistry.cpp:
        (WebCore::newTextCodec): Ditto.
        * platform/text/TextEncodingRegistry.h:
        (WebCore::newTextCodec): Ditto.
        * platform/text/mac/TextCodecMac.cpp:
        (WebCore::newTextCodecMac): Ditto.
        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintFillLayerExtended): Use
        OwnPtr<> instead of auto_ptr<> for stack variable.
        * svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::drawMaskerContent): Ditto.  Return
        OwnPtr<> instead of auto_ptr<>.
        * svg/SVGMaskElement.h:
        (WebCore::SVGMaskElement::drawMaskerContent): Return OwnPtr<>
        instead of auto_ptr<>.
        * svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::buildPattern): Use OwnPtr<> instead
        of auto_ptr<> for stack variable.
        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::nativeImageForCurrentFrame): Updated to use
        assignment operator now that ImageBuffer::create() returns a
        PassOwnPtr<>.
        * svg/graphics/SVGPaintServerGradient.cpp:
        (WebCore::createMaskAndSwapContextForTextGradient): Use OwnPtr<>
        instead of auto_ptr<> for stack variable.
        * svg/graphics/SVGPaintServerPattern.cpp:
        (WebCore::SVGPaintServerPattern::setTile): Updated to take a
        PassOwnPtr<> instead of an auto_ptr<>.
        (WebCore::SVGPaintServerPattern::setup): Use OwnPtr<> instead of
        auto_ptr<> for stack variable.
        * svg/graphics/SVGPaintServerPattern.h:
        (WebCore::SVGPaintServerPattern::setTile): Updated to take a
        PassOwnPtr<> instead of an auto_ptr<>.
        * svg/graphics/SVGResourceMasker.cpp:
        (WebCore::SVGResourceMasker::applyMask): Updated to use
        assignment operator now that SVGMaskElement::drawMaskerContent()
        returns a PassOwnPtr<>.  Use OwnPtr<> instead of auto_ptr<> for
        stack variable.

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Part 1 of 2: Bug 25495: Implement PassOwnPtr and replace uses of std::auto_ptr

        <https://bugs.webkit.org/show_bug.cgi?id=25495>

        Reviewed by Oliver Hunt.

        * ForwardingHeaders/wtf/OwnPtrCommon.h: Added.
        * ForwardingHeaders/wtf/PassOwnPtr.h: Added.
        * WebCore.vcproj/WebCore.vcproj: Added OwnPtrCommon.h and
        PassOwnPtr.h.

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Fix Mac builds by backing out r44093

        * bindings/js/JSCustomPositionCallback.cpp:
        * bindings/js/JSCustomPositionCallback.h:
        * bindings/js/JSCustomPositionErrorCallback.cpp:
        * bindings/js/JSCustomPositionErrorCallback.h:
        * bindings/js/JSGeolocationCustom.cpp:
        * page/Geolocation.cpp:
        * page/Geolocation.idl:
        * page/Geoposition.cpp:
        * page/Geoposition.h:
        * page/Geoposition.idl:
        * page/Navigator.cpp:
        (WebCore::Navigator::disconnectFrame):
        (WebCore::Navigator::geolocation):
        * page/PositionError.idl:
        * platform/GeolocationService.cpp:
        (WebCore::GeolocationService::create):

2009-05-23  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Eric Seidel.

        Add GEOLOCATION guards around Geolocation API code
        https://bugs.webkit.org/show_bug.cgi?id=25756

        * bindings/js/JSCustomPositionCallback.cpp:
        * bindings/js/JSCustomPositionCallback.h:
        * bindings/js/JSCustomPositionErrorCallback.cpp:
        * bindings/js/JSCustomPositionErrorCallback.h:
        * bindings/js/JSGeolocationCustom.cpp:
        * page/Geolocation.cpp:
        * page/Geolocation.idl:
        * page/Geoposition.cpp:
        * page/Geoposition.h:
        * page/Geoposition.idl:
        * page/Navigator.cpp:
        (WebCore::Navigator::disconnectFrame):
        (WebCore::Navigator::geolocation):
        * page/PositionError.idl:
        * platform/GeolocationService.cpp:

2009-05-23  David Kilzer  <ddkilzer@apple.com>

        Rename startupdateStyleIfNeededDispatcher to startUpdateStyleIfNeededDispatcher

        In r42377, startUpdateRenderingDispatcher() was renamed to
        startupdateStyleIfNeededDispatcher(), but the camelCase "U" was
        dropped.  This change restores it.

        * WebCore.order:
        * page/animation/AnimationController.cpp:
        (WebCore::AnimationControllerPrivate::startUpdateStyleIfNeededDispatcher):
        (WebCore::AnimationControllerPrivate::addEventToDispatch):
        (WebCore::AnimationControllerPrivate::addNodeChangeToDispatch):
        (WebCore::AnimationControllerPrivate::pauseAnimationAtTime):
        (WebCore::AnimationControllerPrivate::pauseTransitionAtTime):
        * page/animation/AnimationControllerPrivate.h:

2009-05-23  Holger Hans Peter Freyther  <zecke@selfish.org>

        Unreviewed build-fix for Qt. Disable SVG Filters.

        SVG Filters can not be built right now and Qt should not have
        them enabled anyway as they do not carry out any filtering.

        * WebCore.pro:

2009-05-23  Dirk Schulze  <krit@webkit.org>

        Unreviewed build-fix for gtk. Remove source input files
        for SVG filter system from the build for the moment and
        add them later again.

        * GNUmakefile.am:

2009-05-23  Dirk Schulze  <krit@webkit.org>

        Reviewed by Eric Seidel.

        WebKit needs cross-platform filter system
        [https://bugs.webkit.org/show_bug.cgi?id=19991]

        Preparing Filter primitves for the new filter system.

        No testcases were added. SVG filters are off by default.

        * GNUmakefile.am:
        * platform/graphics/filters/FEBlend.cpp:
        (WebCore::FEBlend::apply):
        * platform/graphics/filters/FEBlend.h:
        * platform/graphics/filters/FEColorMatrix.cpp:
        (WebCore::FEColorMatrix::apply):
        * platform/graphics/filters/FEColorMatrix.h:
        * platform/graphics/filters/FEComponentTransfer.cpp:
        (WebCore::FEComponentTransfer::apply):
        * platform/graphics/filters/FEComponentTransfer.h:
        * platform/graphics/filters/FEComposite.cpp:
        (WebCore::FEComposite::apply):
        * platform/graphics/filters/FEComposite.h:
        * svg/Filter.h:
        * svg/FilterBuilder.h:
        (WebCore::FilterBuilder::lastFilter):
        * svg/FilterEffect.cpp:
        (WebCore::FilterEffect::FilterEffect):
        * svg/FilterEffect.h:
        (WebCore::FilterEffect::xBoundingBoxMode):
        (WebCore::FilterEffect::setXBoundingBoxMode):
        (WebCore::FilterEffect::yBoundingBoxMode):
        (WebCore::FilterEffect::setYBoundingBoxMode):
        (WebCore::FilterEffect::widthBoundingBoxMode):
        (WebCore::FilterEffect::setWidthBoundingBoxMode):
        (WebCore::FilterEffect::heightBoundingBoxMode):
        (WebCore::FilterEffect::setHeightBoundingBoxMode):
        (WebCore::FilterEffect::subRegion):
        (WebCore::FilterEffect::setSubRegion):
        (WebCore::FilterEffect::resultImage):
        (WebCore::FilterEffect::setEffectBuffer):
        * svg/graphics/filters/SVGFEConvolveMatrix.cpp:
        (WebCore::FEConvolveMatrix::apply):
        * svg/graphics/filters/SVGFEConvolveMatrix.h:
        * svg/graphics/filters/SVGFEDiffuseLighting.cpp:
        (WebCore::FEDiffuseLighting::apply):
        * svg/graphics/filters/SVGFEDiffuseLighting.h:
        * svg/graphics/filters/SVGFEDisplacementMap.cpp:
        (WebCore::FEDisplacementMap::apply):
        * svg/graphics/filters/SVGFEDisplacementMap.h:
        * svg/graphics/filters/SVGFEFlood.cpp:
        (WebCore::FEFlood::apply):
        * svg/graphics/filters/SVGFEFlood.h:
        * svg/graphics/filters/SVGFEGaussianBlur.cpp:
        (WebCore::FEGaussianBlur::apply):
        * svg/graphics/filters/SVGFEGaussianBlur.h:
        * svg/graphics/filters/SVGFEImage.cpp:
        (WebCore::FEImage::apply):
        * svg/graphics/filters/SVGFEImage.h:
        * svg/graphics/filters/SVGFEMerge.cpp:
        (WebCore::FEMerge::apply):
        * svg/graphics/filters/SVGFEMerge.h:
        * svg/graphics/filters/SVGFEMorphology.cpp:
        (WebCore::FEMorphology::apply):
        * svg/graphics/filters/SVGFEMorphology.h:
        * svg/graphics/filters/SVGFEOffset.cpp:
        (WebCore::FEOffset::apply):
        * svg/graphics/filters/SVGFEOffset.h:
        * svg/graphics/filters/SVGFESpecularLighting.cpp:
        (WebCore::FESpecularLighting::apply):
        * svg/graphics/filters/SVGFESpecularLighting.h:
        * svg/graphics/filters/SVGFETile.cpp:
        (WebCore::FETile::apply):
        * svg/graphics/filters/SVGFETile.h:
        * svg/graphics/filters/SVGFETurbulence.cpp:
        (WebCore::FETurbulence::apply):
        * svg/graphics/filters/SVGFETurbulence.h:

2009-05-22  Dirk Schulze  <krit@webkit.org>

        Unreviewed build-fix for gtk. Breakage caused by a wrong call of ImageBuffer.

        * platform/graphics/cairo/ImageCairo.cpp:
        (WebCore::Image::drawPattern):

2009-05-22  Dirk Schulze  <vbs85@gmx.de>

        Reviewed by Eric Seidel.

        Added the use of tileRect() for a correct drawing of
        border-images.

        Testcases for border-image are in fast/borders like
        border-image-01.html and will be activated for cairo, once
        gtk supports pixel tests.

        https://bugs.webkit.org/show_bug.cgi?id=19652
        [CAIRO] wrong drawing of border-image

        * platform/graphics/cairo/ImageCairo.cpp:
        (WebCore::Image::drawPattern):

2009-05-22  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25684

        Ask the Scrollbar for the orientation.

        Use Scrollbar::orientation to figure out the
        direction of scrolling.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::valueChanged):

2009-05-22  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6916082> Incorrect handling of % as CSS value.

        Test: fast/css/percent-character-as-value.html

        * css/CSSGrammar.y: Make a stray % character reliably cause
        CSS parsing to succeed, but the CSS value to be ignored because
        of incorrect type. A type of 0 has this effect.

2009-05-22  Brent Fulgham  <bfulgham@webkit.org>

        Reviewed by Adam Roben.

        https://bugs.webkit.org/show_bug.cgi?id=25971
        Correct a handful of build errors in the Windows Cairo variant
        due to missing VIDEO support.

        * WebCore.vcproj/WebCore.vcproj: Exclude RenderMediaControls for
          the Cairo-based Windows target.
        * rendering/RenderThemeWin.cpp: Avoid #include of RenderMediaControls
          for non-VIDEO builds.

2009-05-22  David Kilzer  <ddkilzer@apple.com>

        One <limits> is enough

        * html/HTMLMediaElement.cpp: Removed duplicate #include <limits>.

2009-05-22  Jon Honeycutt  <jhoneycutt@apple.com>

        <rdar://problem/6915957> REGRESSION: Hang when leaving page with VLC
        plug-in

        Reviewed by Steve Falkenburg.

        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackage::determineQuirks):
        Look for the VLC plug-in's new name.

2009-05-22  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Fisher.

        https://bugs.webkit.org/show_bug.cgi?id=25966

        Remove redudant member from Chromium's ResourceRequest.  We already
        have this data in the cross-platform ResourceRequestBase.  Also, rename
        ChromiumBridge parameter to be consistant with the new name for this
        piece of data.

        * platform/chromium/ChromiumBridge.h:
        * platform/network/chromium/ResourceRequest.h:

2009-05-22  Kevin Watters  <kevinwatters@gmail.com>

        Reviewed by Kevin Ollivier.

        Only account for overhang for multi-character strings.
        
        https://bugs.webkit.org/show_bug.cgi?id=25961

        * platform/wx/wxcode/win/fontprops.cpp:
        (GetTextExtent):

2009-05-22  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix. Switch to CURL cookies so we can benefit from API updates.

        * platform/wx/TemporaryLinkStubs.cpp:
        * webcore-wx.bkl:

2009-05-22  Peter Kasting  <pkasting@google.com>

        Reviewed by Darin Fisher.

        https://bugs.webkit.org/show_bug.cgi?id=25709 part one
        Indent contents of namespaces in header files, to comply with the
        style guide.  No functional change.

        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::):
        (WebCore::RGBA32Buffer::RGBA32Buffer):
        (WebCore::RGBA32Buffer::clear):
        (WebCore::RGBA32Buffer::bytes):
        (WebCore::RGBA32Buffer::rect):
        (WebCore::RGBA32Buffer::height):
        (WebCore::RGBA32Buffer::status):
        (WebCore::RGBA32Buffer::duration):
        (WebCore::RGBA32Buffer::disposalMethod):
        (WebCore::RGBA32Buffer::hasAlpha):
        (WebCore::RGBA32Buffer::setRect):
        (WebCore::RGBA32Buffer::ensureHeight):
        (WebCore::RGBA32Buffer::setStatus):
        (WebCore::RGBA32Buffer::setDuration):
        (WebCore::RGBA32Buffer::setDisposalMethod):
        (WebCore::RGBA32Buffer::setHasAlpha):
        (WebCore::RGBA32Buffer::setRGBA):
        (WebCore::ImageDecoder::m_failed):
        (WebCore::ImageDecoder::~ImageDecoder):
        (WebCore::ImageDecoder::setData):
        (WebCore::ImageDecoder::size):
        (WebCore::ImageDecoder::frameCount):
        (WebCore::ImageDecoder::repetitionCount):
        (WebCore::ImageDecoder::supportsAlpha):
        (WebCore::ImageDecoder::failed):
        (WebCore::ImageDecoder::setFailed):
        (WebCore::ImageDecoder::clearFrameBufferCache):
        * platform/image-decoders/bmp/BMPImageDecoder.h:
        (WebCore::BMPImageDecoder::filenameExtension):
        * platform/image-decoders/gif/GIFImageDecoder.h:
        (WebCore::GIFImageDecoder::filenameExtension):
        (WebCore::GIFImageDecoder::frameDurationAtIndex):
        (WebCore::GIFImageDecoder::):
        * platform/image-decoders/ico/ICOImageDecoder.h:
        (WebCore::ICOImageDecoder::filenameExtension):
        * platform/image-decoders/jpeg/JPEGImageDecoder.h:
        (WebCore::JPEGImageDecoder::filenameExtension):
        (WebCore::JPEGImageDecoder::supportsAlpha):
        (WebCore::JPEGImageDecoder::reader):
        (WebCore::JPEGImageDecoder::setSize):
        * platform/image-decoders/png/PNGImageDecoder.h:
        (WebCore::PNGImageDecoder::filenameExtension):
        (WebCore::PNGImageDecoder::reader):
        (WebCore::PNGImageDecoder::decodingFailed):
        * platform/image-decoders/xbm/XBMImageDecoder.h:
        (WebCore::XBMImageDecoder::filenameExtension):

2009-05-22  Dominik Röttsches  <dominik.roettsches@access-company.com>

        Reviewed by Gustavo Noronha.

        https://bugs.webkit.org/show_bug.cgi?id=15914
        [GTK] Implement Unicode functionality using GLib

        Minor changes that allow building a hybrid version of WebKit
        that has WTF Unicode backend based on GLib functions while
        text codecs and TextBreakIterator remain based on ICU.

        Fixed some includes that were assuming a WTF ICU backend and
        introduced temporary usage of WTF_USE_GLIB_ICU_UNICODE_HYBRID
        macro.

        * platform/ThreadGlobalData.cpp:
        (WebCore::ThreadGlobalData::ThreadGlobalData):
        (WebCore::ThreadGlobalData::~ThreadGlobalData):
        * platform/ThreadGlobalData.h:
        * platform/text/TextBoundariesICU.cpp:
        * platform/text/TextCodecICU.h:
        * platform/text/TextEncoding.cpp:
        (WebCore::TextEncoding::encode):
        * platform/text/TextEncodingRegistry.cpp:
        (WebCore::buildBaseTextCodecMaps):
        (WebCore::extendTextCodecMaps):

2009-05-22  Adam Barth  <abarth@webkit.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25955

        Remove the policyBaseURL parameter from setCookie.  This parameter is
        redundant with the document parameter.

        * WebCore.base.exp:
        * WebCore.order:
        * dom/Document.cpp:
        (WebCore::Document::setCookie):
        * platform/CookieJar.h:
        * platform/mac/CookieJar.mm:
        (WebCore::setCookies):
        * platform/network/chromium/CookieJarChromium.cpp:
        (WebCore::setCookies):
        * platform/network/curl/CookieJarCurl.cpp:
        (WebCore::setCookies):
        * platform/network/soup/CookieJarSoup.cpp:
        (WebCore::setCookies):
        * platform/network/win/CookieJarCFNetWin.cpp:
        (WebCore::setCookies):
        * platform/network/win/CookieJarWin.cpp:
        (WebCore::setCookies):
        * platform/qt/CookieJarQt.cpp:
        (WebCore::setCookies):

2009-05-22  Adam Barth  <abarth@webkit.org>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25955

        Rename policyBaseURL and mainDocumentURL to firstPartyForCookies.  The
        previous names were confusing and inaccurate.

        * WebCore.order:
        * dom/Document.cpp:
        (WebCore::Document::setCookie):
        * dom/Document.h:
        (WebCore::Document::firstPartyForCookies):
        (WebCore::Document::setFirstPartyForCookies):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::begin):
        (WebCore::FrameLoader::updateFirstPartyForCookies):
        (WebCore::FrameLoader::setFirstPartyForCookies):
        (WebCore::FrameLoader::open):
        (WebCore::FrameLoader::addExtraFieldsToRequest):
        (WebCore::FrameLoader::loadResourceSynchronously):
        * loader/FrameLoader.h:
        * loader/MainResourceLoader.cpp:
        (WebCore::MainResourceLoader::willSendRequest):
        (WebCore::ResourceRequestBase::adopt):
        (WebCore::ResourceRequestBase::copyData):
        (WebCore::ResourceRequestBase::firstPartyForCookies):
        (WebCore::ResourceRequestBase::setFirstPartyForCookies):
        (WebCore::equalIgnoringHeaderFields):
        * platform/network/ResourceRequestBase.h:
        * platform/network/cf/ResourceRequestCFNet.cpp:
        (WebCore::ResourceRequest::doUpdatePlatformRequest):
        (WebCore::ResourceRequest::doUpdateResourceRequest):
        * platform/network/chromium/CookieJarChromium.cpp:
        (WebCore::setCookies):
        * platform/network/mac/ResourceRequestMac.mm:
        (WebCore::ResourceRequest::doUpdateResourceRequest):
        (WebCore::ResourceRequest::doUpdatePlatformRequest):
        * platform/network/ResourceRequestBase.cpp:
        (WebCore::ResourceRequestBase::firstPartyForCookies):
        (WebCore::ResourceRequestBase::setFirstPartyForCookies):
        * platform/network/chromium/CookieJarChromium.cpp:
        (WebCore::setCookies):
        * platform/network/curl/CookieJarCurl.cpp:
        (WebCore::setCookies):
        * platform/network/soup/CookieJarSoup.cpp:
        (WebCore::setCookies):
        * platform/network/win/CookieJarCFNetWin.cpp:
        (WebCore::setCookies):
        * platform/network/win/CookieJarWin.cpp:
        (WebCore::setCookies):
        * platform/qt/CookieJarQt.cpp:
        (WebCore::setCookies):

2009-05-22  Pavel Feldman  <pfeldman@chromium.org>

        Fix the call to editingCancelled to be this._editingCancelled, since
        editingCancelled doesn't exist and throws an exception.

        <https://bugs.webkit.org/show_bug.cgi?id=24881>

        Reviewed by Timothy Hatcher.

        * inspector/front-end/ElementsTreeOutline.js:
        (WebInspector.ElementsTreeElement.prototype._attributeEditingCommitted):

2009-05-22  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=25928
        Several errors detected by cppcheck

        Fix all (the only one) problem in cross-platform code found by the tool. Port maintainers
        should take a look at other reports.

        * css/CSSParser.cpp: (WebCore::CSSParser::addProperty): Don't leak the property even if there
        are billions of those.

2009-05-22  Shinichiro Hamaji  <hamaji@google.com>

        Reviewed by Oliver Hunt.

        Remove optimization path alpha=0 case from GraphicContext(CG|Skia).
        This optimization doesn't make sense for some composite mode (e.g., 'copy' operation).

        https://bugs.webkit.org/show_bug.cgi?id=25956

        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::drawRect):
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::fillRoundedRect):
        (WebCore::GraphicsContext::strokeRect):
        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::strokeRect):

2009-05-22  Xan Lopez  <xlopez@igalia.com>

        Unreviewed build fix.

        Revert the whole thing, since we can't figure out a way to make it
        work in all platforms.

        * rendering/SVGInlineTextBox.cpp:
        (WebCore::pathForDecoration):
        * svg/SVGLength.cpp:
        (WebCore::SVGLength::PercentageOfViewport):

2009-05-22  Xan Lopez  <xlopez@igalia.com>

        Try to fix Windows build.

        Apparently it can't tell if '1.0f' is float or double, so cast to
        float.

        * rendering/SVGInlineTextBox.cpp:
        (WebCore::pathForDecoration):

2009-05-22  Xan Lopez  <xlopez@igalia.com>

        Try to fix breakage from the previous patch.

        * rendering/SVGInlineTextBox.cpp:
        (WebCore::pathForDecoration):
        * svg/SVGLength.cpp:
        (WebCore::SVGLength::PercentageOfViewport):

2009-05-15  Fridrich Strba  <fridrich.strba@bluewin.ch>

        Reviewed by Maciej Stachowiak.

        https://bugs.webkit.org/show_bug.cgi?id=25805
        In debug build, mingw win32 build has problems with powf

        Change C-style calls to powf and sqrtf to C++-style calls to
        overloaded pow and sqrt. This solves also a problem with mingw
        compiler during the debug build.

        * rendering/SVGInlineTextBox.cpp:
        (WebCore::pathForDecoration):
        * svg/SVGLength.cpp:
        (WebCore::SVGLength::PercentageOfViewport):

2009-05-21  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/6913680> Update image caching options.
        Disable extra ImageIO cache because we already handle caching decoded image data.

        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::imageSourceOptions):

2009-05-21  Albert J. Wong  <ajwong@chromium.org>

        Reviewed by Eric Seidel.

        Bug 25903: Create a default UI theme for media controls in Chromium.
        https://bugs.webkit.org/show_bug.cgi?id=25903

        Implement a default UI for chromium.  Add a style sheet for Chromium
        media controls with good defaults and implemented basic draw functions
        for play/pause & mute buttons.

        * css/mediaControlsChromium.css: Added.
        * rendering/RenderThemeChromiumLinux.cpp:
        (WebCore::RenderThemeChromiumWin::extraMediaControlsStyleSheet): Export
        our custom media controls style sheet.
        (WebCore::RenderThemeChromiumLinux::paintMediaButtonInternal): Paint
        buttons respecting chromium media controls color scheme.
        (WebCore::RenderThemeChromiumLinux::paintMediaPlayButton): Paint logic
        specific to play/pause button.
        (WebCore::RenderThemeChromiumLinux::paintMediaMuteButton): Paint
        specific to mute button.
        * rendering/RenderThemeChromiumLinux.h: Appropriate header changes.
        * rendering/RenderThemeChromiumWin.cpp:
        (WebCore::RenderThemeChromiumWin::extraMediaControlsStyleSheet): Export
        our custom media controls style sheet.
        (WebCore::RenderThemeChromiumWin::paintMediaButtonInternal): Paint
        buttons respecting chromium media controls color scheme.
        (WebCore::RenderThemeChromiumWin::paintMediaPlayButton): Paint logic
        specific to play/pause button.
        (WebCore::RenderThemeChromiumWin::paintMediaMuteButton): Paint specific
        to mute button.
        (WebCore::RenderThemeChromiumWin::setDefaultFontSize): Appropriate
        header changes.
